Tue Dec 15 18:18:11 2009  Lee Noar  <leenoar@sky.com>

	* gcccompat/galloca.c: Bug 174 Fix. If GCC determines
	that a call to __gcc_alloca can never be reached, it will
	optimise it away. However, __gcc_alloca_restore is still
	called and crashes because a block was never allocated.
	Fix by exiting if a chunk isn't found.

Thu Nov 26 10:13:45 PST 2009  Peter Naulls  <peter@chocky.org>

	* time/ctime.c, time/stdtime.c, time/asctime.c, include/time.h,
	  incl-local/time.h: Add asctime_r, ctime_r.

Sat Nov 14 10:30:39 PST 2009  Peter Naulls  <peter@chocky.org>

	* string/_strlen.s: Alignment access fix from Adrian
          Lees (Bug #173).

Wed Oct 21 17:46:48 2009  Lee Noar  <leenoar@sky.com>

	* incl-local/internal/unix.h(struct __process): Add
	2 new flags to record how this process was created.
	* sys/exec.c(execve): Set flag to show that this
	process was the result of exec().
	* sys/vfork.c(__fork_post): Set flag to show that this
	process was the result of fork().
	* unix/unix.c(_exit): Be more careful about when we
	deregister the client from the Shared Object Manager.
	A process that was forked (but not execed) is
	considered to be the same client as its parent. It
	should not be deregistered on exit, so that control can
	be successfully returned to the parent.
	A process that was execed (even if forked) is a new client
	in its own right and distinct from its parent and should
	be deregistered on exit.
	A process with no parent should always be deregistered.

Sat Sep 19 12:41:12 2009  Lee Noar  <leenoar@sky.com>

	* gmon/gmon_start.c: Don't use _init symbol to find the
	start of the text segment as this creates a bogus
	DT_INIT entry in the dynamic segment. Instead use the
	linker generated __text_start.

Mon Aug 24 10:41:22 PDT 2009  Peter Naulls  <peter@chocky.org>

	* signal/post.c: Skip over # at start of C++ symbol names
        for demangling.
	* sys/_syslib.s: Typo fix.
	* pthread/_yield.s: Register handling safety from John Tytgat.
        * debug/dvsprintf.c: Use stdio for __os_printf after stdio
        is initialised, otherwise Wimp debugging can become very
        difficult.

Thu Aug 20 00:44:36 CEST 2009  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/pthread.h(__pthread_saved_context): don't define fpregs
	and fpstatus in softfloat builds.

Sun Aug 16 12:58:06 PDT 2009   Peter Naulls  <peter@chocky.org>

	* sys/mman.c: Simplistic mmap file handling. Only supports reading
        from a zero offset, but this covers much of its use.

Sun Aug  9 01:15:13 CEST 2009  John Tytgat  <John.Tytgat@aaug.net>

	* netlib/getnameinfo.c: Removed, we have another implementation in
	netlib/getaddrinfo.c.

Sun Aug  2 07:44:06 PDT 2009  Peter Naulls  <peter@chocky.org>

	* sys/errlist.c: Add entry for EOVERFLOW.
	* libm-dbl64/s_finite.c, libm-dbl64/s_isinf.c, libm-dbl64/s_isnan.c,
          libm-flt32/s_isinff.c, libm-flt32/s_finitef.c libm-flt32/s_isnanf.c:
	Remove hidden_def, since it seems to serve no purpose, and 
        causes linking errors.

Fri Jul 31 14:20:29 PDT 2009  Peter Naulls  <peter@chocky.org>

	* include/errno.h: Add EOVERFLOW.  Not used by UnixLib,
          but sometimes returned by library routines.

Thu Jul 16 17:29:12 2009  Lee Noar  <leenoar@sky.com>

	* Generally:
	Implement very simple profiling. Only function call
	counting is supported, there is no timing. Only really
	effective on statically linked code. Some of this
	code is imported and adapted from glibc.

	* Specifically:
	* include/sys/gmon.h: New file. Standard header for
	profiling support.
	* include/sys/gmon_out.h: Likewise.
	* gmon/gmon.c: New file. Support routines for profiling.
	* gmon/prof-freq.c: New file. Stub implementation of
	__profile_frequency().
	* gmon/mcount.c: New file. Simple mcount implementation
	that counts function calls and records their relationships.
	* gmon/gmon-start.c: New file. Code called at program startup
	to start profiling. Also registers function with atexit to
	write results to file.
	* incl-local/internal/machine-gmon.h: New file. mcount
	machine code stub that saves any registers that real mcount
	code would otherwise corrupt.
	* incl-local/internal/unix.h(ul_global): Add word to record
	flags passed by (g)crt1-riscos.o.
	* incl-local/internal/asm_dec.s: Add constant for above.
	* incl-local/sys/cdefs.h: Define some of the symbol attribute
	macros.
	* sys/_syslib.s(__main): Call __gmon_start__ if profiling is
	enabled.

Fri Jul 03 19:42:48 2009  Lee Noar  <leenoar@sky.com>

	* sys/exec.c(execve): Only deregister the client from the
	Shared Object Manager if we are not the parent of another
	process. If the client is a parent, then it must remain
	registered so that the child can return.
	Also don't bother about accessing global variables after
	deregistering. Examination of the compiled code shows that
	despite attempts to ensure that this doesn't happen, the
	compiler still generates accesses to global variables after
	deregistering without any ill effects. In fact, there should
	be no ill effects as the PIC register and R/W data segment are
	still valid and are not under the control of the Shared
	Object Manager.

Mon Jun 22 19:23:05 2009  Lee Noar  <leenoar@sky.com>

	* gcccompat/_eh_support.s: Add PIC instructions.
	* gcccompat/_b_return.s: Likewise.

Sun Jun 14 14:46:12 2009  Lee Noar  <leenoar@sky.com>

	* gcccompat/_eh_support.s:
	* (__ehs_stack_limit): New function.
	Given a stack pointer (which will not be the current one),
	determine which stack chunk contains it and return the stack
	limit for that chunk. Used by uw_install_context() in
	unwind-dw2.c (call frame exception handling). The stack
	unwinder steps through the call frames looking for either
	cleanup handlers or exception handlers. The context is installed
	once one of these is found, however, the frame that is jumped
	to may be within a different stack chunk so we have to restore
	the stack limit for that chunk.
	* (__ehs_trim_stack): New function.
	Wrapper for __trim_stack to preserve any registers that it may
	use/corrupt. If the stack unwinder unwinds down the call frames
	to a different stack chunk, then there will be one or more
	redundant chunks that need to be freed.

Sun Jun 7 11:10:43 2009  Lee Noar  <leenoar@sky.com>

	* General overview:
	The call frame C++ exception handling code creates a table of
	call frames that relate to the frames on the stack. This table
	allows the stack unwinder to maintain a context that stores
	the locations of all registers stored by the current function
	on entry.
	The return address of a function is used as a key to allow the
	stack unwinder to find its particular entry in the table. If the
	wrong return address is used, then exception handling will fail
	usually with a crash in the personality routine. The personality
	routine (for C++ at least) attempts to write to r0 and r1 in the
	stack frame. These registers aren't usually saved on function
	entry, only a few exception handling functions actually save
	these registers.
	Wesnoth is an example of where these crashes have been observed.

	* Specifically:
	* gcccompat/_b_frame.s(__builtin_frame_address): I have found
	that __builtin_frame_address can return the wrong result under
	certain circumstances, e.g., when the requested fp is not within
	the current stack chunk. This causes __builtin_return_address to
	give the wrong return address and crashes in C++ exception
	handling as detailed above. The problem seems to be that the
	behaviour of the SCL is slightly different to UnixLib when the
	stack is extended. UnixLib creates a new chunk and starts using
	that as the stack, but the comment in the code suggests that SCL
	copies a frame as well. I believe that this makes the chain of
	frames slightly different for UnixLib and SCL. These changes
	simplify the UnixLib code to match the stack extension code, but
	leave the SCL code as is, as I have no reason to believe that it
	is wrong in this case.
	* gcccompat/_b_return.s(__builtin_return_address): UnixLib code
	attempts to load the return address from the stack chunk which is
	addressed by a2. However, at this point, a2 will either contain a
	frame address or have been corrupted by the call to
	__gcc_alloca_return_address() leading to crashes in exception
	handling as detailed above.
	Set a2 to contain the address of the current stack chunk. Note
	that using the chunk that actually contains the requested fp
	doesn't work as far as exception handling is concerned.
	* gcccompat/_eh_support.s(__ehs_return_address): New file, new
	function. The context maintained by the exception handling code,
	as detailed above, is initialised from the call frame table using
	a return address obtained via __builtin_return_address(). This
	correctly handles the case whereby the return address may be
	__free_stack_chunk or __gcc_alloca_free. However, further updates
	to the context by the stack unwinder retrieve the return address
	directly from the stack. If the return address happens to be one
	of these functions, then exception handling will fail.
	__ehs_return_address() does a similar job to
	__builtin_return_address() in that it traps these special functions
	and returns the correct result. It differs in that we already know
	the frame address (which will not be the current one) and are able
	to pass it as an argument.

Wed May 27 20:31:18 PDT 2009  Peter Naulls  <peter@chocky.org>

	* sys/byteorder.h: Fix bogus include.  Seems to have been wrong
	for a long time.

Sat May 23 15:29:42 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* unix/getenv.c(__last_environ): Removed, is now
	__ul_global.last_environ.
	* incl-local/internal/unix.h(struct ul_global): Replaced __notused5
	by last_environ field, always have a main function pointer.
	(_main): Removed prototype, no longer exists.
	* unix/setenv.c(unsetenv): Micro optimisation.
	(clearenv): Make use of last_environ from __ul_global.
	* unix/putenv.c(__addenv_to_env): Likewise.
	* unix/unix.c(_main, main prototype): Remove, equivalent code got
	added to __main.
	* incl-local/internal/asm_dec.s(PROC_ARGC,PROC_ARGV): Added.
	(GBL_*): Fixes up some recently allocated entries.
	(GBL_LASTENVIRON): Added.
	* sys/_syslib.s(__main): Instead of calling _main, call user
	supplied main routine directly.
	(main): Have it always defined.
	* vscript(__last_environ): Removed.
	* local/ctypetable.c(__build_ctype_tables): Fix comment.
	* test/env/testenv.c: Dump environ.

Thu May 21 18:58:32 2009  Lee Noar  <leenoar@sky.com>

	* sys/exec.c(execve): Deregister the current client from the
	Shared Object Manager before passing control to the new
	process. Fix for bug 171.

Mon May 11 23:31:29 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* include/bits/posix_opt.h(_POSIX_TIMEOUTS): Disabled as we don't
	have pthread_mutex_timedlock.

Sat Mar 28 14:36:21 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* include/kernel.h: Constify _kernel_osfind name parameter;
	'unsigned' -> 'unsigned int'.
	* scl/_kosfind.s: Update comments.
	* sys/mman.c: White space change.

Sat Mar 28 11:30:10 2009  Lee Noar  <leenoar@sky.com>

	* signal/_signal.s(__h_error): Make sure a valid signal number
	is passed to __unixlib_raise_signal() when __SOFTFP__ is defined.
	Previously, for example, instead of seeing a branch through zero
	error, you would get a recursive signal because the signal handler
	itself would cause a memory violation due to a2 containing a
	pointer instead of an array index.

Sun Jan 18 19:45:02 2009  Lee Noar  <leenoar@sky.com>

	* incl-local/internal/unix.h(__funcall): In the shared library,
	function addresses can and will exist outside application space,
	so don't test against appspace_himem.
	* unixlib/buildoptions.h: Remove comment.

Sun Jan 18 16:57:12 2009  Lee Noar  <leenoar@sky.com>

	* Generally:
	Implement lstat so that symlinks can be probed. Fix for
	bug(feature request) #162 item 1.

	stat() - Always follow symlinks and return info on target object.
	lstat() - Do not follow symlinks, and return info on given
	object even if symlink. As per Linux, if a symlink is lstat()ed,
	S_IFLNK = TRUE, S_IFREG = FALSE.

	* Specifically:
	* unix/custom.c: Add __customlstat().
	* unix/lstat.c(lstat,lstat64): Call new implementation instead
	of stat().
	* unix/dev.c: Add __fslstat() and ensure all devices have a
	suitable lstat entry.
	* common/objattr.c(__object_get_lattrs): New function similar
	to __object_get_attrs() except symlinks are not followed. Allows
	the file info of the symlink itself to be found.
	* common/symlinks.c: Move macro definitions of constants...
	* incl-local/internal/symlinks.h: ...to here.
	* incl-local/internal/local.h: Add declaration of
	__object_get_lattrs().
	* incl-local/internal/dev.h: Add lstat entry to struct dev.
	Add declarations for __fslstat() and __customlstat().
	* incl-local/internal/unix.h: Instead of declaring
	__resolve_symlinks() directly, include symlinks.h.

Sat Jan 17 20:10:49 2009  Lee Noar  <leenoar@sky.com>

	* common/objattr.c(__object_set_attrs): Fix typo that would lead
	to a memory leak.

Sat Jan 17 18:22:26 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* unix/unix.c(convert_command_line): Reverting r1904 change
	(Fri Mar 10 21:25:47 2006) and canonicalise using Run$Path; When
	result of canonicalisation is non-existing, use given argv[0] as
	input for unixify; Made	common fatal exit point; void return instead
	of unused int return.

Sat Jan 17 15:53:04 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* include/kernel.h: Add 'int' to 'unsigned'.
	* README(Building): Updated.

Fri Jan 16 02:53:30 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	*  unix/features.c(__get_program_name): A colum character can mark the
	start of a leafname as well.  Solves Bugzilla #169 (reported by John
	Kortink).

Sat Jan  3 21:03:34 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* ChangeLog: Updated John-Mark Bell's e-mail address.

Fri Jan  2 03:23:07 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* module/sul.s: Update module title with "(debug)" string when
	DEBUG_PROC_MATCHING has been defined.

-----------------------------------------------------------------------
[ UnixLib v5.0 ]

Fri Jan  2 03:09:47 CET 2009  John Tytgat  <John.Tytgat@aaug.net>

	* stdlib/msort.c: Fixed wrong __mempcpy emulation (when result gets
	written back to first __mempcpy argument).

Tue Dec 23 02:25:46 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* test/env/testenv.c: Added test for inheritance of environment
	variables from parent to child process and when changes from
	Unix environment variables need to result in updated RISC OS
	system variables.  Based on a test program written and posted
	in ML by Peter Naulls.

Sat Dec 20 14:34:20 CET 2008  Theo Markettos <theo@markettos.org.uk>

	* grp/getgrouplist.c(getgrouplist): Added.
	* test/grp/getgrouplist.c,test/grp/test.group: Added test application
	for getgrouplist code.
	* include/grp.h(getgrouplist): Added prototype.

Thu Dec 18 22:57:28 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* unix/syslog.c(vsyslog): More sensible mapping between Unix and
	RISC OS syslog priorities.

Thu Dec 18 22:23:52 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* stdlib/msort.c: Copy from glibc 2.9 which has a much better qsort
	implementation.  Number of compares done in testsort2.c dropped from
	1849086/1534480/834012928/627343953 to 1536347/815024/853904/1209216.
	* stdlib/memcopy.h: Added, also from glibc 2.9.
	* stdlib/qsort.c: Removed.
	* test/stdlib/testsort2.c: Added.

Mon Dec 15 05:08:52 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* unix/features.c(features): Implement coredump feature.
	* signal/post.c(__write_backtrace): Mark as pthread unsafe.
	(post_signal): Move FPE reg dump code to __write_backtrace; call
	__unixlib_write_coredump when action is 'core'.
	* include/unixlib/local.h(__unixlib_write_coredump,__write_backtrack):
	Make public.
	* vscript(__backtrace_getfp): Remove, this routine no longer exists.
	* README: Document 'coredump' feature.
	* incl-local/internal/sigstate.h(__init_coredump): Add prototype.
	* incl-local/internal/swiparams.h(OSFILE_SAVEBLOCK_LOADNEXEC,
	OSFILE_SAVEBLOCK_FILETYPE): Define.
	* sys/_os.s(__os_file): Don't change a3 when it was 0 on entry.
	* sys/mman.c(__init_coredump): Define coredump directory.
	(__unixlib_write_coredump): Write coredump files (application space
	and all DAs).

Tue Dec  2 02:36:59 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* test/pthread/fork.c(__UNIXLIB_INTERNALS): Remove usage as it is no
	longer needed.
	* include/complex.h: Likewise.
	* include/features.h: Likewise.
	* include/math.h: Likewise.
	* include/sys/cdefs.h: Likewise.
	* incl-local/internal/fd.h: Likewise.
	* incl-local/internal/os.h: Likewise.
	* incl-local/internal/unix.h: Likewise.
	* incl-local/internal/swiparams.h: Likewise.
	* gen-auto.pl(AM_CFLAGS): Remove __UNIXLIB_INTERNALS definition and
	add __GNU_LIBRARY__ and __NO_LONG_DOUBLE_MATH definitions.

Fri Oct 24 02:07:18 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* string/strdup.c(strdup): renamed strdup to __strdup and
	provided weak alias strdup instead.

Mon Oct 13 02:34:22 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* pthread/_exit.s(__pthread_exit): Simplify code.

Mon Oct 13 02:19:00 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* gen-auto.pl: Fix typo.

Tue Sep  9 19:29:39 PDT 2008  Peter Naulls  <peter@chocky.org>

	* pthread/cond.c(pthread_cond_timedwait): Fix divisor.
	Timeout is in centiseconds, not milliseconds.

Tue Sep  9 20:49:05 2008  Lee Noar  <leenoar@sky.com>

	* signal/post.c(sigsetup): Don't use the address range of the
	application to validate the location of the signal handler when
	compiling for the shared library.

Thu Aug 28 20:27:45 2008  Lee Noar  <leenoar@sky.com>

	* pthread/_yields.s(pthread_yield): The current implementation
	uses a single STMDB instruction to store all relevant registers
	to __cbreg including two banked registers. Under certain
	circumstances, this can trigger a bug in revision K StrongARM
	CPUs whereby the banked register r14 is not saved. To overcome
	the bug, split the instruction into two STMs so that the banked
	registers are saved independently of the others.

Mon Aug 11 20:38:14 2008  Lee Noar  <leenoar@sky.com>

	* signal/_signal.s(__h_cback): Make sure __pthread_callback
	is called with r7 containing the UnixLib GOT pointer as it
	expects.

Wed Aug  6 20:34:09 2008  Lee Noar  <leenoar@sky.com>

	* pthread/cancel.c: Add dummy function that is never called or
	referenced. Its only purpose is to ensure that several pthread
	functions that are made weak in libstdc++ are pulled in by the
	static linker which otherwise would resolve to NULL. This only
	effects statically linked C++ binaries.

Sun Jul  6 17:12:39 PDT 2008  Peter Naulls  <peter@chocky.org>

	* common/riscosify.c: Add defines for a cut-down version of
	__riscosify for the benefit libdl, which only needs to handle a single 
	case.  This doesn't change the behaviour of the code for UnixLib or
	SCL.

Fri Jun 13 01:33:48 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* include/bits/netdb.h(_sclose,_sread,_swrite,_sioctl): Move internal
	swi veneers to...
	* incl-local/bits/netdb.h: ...here.
	* include/sys/stat.h(__stat): Move to...
	* incl-local/sys/stat.h: ...here.
	* include/sys/select.h(_select): Move to...
	* incl-local/sys/select.h: ...here.
	* include/sys/cdefs.h(_strong_alias,weak_function,weak_const_function,
	weak_alias,_weak_alias,hidden_def,libm_hidden_def,INTDEF,
	internal_function): Move to...
	* incl-local/sys/cdefs.h: ...here.
	* include/sys/debug.h: Moved file to...
	* incl-local/sys/debug.h: ...here.
	(debug_printf): Added printf attribute for better type checking.
	* include/sys/socket.h(_socket,_bind,_listen,_accept,_connect,_recv,
	_recvfrom,_recvmsg,_send,_sendto,_sendmsg,_shutdown,_setsockopt,
	_getsockopt,_getsockname,_getpeername,__opensock): Move to...
	* incl-local/sys/socket.h: ...here.
	Upgraded to glibc 2.7 version.
	* string/strchr.c(index): Make index strong alias of strchr.
	* string/strrchr.c(rindex): Make rindex strong alias of strrchr.
	* string/index.c(index,rindex): Removed.
	* string/stricmp.c(strcasecmp): Make strcasecmp strong alias of
	stricmp.
	* string/strnicmp.c(strncasecmp): Make strncasecmp strong alias of
	strnicmp.
	* string/memcmp.c(bcmp): Make bcmp strong alias of memcmp.
	* string/memrchr.c: Go for original glibc 2.7 version.
	* string/strchrnul.c: Likewise.

Fri May 16 01:43:59 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* common/symlinks.c(__resolve_symlinks): avoid writing to NULL.

Tue May 13 21:07:51 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* unix/dev.c(__fsopen): Call __riscosify only once as the result of
	__resolve_symlinks is guaranteed to be already a RISC OS filename.
	* common/symlinks.c(__resolve_symlinks): avoid malloc/free sequence
	unless it is really necessary and reuse previously claimed buffer when
	possible; Made code a little bit more compact; Added comments.

Thu May  1 20:08:23 PDT 2008  Peter Naulls  <peter@chocky.org>

	* pthread/lock.c: Fix logic from earlier tidy.

Wed Apr 23 22:23:03 PDT 2008  Peter Naulls  <peter@chocky.org>

	* unix/custom.c, include/unixlib/local.h: New function to 
	  allow opaque setting of custom select() function.

Sun Apr  6 01:47:47 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* include/pthread.h(struct __pthread_thread,
	__pthread_running_thread): Move to...
	* incl-local/pthread.h: ...here.
	* string/strsignal.c: Added include pthread.h.

Sat Apr  5 22:01:57 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/fopen.c(fopen): Added comment.
	* unix/dev.c(__fsopen): When opening a directory, make sure we're
	using the original filename and not the riscosified one.  Solves
	bug #163 logged by Duncan Moore <duncan.m00re@btinternet.com>.

Sat Apr  5 17:58:01 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* time/_clock.s: Use NAME/DECLARE_FUNCTION macros.
	* string/_strcpy.s: Likewise.
	* string/_memcpy.s: Likewise.
	* string/_strlen.s: Likewise.
	* string/_memset.s: Likewise.

Sat Apr  5 17:07:58 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* include/features.h: Move UnixLib internal definitions to...
	* incl-local/features.h: ...here.
	* include/dirent.h,incl-local/dirent.h: Likewise.
	* include/time.h,incl-local/time.h: Likewise.
	* include/locale.h,incl-local/locale.h: Likewise.
	* include/setjmp.h,incl-local/setjmp.h: Likewise.
	* include/pwd.h,incl-local/pwd.h: Likewise.
	* include/stdlib.h,incl-local/stdlib.h: Likewise.
	* include/stdio.h,incl-local/stdio.h: Likewise.
	* include/pthread.h,incl-local/pthread.h: Likewise.
	* include/grp.h,incl-local/grp.h: Likewise.
	* include/unistd.h,incl-local/unistd.h: Likewise.
	* include/signal.h,incl-local/signal.h: Likewise.
	* include/errno.h,incl-local/errno.h: Likewise.
	* incl-local/internal/unix.h( __addenv_to_os): Add prototype.

Wed Apr  2 00:36:38 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* common/riscosify.c(riscosify): Avoid discname when specified gets
	changed and when no discname is specified, make sure we output a '$'.
	* test/filename/testriscosify.c: Added new cases.

Tue Apr  1 00:23:32 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* include/unixlib/asm_dec.s: Moved to...
	* incl-local/internal/asm_dec.s: ...here.
	* include/unixlib/dev.h: Moved to...
	* incl-local/internal/dev.h: ...here.
	* include/unixlib/fd.h: Moved to...
	* incl-local/internal/fd.h: ...here.
	* include/unixlib/os.h: Moved to...
	* incl-local/internal/os.h: ...here.
	* include/unixlib/types.h: Moved to...
	* incl-local/internal/types.h: ...here.
	* include/unixlib/unix.h: Moved to...
	* incl-local/internal/unix.h: ...here.
	* include/unixlib/local.h: Moved __UNIXLIB_INTERNALS marked
	declarations to...
	* incl-local/internal/local.h: ...here.
	* Updated lots and lots of c/h/s files to follow above changes.

Sun Mar 30 15:59:15 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* unix/dev.c: Added a bit more debug info and did some
	microoptimisation.
	* unix/tty.c(__ttyicanon): 0 -> NULL
	* debug/debug.c(__debug): Added a bit more debug info.

Sun Mar 30 15:33:22 CEST 2008  John Tytgat  <John.Tytgat@aaug.net>

	* test/process-redirect/{child.c,Makefile,parent.c,RunTestQueue,feb}:
	Added test suite used to test the recent redirection/pipe/dup fixes.

Sat Mar 29 18:48:49 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* unix/fcntl.c(fcntl): Case F_DUPFD needs file descriptors to be
	copied too otherwise we would be closing OS_ChangeRedirection acquired
	RISC OS handles (FILE_HANDLE_FROM_OS).  And FILE_ISDIR bit also needs
	to be copied.
	* include/unixlib/unix.h(struct ul_global): Renamed __unused1,
	__unused4 and __unused2 to rewindpipeoffset, changeredir0 and
	changeredir1.
	* sys/_syslib.s: Likewise.
	* sys/vfork.c(__fork_pre): initialise rewindpipeoffset, changeredir0
	and changeredir1; (__fork_post): restore read pipe file offset and
	RISC OS redirection.
	* sys/exec.c(execve): when in a fork context set RISC OS redirection
	based on file descriptors 0 and 1 when those are real files or a pipe.
	Also record the read pipe offset for file descriptor 1 as
	rewindpipeoffset and move file offset to the end. Any non-UL process
	(e.g. libscl, OS command) can now read/write data using file handles
	managed by parent.

Thu Mar 27 02:24:59 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* vscript(_Exit,__exit,__exit_no_code,__exit_with_error_block):
	Deleted (_Exit is a valid C99 symbol and the others were not defined)

Fri Mar 21 19:37:54 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* include/time.h(__tz): Remove declaration.
	* time/tzset.c(tzset): One maximum byte less copied.
	(__tz): Moved to...
	* time/calendconv.c: ...here.
	(__calendar_convert): Use static __tz data when parameter tz is NULL.
	* time/localtime.c(localtime): Use tz = NULL for __calendar_convert;
	call tzset() to initialise timezone and daylight.
	* time/localtime_r.c(localtime_r): Call tzset() to initialise timezone
	and daylight.
	* time/gmtime.c(gmtime): Use tz = NULL for __calendar_convert.
	* time/asctime.c(asctime): One byte trimming.
	* time/gettod.c(gettimeofday): Simplified code for tz != NULL.
	* time/mktime.c(mktime): calculated tm_wday and tm_yday fields were
	one off.
	* time/clk_gettime.c(clock_gettime): case CLOCK_REALTIME: use uint64_t
	based calculation which now gives correct result; case
	CLOCK_MONOTONIC: calculated tv_nsec field was 100 times too big.

Fri Mar 21 13:26:13 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* serial/common.c(__get_file_ino): combining directory and filename
	should be done with a Unix directory separator, not RISC OS one;
	some variable shuffling resulting in dropping a nasty cast.

Fri Mar 21 05:34:43 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* stdio/printf.c: Cosmetic reformat.
	* stdio/asprintf.c: Likewise.
	* include/stdio.h(clearerr_unlocked): Declare.
	* stdio/clearerr.c(clearerr_unlocked): Implement as alias to clearerr.
	* include/dirent.h(DIR): Add fd entry.
	(dirfd): Declare.
	* unix/dirfd.c(dirfd): Implemention based on lazy fd allocation.
	* unix/dirent.c(newstream): Initialize fd to -1.
	(closedir): close fd when allocated.

Mon Mar 17 03:31:08 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/stdio_ext.h: Moved to...
	* include/stdio_ext.h: ...here and changed contents with a glibc
	version with everything disabled except the __fpurge prototype.

Thu Feb 28 00:58:23 CET 2008  John Tytgat  <John.Tytgat@aaug.net>

	* README: Added comment on Wimp_StartTask usage in threaded programs.
	Updated description on build options.

Sat Feb 16 07:05:37 PST 2008  Peter Naulls  <peter@chocky.org>

	* include/stdio.h, stdio/putc.c: Change putc_unlocked to a
	declaration. This works better with some code that gets confused when
	it's a #define.
	* unix/setenv.c, unix/putenv.c: Make putenv works as advertised for
	setenv when handling RISC OS native variables as documented in the
	README.

Tue Jan 29 22:46:43 PST 2008  Peter Naulls  <peter@chocky.org>

	* unix/statfs.c, include/sys/vfs.h, include/statfs.h: Dummy
	statfs implementation.

Sun Jan 27 19:29:25 PST 2008  Peter Naulls  <peter@chocky.org>	

	* stdio/fpurge.c, include/stdio.h: Added hopefully correct fpurge
	implementation.

Mon Dec 31 17:10:15 2007  Lee Noar  <leenoar@sky.com>

	* sys/_syslib.s: Force word alignment of bss area. If we don't and
	a bss section whose size is not a multiple of 4 is merged before this one,
	then it will be misaligned.
	* sys/_vfork.s: Likewise.

Thu Dec 27 04:47:04 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* sys/_jmp.s (setjmp): Previous change introduced wrong GOT handling
	for shared library support.

Sun Dec 23 17:36:16 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* string/basename.c: Added version from glibc 2.7.
	* include/string.h (basename): Added prototype.

Sat Dec  1 05:51:17 CET 2007  Peter Naulls  <peter@chocky.org>

	* unix/unix.c: Fixed typo.

Sun Nov 25 11:36:06 PST 2007  Peter Naulls  <peter@chocky.org>

	* include/swis.h: Massive number of missing SWIs. Thanks to Rob F. Johnson.
	* unix/stat.c: Add missing stat64 function - just call stat.

Sun Nov 18 02:40:16 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* debug/dvsprintf.c: Synced with the latest Linux version.
	* stdio/freopen.c, stdio/newstream.c, stdio/flsbuf.c, stdio/fwrite.c,
	stdio/fopen.c, stdio/fpos.c, stdio/fclose.c, stdio/popen.c,
	unix/open.c, unix/close.c, unix/stat.c, unix/features.c,
	unix/select.c, unix/unix.c, unix/dirent.c, unix/dev.c,
	unix/putenv.c, unix/getenv.c, unix/write.c, pthread/create.c,
	pthread/exit.c, pthread/pthinit.c, pthread/newnode.c,
	pthread/context.c, signal/sleep.c, signal/sigprocmsk.c,
	signal/sigsuspend.c, signal/post.c, common/riscosify.c,
	common/funcallerr.c, sys/brk.c, sys/stackalloc.c, sys/exec.c,
	sys/execvp.c: Make use of debug_printf.

Sat Nov 10 18:06:26 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* common/riscosify.c: Use GNU code style
	(__sfixfind): Changed while() into for()
	(riscosify): Do the test on non-__RISCOSIFY_MASK bits only when
	configured for __UNIXLIB_PARANOID and use assert() for this.

Thu Oct 25 16:49:23 2007  Lee Noar  <leenoar@sky.com>

	* gcccompat/_b_return.s: Poke function name to aid debugging.
	* gcccompat/_galloca.s: Likewise.
	* gcccompat/_b_frame.s: Likewise.
	* sys/_syslib.s: In the DSO, call Dynamic Loader function
	_dl_call_ctors() to call all shared library _init functions.

Tue Oct 16 01:55:08 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* module/sul.s(sul_exec): finetune previous change by canonicalising
	given exec parameter using Run$Path and verifying if result is an
	existing file.  If not, fall back on original given parameter.

Sat Oct  6 22:24:36 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	Due to the large number of files where following changes were made, we
	won't mention them all explicitly.
	* __set_errno: use it more consistently to set errno value and return
	-1.
	* __ul_seterr: likewise.
	* IGNORE(): removed.
	* Include unixlib/unix.h to get access to private UnixLib variables.
	* Reduction of the export of private variables by referencing them
	via __ul_global.
	* Updated comments.
	* dsp_exit: renamed to __dsp_exit.
	* scl/_ksetenv.s(_kernel_setenv): declare as function.
	* scl/_kswi_c.s(_kernel_swi_c): likewise.
	* scl/_kernel.s(_kernel_swi): likewise.
	* scl/_kosbyte.s(_kernel_osbyte): likewise.
	* scl/_koscli.s(_kernel_oscli): likewise.
	* scl/_kosbput.s(_kernel_osbput): likewise; call __ul_set_err in case
	of a RISC OS error.
	* scl/_kosgbpb.s(_kernel_osgbpb): likewise.
	* scl/_kosfile.s(_kernel_osfile): likewise.
	* scl/_kosfind.s(_kernel_osfind): likewise.
	* scl/_kosrdch.s(_kernel_osrdch): likewise.
	* scl/_kosbget.s(_kernel_osbget): likewise.
	* scl/_kgetenv.s(_kernel_getenv): likewise.
	* scl/_kosargs.s(_kernel_osargs): likewise.
	* scl/_kcurskch.s(_kernel_current_stack_chunk): likewise.
	* include/assert.h(assert): removed noreturn attribute.
	* module/sul.s(DEBUG_PROC_MATCHING): added debug output during
	sul_exec and sul_fork;
	(PROC_FORK_STORAGE): reserved 10*4 + 4*12 instead of 11*4 + 4*12
	bytes.
	(swi_handler): turned into branch table.
	(swi_value): reduced the number of different registers used.
	(swi_count): likewise.
	(sul_wimpslot): likewise.
	(swi_initialise): strip off the FS of OS_GetEnv argv[0] as well the
	executable given to sul_exec().
	(sul_fork): FP register f4-f7 were not restored.
	(sul_exec): canonicalise exec filename so that we can inherit process
	structures more reliably at swi_initialise; FP registers f4-f7 were
	wrongly restored when returning to a parent process.
	* common/_taskhandle.s(__get_task_handle): used to request taskhandle
	from OS and result is stored as __ul_global.taskhandle.
	* sys/_syslib.s:
	Removed X bit from SWI calls made before setting up our UnixLib OS
	environment handlers so that an error will call the default error
	handler automatically.
	(__get_cpu_arch): wasn't called when ___dynamic_no_da was set.
	(__unixlib_get_fpstatus): prefix with function name.
	(__unixlib_set_fpstatus): likewise.
	(__valid_address): likewise.
	(__unixlib_cli): dropped and its contents is now __ul_global.cli.
	(__time): dropped and its contents is now __ul_global.time.
	(__notused1):): dropped and its contents is now __ul_global.unused1.
	(__taskwindow): dropped and its contents is now
	__ul_global.taskwindow.
	(__taskhandle): dropped and its contents is now
	__ul_global.taskhandle.
	(__dynamic_num): dropped and its contents is now
	__ul_global.dynamic_num.
	(__old_u): dropped and its contents is now __ul_global.unused4.
	(__32bit): removed, this can easily and cheaply found out at run-time.
	(__panic_mode): dropped and its contents is now
	__ul_global.panic_mode.
	(__proc): dropped and its contents is now __ul_global.sulproc.
	(__ul_pagesize): dropped and its contents is now
	__ul_global.pagesize.
	(__upcall_handler_addr): dropped and its contents is now
	__ul_global.upcall_handler_addr.
	(__upcall_handler_r12): dropped and its contents is now
	__ul_global.upcall_handler_r12.
	(__pthread_return_address): dropped and its contents is now
	__ul_global.pthread_return_address.
	(__pthread_worksemaphore): dropped and its contents is now
	__ul_global.pthread_worksemaphore.
	(__pthread_system_running): dropped and its contents is now
	__ul_global.pthread_system_running.
	(__pthread_callback_semaphore): dropped and its contents is now
	__ul_global.pthread_callback_semaphore.
	(__pthread_callback_missed): dropped and its contents is now
	__ul_global.pthread_callback_missed.
	(__pthread_num_running_threads): dropped and its contents is now
	__ul_global.pthread_num_running_threads.
	(__executing_signalhandler): dropped and its contents is now
	__ul_global.executing_signalhandler.
	(__signalhandler_sl): dropped and its contents is now
	__ul_global.signalhandler_sl.
	(__signalhandler_sp): dropped and its contents is now
	__ul_global.signalhandler_sp.
	(__escape_disabled): dropped and its contents is now
	__ul_global.escape_disabled.

Sat Oct  6 17:32:59 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* sys/_vfork.s (fork,vfork): Prevent register corruption v4 and v5.

Sun Sep  2 02:19:59 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* gcccompat/_b_return.s: Made code usable for libscl.
	* gcccompat/_galloca.s: Likewise.
	* gcccompat/galloca.c: Likewise.
	(__gcc_alloca_return_address): strip off the PC flags of return value
	when running in 26-bit mode.
	* gcccompat/_b_frame.s: Likewise.

Thu Aug 30 01:36:41 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* gen-auto.pl(sul): Reverted previous (unwanted and undocumented)
	change as it required libscl to be present; use STRIP iso OBJCOPY
	to extract binary blob out of ELF file which has the advantage that
	this is already defined in GCC build system.

Fri Aug 24 01:38:30 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* stdlib/system.c(system): whitespace changes; use EXIT_FAILURE for
	_exit.
	* common/objattr.c: Whitespace changes.
	* common/symlinks.c: Likewise.
	* common/exist.c: Likewise.
	* sys/_syslib.s: Likewise.
	* unix/dev.c: Likewise.
	* unix/unix.c: Likewise.
	* stdlib/qsort.c(__UNIXLIB_PARANOID): use non-0 testing iso a strict
	positive test.
	* unix/dev.c(__UNIXLIB_SYMLINKS): Likewise.
	* common/objattr.c(__UNIXLIB_SYMLINKS): Likewise.
	* common/exist.c(__UNIXLIB_SYMLINKS): Likewise.
	* include/unixlib/unix.h(__UNIXLIB_PARANOID,__UNIXLIB_SYMLINKS):
	Likewise.
	* unix/getenv.c(__getenv_from_os): Updated comment on its API.
	* scl/_kcurskch.s(_kernel_current_stack_chunk): _kernel_chunk_stack
	was wrongly located and always returned NULL.
	* test/scl/test-kernel_current_stack_chunk.c: Added.
	* include/unixlib/asm_dec.s: Updated comment on CHUNK_* values.
	* include/kernel.h(__rt_allocauto): removed prototypes as it is no
	longer implemented.
	(__rt_freeauto): Likewise.
	* contrib/Help: Updated pointer to other documents.
	* sys/execlp.c: Updated comments.
	* sys/execvp.c: Likewise.

Mon Aug 20 22:41:11 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* gen-auto.pl: forgot to escape special chararacters in previous
	change.

Fri Aug 17 23:49:29 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* sys/exec.c(execve): support __UNIXLIB_SYMLINKS.

Thu Aug 16 23:40:21 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* gen-auto.pl: Define tooldir in produced Makefile.am so that partial
	build (or out-of-tree) of UnixLib works.

Wed Aug 8 19:03:03 2007  Lee Noar  <leenoar@sky.com>

	* common/symlinks.c: Don't use C based file access functions,
	because we may be called from one. Instead use low level OS
	functions.

Sat Aug 4 18:53:54 2007  Lee Noar  <leenoar@sky.com>

	* unix/dev.c: Add support for symlink files.
	* include/unixlib/buildoptions.h: Likewise.
	* include/unixlib/unix.h: Likewise.
	* common/objattr.c: Likewise.
	* common/exist.c: Likewise.
	* common/symlinks.c: New file. Implement symlink file processing.
	Primarily for use by GCC so that, eg, -lstdc++ will find symlink
	libstdc++.so which in turn points to libstdc++.6.0.8.so.

Sat Aug 4 17:39:01 2007  Lee Noar  <leenoar@sky.com>

	* vscript: Remove __pthread_cleanup_pop & __pthread_cleanup_push to
	make them visible from outside the DSO, as they could be called from
	a user program.

Sat Aug 4 14:40:20 2007  Lee Noar  <leenoar@sky.com>

	* vscript: Remove __pthread_start_ticker & __pthread_stop_ticker to
	make them visible from outside the DSO. Add __gcc_alloca_free_1 as
	it's only called by __gcc_alloca_free. Hiding it means a direct call
	instead of via the PLT and __gcc_alloca_free doesn't need to load
	the PIC register.

Tue Jul 10 00:53:25 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* include/sys/cdefs.h(__REDIRECT, __REDIRECT_NTH): Define.
	* include/sys/stat.h(struct stat): Define struct stat equal to the
	already existing struct stat64 and avoid the #define stat stat64 hack.
	Update function declaration of fstat64 and lstat64.
	* unix/lstat.c(lstat64): Use struct stat64 iso struct stat.
	* unix/fstat.c(fstat64): Likewise.
	* unix/stat.c(stat64): Likewise.
	* common/riscosify.c(translate_or_null): Avoid cast.

Fri Jul 6 14:16:12 2007  Lee Noar  <leenoar@sky.com>

	* pthread/_context.s: Change PIC code to load PIC register from
	16 byte array instead of 4 byte array.
	* pthread/_yield.s: Likewise.
	* pthread/_ints.s: Likewise.
	* signal/_demangle.s: Likewise.
	* signal/_signal.s: Likewise.
	* common/_exist.s: Likewise.
	* common/_riscosify.s: Likewise.
	* gcccompat/_b_return.s: Likewise.
	* sys/_jmp.s: Likewise.
	* sys/_vfork.s: Likewise.
	* sys/_syslib.s: Likewise.

Sat Jun 30 11:55:12 2007  Lee Noar  <leenoar@sky.com>

	* sys/_syslib.s(__main): Using registers to receive data from
	crt1-riscos is not very elegant and we can't use the stack as it
	may not exist, so use a block of memory defined in crt1-riscos
	instead.

Tue Jun 19 20:00:43 2007  Lee Noar  <leenoar@sky.com>

	* sys/_syslib.s(__main): Change below (r2667) did not solve
	anything as it still uses the stack. Abandon using the stack
	altogether and use only registers to receive data from crt1-riscos.

Tue Jun 19 19:18:29 2007  Lee Noar  <leenoar@sky.com>

	* sys/_syslib.s(__main): Receive the _init/_fini function ptrs
	via registers as statically linked binaries may not have a
	valid stack pointer.

Sun Jun 17 16:23:01 2007  Lee Noar  <leenoar@sky.com>

	* include/unixlib/asm_dec.s: Remove XSOM_GOTFromAddr from the
	list of SWIs. The new PIC scheme makes it redundant.
	* include/swis.h: Change SWI number for SOM_DeregisterClient
	to account for the removal of SOM_Prologue and SOM_Resolver.

Sun Jun 17 14:30:21 2007  Lee Noar  <leenoar@sky.com>

	* gen-auto.pl: Remove -lpic from linker flags as it is no
	longer required.

Fri Jun 15 17:41:54 2007  Lee Noar  <leenoar@sky.com>

	* pthread/_context.s: Use new PIC register loading scheme.
	* pthread/_yields.s: Likewise.
	* pthread/_ints.s: Likewise.
	* common/_exist.s: Likewise.
	* common/_riscosify.s: Likewise.
	* gcccompat/_b_return.s: Likewise.
	* sys/_jmp.s: Likewise.
	* sys/_vfork.s: Likewise.
	* signal/_demangle.s: Likewise.
	* signal/_signal.s: Use new PIC register loading scheme.
	(__h_cback_common): Fix bug in DSO; when copying registers, start
	from the correct position in __cbreg.
	* sys/_syslib.s: Use new PIC register loading scheme.
	(__main): Retrieve values passed by crt1-riscos.o from the stack
	rather than from registers and store them as required. Register
	the program's _fini function with atexit() and call its _init
	function after library initialisation, but before main() is
	called. This replaces the call to __gccmain(). This is necessary
	as eventually, we'll also want to call the _init functions of all
	the shared libraries here too. Where the PIC register (v4) is used
	for non-PIC code, replace with v6.

Wed May 16 21:34:47 2007  Lee Noar  <leenoar@sky.com>

	* signal/_signal.s(__h_sigint): Fixed bug in DSO where r12 was assumed
	to be GOT pointer, but was actually reused for something else.

Wed Apr 11 03:21:40 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* string/{_ffs.s,_ffsll.s}: the armv5 implemenation didn't work at
	all; replaced the non-armv5 implementation by a faster algorithm from
	David Seal.
	* pthread/_ints.s: DCB -> .asciz
	* gen-auto: moved from GCCSDK recipe/files/scripts/reconf-libunixlib-01
	to here; updated it so that the configure.ac is generated from
	configure.template filling in the AC_OUTPUT parameters; updated it
	to create TESTS for each test subdirectories.
	* test: reorganised the test files.
	* gcccompat/galloca.c: fixed wrong test on __UNIXLIB_PARANOID to
	determine if asserts need to be enabled or not.

Tue Apr 10 19:10:01 2007  Lee Noar  <leenoar@ntlworld.com>

	* libtool.m4: Remove occurrences of -fcall-used-v5 as it's now implied
	by -fPIC.

Mon Apr  9 21:16:29 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	Removed the last pre-UnixLib 5 only alloca implementation remains:
	* include/pthread.h(struct __pthread_thread): reduced alloca entry
	array of 3 pointers to just one pointer. The other array entries
	were not used.
	* pthread/newnode.c: following above change in struct
	__pthread_thread.
	* include/unixlib/asm_dec.s: likewise.
	* gcccompat/galloca.c: likewise.
	Enabled asserts for __UNIXLIB_PARANOID enabled builds.  Listen to
	__UNIXLIB_ALLOCA_FATAL to determine what to do if alloca() fails due
	to memory failure.
	(__gcc_alloca_longjmp_free): added, restores the alloca chunk list
	at longjmp() time.
	* sys/_jmp.s(setjmp,longjmp): alloca_list no longer exists so no
	longer (re)storing this weak value. longjmp() calls
	__gcc_alloca_longjmp_free() when the alloca chunk list is different
	than that setjmp() time. Soft-float builds are no longer storing
	the floating point registers.
	* include/setjmp.h(jmp_buf): following above change in struct
	jmp_buf.
	* gcccompat/_b_frame.s: fixed comments which got incorrectly changed
	by the aof2elf assembler conversion.
	* pthread/_ints.s(__pthread_protect_unsafe): don't resore pc flags in
	__pthread_unprotect_unsafe value when running on 26 bit systems (not
	needed for APCS-32).
	* sys/_syslib.s(use_existing_chunk): don't restore pc flags in
	__free_stack_chunk value when running on 26 bit systems (not needed
	for APCS-32).

Mon Apr  9 01:57:11 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* signal/_signal.s(unrecoverable_error): don't test for FPU exception
	in soft-float build.
	* module/sul.s: explicit fpu specification as "fpa" as we're using
	FP instructions even in a soft-float build.
	* string/_memcpy.s: explicit arch specification as "armv6" to allow
	PLD instructions even if we're building with another -march compiler
	option.
	* README(<program name>$HeapMax): clarified it a little bit more.

Sat Apr  7 16:06:43 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* stdlib/alloc.c(calloc): Detect size_t overflow for total size
	calculation as this might result in a non-NULL return value letting
	the caller believe it has a memory block that big.

Fri Apr  6 18:37:14 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* include/stdio.h(__STDIOLIB__): Removed static __stdiolib function
	pointer to __stdioinit (). It wasn't needed anymore for quite some
	time.
	* stdio/{freopen.c,fputs.c,fgets.c,perror.c,putc.c,flsbuf.c,getc.c
	stdio.c,ungetc.c,setbuf.c,puts.c,putw.c,fwrite.c,tmpfile.c,gets.c
	getw.c,filbuf.c,fopen.c,fpos.c,fclose.c,popen.c,fread.c,fflush.c}:
	Removed __STDIOLIB__.

Fri Mar 30 19:16:19 2007  Lee Noar  <leenoar@ntlworld.com>

	* vscript: New file. A linker file containing a list of symbols that
	are global within the DSO, but should not be visible outside the library
	as they are not part of its API. This has the same effect as declaring
	each symbol as hidden. The file is actually a version script, hence the
	name, but version information is not used in this case.

	There are a number of advantages to hiding such symbols:
	a) The API/public interface of the library is cleaner and hides the
	   internal workings.
	b) Library initialisation is quicker as there are fewer relocations at
	   runtime (the static linker is able to resolve more symbols at build
	   time).
	c) Functions that are only ever called from within the library and are
	   hidden are called directly and not via the PLT making the library
	   more efficient.

	More symbols may be added to the list in the future as it becomes clearer
	which qualify for inclusion.

Tue Mar 27 02:11:36 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* include/unixlib/asm_dec.s: include internal/defines.h; removed define
	TRUE/FALSE as it was not used.
	* include/unixlib/buildoptions.h(__UNIXLIB_CLZ_SUPPORTED): Removed,
	using __ARM_ARCH__ #define value instead.
	* string/_ffsll.s: Likewise.
	* string/_ffs.s: Likewise.
	* incl-local/internal/defines.h(__ARM_ARCH__,__ARM_ARCH_STR__): New
	file.
	* sys/_syslib.s: Reenabled runtime minimal ARM architecture check, was
	previously on XSCALE only, now based on __ARM_ARCH__ build and
	__get_cpu_arch runtime result.
	* README: updated with GCCSDK 4 build info.

Sat Mar 24 16:51:41 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/internal/elf-macros.s (NetSWI0): Fixed odd typo.

Tue Mar 20 20:03:46 2007  Lee Noar  <leenoar@ntlworld.com>

	* sys/_syslib.s: Change visibility of main function pointer to hidden.
	This prevents the dynamic linker from linking against main() in the
	executable.

Sun Mar 11 18:34:50 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/internal/elf-macros.s(UL_MEMORY_LAYOUT): Moving back to...
	* sys/_syslib.s: ...here.  Restored our stack ASCII art.
	* include/unixlib/asm_dec.s: Updated comments.

Sun Mar 11 16:54:44 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* incl-local/internal/aof-macros.s: Removed, no longer used.
	* incl-local/internal/elf-macros.s(__UNIXLIB_ERRNO_THREADED): changed
	from assembler test to preprocessor test; (__SOFTFP__) no longer
	defined as 0 when it is not defined.
	* include/unixlib/buildoptions.h(__UNIXLIB_ELF): Removed, no longer
	used.
	* unix/features.c : Removed tests on __ELF__, this is always 'true'
	from now on.
	* unix/unix.c: Likewise.
	* pthread/_exit.s: Likewise.
	* signal/_signal.s: Likewise.
	* include/features.h: Likewise.
	* include/unixlib/unix.h: Likewise.
	* include/sys/cdefs.h: Likewise.
	* gcccompat/_b_return.s: Likewise.
	* gcccompat/_galloca.s: Likewise.
	* gcccompat/galloca.c: Likewise.
	* gcccompat/_b_frame.s: Likewise.
	* string/_memcpy.s: Likewise.
	* string/_memset.s: Likewise.
	* sys/_syslib.s: Likewise.
	* sys/mman.c: Likewise.
	* include: Removed svn:ignore property.  No longer relevant.
	* include/unixlib: Updated svn:ignore property, buildoptions.s is no
	longer used nor exists.
	* include/endian.h: Typo fix.
	* pthread/_context.s (__SOFTFP__): Test on existance and not on its
	value.
	* sys/_jmp.s: Likewise.
	* sys/_syslib.s: Likewise.
	* README: Documented __program_name.
	* sys/_alloca.s: Removed, no longer needed.

Sat Mar 10 21:21:23 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* Used convert-unixlib.pl for the last time and stored its ELF
	result in SVN as trunk/gcc4/recipe/files/libunixlib.

Tue Mar 06 21:03:02 2007  Lee Noar  <leenoar@ntlworld.com>

	* source/clib/unixlib/unix.h: When not compiling for the
	shared library, use padding in place of the main function
	pointer to maintain structure offsets.
	* source/sys/_syslib.s: Always define the word that stores
	the main function pointer to maintain structure offsets,
	but only name it in the shared library.

Sun Mar 04 14:55:23 2007  Lee Noar  <leenoar@ntlworld.com>

	* source/unix/unix.c: Remove the dependency on the main symbol
	from the shared library by declaring and accessing it as a
	function pointer.
	* source/clib/unixlib/unix.h: Add main function pointer to
	__ul_global structure (shared library only).
	* source/clib/unixlib/asm_dec.s: Add main function pointer to
	GBL_* structure (shared library only).
	* source/sys/_syslib.s: In the shared library, initialise the
	main function pointer from the arguments passed to it in
	crti-riscos.asm and add main function pointer to the
	__ul_global structure.

Sun Jan 21 15:21:56 2007  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/features.h, source/common/_exist.s: Change default
	value of __feature_imagefs_is_file to 1.

Fri Jan 19 15:56:39 2007  Lee Noar  <leenoar@ntlworld.com>

	* source/sys/_syslib.s: Undo changes made Thu Jan 18.
	* source/unix/unix.c: Change comment about _main.

Thu Jan 18 19:39:06 2007  Lee Noar  <leenoar@ntlworld.com>

	* source/sys/_syslib.s: For the ELF build, convert __main into
	an initialisation function called __unixlib_main that returns
	to its caller. This allows the call to _main (and ultimately
	main()) to be moved to the executable.
	* source/unix/unix.c: Don't compile _main() for the ELF build.
	It is moved to crti-riscos.asm so that it can call main() in the
	executable.

Sat Jan 13 19:06:23 2007  Lee Noar  <leenoar@ntlworld.com>

	* elf/libtool.m4: Change names of shared library and symlinks to
	something that is recognised by GCC (effects libunixlib and libm
	only). In the dlopen test, look for riscos at the end of the
	string rather than the beginning.

Fri Jan 12 21:29:54 2007  Lee Noar  <leenoar@ntlworld.com>

	* elf/convert-unixlib.pl: Link libunixlib.so with shared libgcc.

Sat Jan 06 01:25:35 2007  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/pthread/_exit.s: Use v1 for function table pointer;
	a2 need not be preserved by callees under APCS

Fri Jan 05 17:13:54 2007  Lee Noar  <leenoar@ntlworld.com>

	* source/sys/_syslib.s (__main):
	Use correct PIC register which is v6 in this case, not v4.
	Make sure v6 (PIC register) is not used for anything else so that
	it is valid throughout the routine (anticipating future changes).

Thu Jan 04 18:17:23 2007  Lee Noar  <leenoar@ntlworld.com>

	* source/string/rawmemchr.c: Declare rawmemchr as alias for __rawmemchr
	otherwise rawmemchr is undefined.

Wed Dec 27 12:22:23 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/clib/sys/elf.h: Correct spelling of R_ARM_JUMP_SLOT.

Wed Dec 27 03:08:02 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/{stdarg.h,stddef.h,varargs.h}: Restored as clean build
	of GCC 3.4.6 did not work anymore (got obfuscated by a copy in
	$GCCSDK_INSTALL_ENV/include/unixlib).
	* source/gcccompat/_b_frame.s: Previous change broke the ELF shared
	build.

Tue Dec 26 21:12:06 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/gcccompat/{_b_return.s,_b_frame.s,_galloca.s,galloca.c}:
	finished and reworked the alloca, __builtin_return_address and
	__builtin_frame_address implementations for GCC 4
	This improves the gcc/g++ testsuite results.

Tue Dec 26 16:26:23 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/pthread/_exit.s: Fix FIXMEs, ie, don't use
	__alloca_thread_free_all or ___arm_alloca_thread_free_all in
	ELF build.

Tue Dec 26 14:59:48 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/sys/_syslib.s: Move DECLARE_FUNCTION of __trim_stack to the
	end of __free_stack_chain as technically they are part of the same
	function and also there's a possibility that the compiler may
	separate them in the resulting object file.

Mon Dec 25 17:03:19 2006  Lee Noar  <leenoar@ntlworld.com>

	* elf/convert-unixlib.pl: Link libpic.a into libunixlib.so and add
	version info to libunixlib.so and libm.so.

Wed Dec 20 20:47:17 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	Small bit of code reshuffling and cleanup before addressing the
	remaining source/gcccompat alloca work.
	* source/stdlib/random.c: GCC has inline.
	* source/stdlib/div.c: Remove __GNUC__ check.
	* source/unix/unix.c: Uppercase start char of __unixlib_fatal() calls.
	* source/pthread/_exit.s(___arm_alloca_thread_free_all,
	__alloca_thread_free_all): disabled for ELF builds.  These should go
	for good when UnixLib build is ELF only.
	* source/signal/post.c: No longer make use of __backtrace_getfp() by
	using inline assembler.
	* source/clib/unixlib/sigstate.h(__backtrace_getfp): Removed
	declaration.
	* source/signal/_coredump.s(__backtrace_getfp()): Removed file.
	* source/clib/unixlib/asm_dec.s(GBL_,MEM_): Updated comments.
	* source/clib/unixlib/asm_dec.s(CHUNK_): Added CHUNK_ definitions from
	_syslib.s.
	* source/clib/bits/byteswap.h(__bswap_16,__bswap_32): Removed
	declaration.
	* source/netlib/{_bswap_16.s,_bswap_32.s}(__bswap_32,htonl,ntohl,
	__bswap_16,htons,ntohs): Removed files.
	* source/clib/stdio.h: Removed Norcroft specific pragmas.
	* source/scl/_kfpavailable.s(_kernel_fpavailable): Code moved from
	_syslib.s.
	* source/gcccompat/{_moddi3.s,_divdi3.s,_umoddi3.s,_udivdi3.s}
	(__moddi3.s,__divdi3.s,__umoddi3.s,__udivdi3.s): Removed (we've enabled
	those routines in gcc/libgcc/Makefile).
	* source/sys/_alloca.s(alloca,__alloca,__alloca_thread_free_all):
	Disabled code for ELF builds as it is not used.  This file should go
	for good when UnixLib build is ELF only.
	* source/sys/_syslib.s: Moved CHUNK_ definitions to asm_dec.s; Don't
	check for FPEmulator in soft-float builds; Don't export
	__stackchunk_magic_number; Changed termination CR/NL + NUL to NUL for
	fatal error messages; Renamed free_stack_chunk to __free_stack_chunk
	and exported it; Moved __builtin_return_address implementation to
	gcccompat/_b_return.s.; Moved _kernel_fpavailable implementation to
	scl/_kfpavailable.s.; Added important FIXME for __trim_stack; Added
	suggestion for __unixlib_fatal_got_msg improvement.
	* source/gcccompat/_b_return.s(__builtin_return_address): Code moved
	from _syslib.s and added some comments on necessary improvements.
	* source/gcccompat/_galloca.s: Added a couple of FIXMEs.
	* source/gcccompat/galloca.c: Removed __backtrace_getfp() call; Added
	FIXMEs and a couple of small changes (like do not access data from a
	free'd memory block).

Mon Dec 18 03:28:56 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/stdlib/alloc(malloc,free,realloc,memalign,valloc,pvalloc,
	calloc,cfree,malloc_trim): prefixed routine names with '__' and made
	weak aliases for the original routine names to those implementations.
	* source/clib/limits.h(SHRT_MIN,INT_MIN,LONG_MIN,LONG_LONG_MIN): don't
	use C casting as these values should be evaluatable by the preprocessor
	too.
	This improves the g++ testsuite results.

Sun Dec 17 15:31:56 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/{libm-dbl64/s_finite.c,libm-flt32/s_finitef.c}: enable
	call to (currently empty) hidden_def(). This will be needed when we're
	going to hide symbols from shared UnixLib version.
	* source/clib/{complex.h,math.h}: don't declare 'long double' math
	variants here when building UnixLib as they are	declared in the source
	code as aliases to the 'double' variants.
	* source/clib/mathdef.h(__NO_LONG_DOUBLE_MATH): no longer define it so
	this means we're supporting 'long double' math calls but they are in
	reality the same as 'double' ones.
	* source/clib/varargs.h: Removed (falling back on the gcc version).
	* source/clib/bits/mathcalls.h: Using an up-to-date version.
	* source/libm-complex/{creall.c,conjl.c,cabsl.c,cargl.c,cimagl.c}:
	Removed as they are elsewhere declared as aliases to their 'double'
	equivalents.
	* elf/convert-unixlib.pl(NO_LONG_DOUBLE): Defined, meaning we're going
	to alias the 'long double' math routines to the 'double' versions.
	This improves the gcc testsuite results.

Sat Dec 16 14:41:51 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/stddef.h: Removed (falling back on the gcc version).
	* source/clib/bits/mathdef.h(INFINITY): Removed duplicate definition,
	was also defined in source/clib/bits/inf.h.
	This improves the gcc/g++ testsuite results.

Fri Dec 15 04:34:46 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/stdlib.h(atof,atoi,atol,atoll): consistent declaration of
	exported and inline variants.
	This improves the g++ testsuite results.

Sun Dec 10 21:03:51 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/stdarg.h: Removed (falling back on the gcc version).
	* source/string/_memcpy.s: Previous change got a build breaking typo.
	* source/string/_memset.s(memset,bzero): Made exported routines
	weakly defined.
	This improves the gcc/g++ testsuite results.

Sun Dec 10 15:29:31 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/stdio/_printf.s(_printf,_fprintf,_sprintf,_vfprintf,_vprintf,
	_snprintf,_vsprintf,_vsnprintf): Removed.
	* source/stdio/printf.c(vsnprintf,vsprintf,snprintf,sprintf,vprintf,
	fprintf,printf): Prefixed the exported routines with '__' and created
	weak symbols to those routines.
	* source/stdio/vasprintf.c(vasprintf): Likewise.
	* source/stdio/asprintf.c(asprintf): Likewise.
	* source/crypt/crypt_util.c(encrypt_r,setkey_r): Likewise.
	* source/crypt/crypt-entry.c(crypt_r,fcrypt): Likewise.
	* source/string/strndup.c(strndup): Cleanup, weak_alias is always
	defined (even for AOF case).
	* source/string/strnlen.c(strnlen): Likewise.
	* source/resolv/inet_addr.c(inet_aton): Likewise.
	* source/string/_memcpy.s(memcpy,memmove,bcopy): Made exported routines
	weakly defined.
	This all improves the gcc/g++ testsuite results.

Sat Dec 09 14:47:59 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/sys/_syslib.s(__rt_stkovf_split_big): Make sure that the frame size
	calculation takes into account the PIC register.

Sat Dec 09 14:26:02 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/sys/_jmp.s: Add PIC instructions and declare functions
	for ELF DSO.
	* source/sys/_alloca.s: Likewise.
	* source/sys/_vfork.s: Add PIC instructions and declare functions
	and objects for ELF DSO.
	* source/sys/_syslib.s: As above, also use a macro to define the layout of
	__ul_memory to support AOF/static ELF/shared ELF at the same time without
	unsightly nested conditional assembler.
	* source/sys/_syslib.s(__env_unixlib): Pass GOT pointer to exception
	handlers where possible.

Thur Dec 07 19:42:15 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/clib/errno.h: Ensure C linkage when used with C++
	compiler, otherwise there's a linkage disagreement with
	sys_errlist and sys_nerr in stdio.h.

Wed Dec 06 20:19:15 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/sys/_os.s: Declare functions for ELF DSO.
	* source/sys/_mman.s: Likewise.
	* source/sys/_sigjmp.s: Likewise.
	* source/sys/_swi.s: Likewise.

Wed Dec 06 19:50:16 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/signal/_demangle.s: Add PIC instructions and declare
	function for ELF DSO.
	* source/signal/_signal.s: Add PIC instructions and declare
	functions and objects for ELF DSO.
	* source/signal/_coredump.s: Declare function for ELF DSO.

Wed Dec 06 19:35:42 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/clib/unixlib/asm_dec.s: Add XSOM_GOTFromAddr to list of SWIs.

Wed Dec 06 19:19:42 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/incl-local/internal/aof-macros.s: Define macro UL_MEMORY_LAYOUT
	to make it easier to specify _ul_memory for {AOF/ELF static/ELF shared} in
	sys/_syslib.s.
	* source/incl-local/internal/elf-macros.s: As above, also add PIC instructions
	to __set_errno and __get_errno macros for ELF DSO.

Sun Dec 03 16:36:08 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/pthread/_context.s: Add PIC instructions and declare
	objects and functions for ELF DSO.
	* source/pthread/_yield.s: Likewise.
	* source/pthread/_ints.s: Likewise.
	* source/pthread/_exit.s: Likewise.

Wed Nov 29 22:58:55 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/unixlib/buildoptions.h: Removed __UNIXLIB_MULL_SUPPORTED
	as it isn't used anymore.

Wed Nov 29 22:43:05 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/unixlib/buildoptions.h,
	source/incl-local/internal/swiparams.h: Removed
	__UNIXLIB_USEFILEPATH build support and made FILEPATH default instead
	of using Run$Path.

Wed Nov 29 22:10:40 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/{unixlib/buildoptions.h,bits/sockaddr.h,sys/ioctl.h},
	source/netlib/{_sendmsg.s,_recvmsg.s,_getpeerna.s,_recvfrom.s,
	_accept.s,_getsockna.s}: Removed Internet 4 support
	(__UNIXLIB_COMPAT_INET4, which was equivalent to COMPAT_INET4 in
	Acorn's TCPIPLibs headers).

Wed Nov 29 20:36:22 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* Removed build support for Norcroft and LCC compilers (preprocessor
	tests on __UNIXLIB_NORCROFT_BUILD, __CC_NORCROFT,
	__CC_NORCROFT_VERSION, __LCC__).
	* source/{scl/_memchk.s,sys/_profile.s,sys/_longlong.s,sys/_divtest.s,
	sys/_smod.s,sys/_umod.s,sys/_sdiv.s,sys/_sdiv10.s,sys/_udiv.s,
	sys/_udiv10.s}: Removed private Norcroft routines.
	* source/sys/_alloca.s(__rt_freealloc,__rt_allocauto): Likewise.
	* source/sys/_syslib.s(x$stack_overflow,x$stack_overflow_1): Likewise.
	* source/sys/{_udivsi3.s,_modsi3.s,_umodsi3.s,_divsi3.s}: Removed
	unnecessary duplication of GCC private routines (already available in
	libgcc.a).
	* __UNIXLIB_NO_COMPLEX: Removed.
	* Docs/ReadMe,!Help: Updated that we're only support GCC compiler now.

Tue Nov 28 22:48:49 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/stdlib/qsort.c, source/unix/unix.c,
	source/clib/{unixlib/buildoptions.h,bits/libc-lock.h,pthread.h,
	errno.h},source/gcccompat/galloca.c,source/string/strsignal.c,
	source/signal/_signal.s, source/sys/{stackalloc.c,errlist.c,exec.c,
	_jmp.s,_syslib.s}: Remove compile test on __UNIXLIB_FEATURE_PTHREADS.
	pthread support is standard now.
	* source/clib/unixlib/unix.h(struct ul_global): made
	__pthread_worksemaphore and __pthread_callback_semaphore volatile
	as they are (can) be modified under interrupts.

Sat Nov 25 12:36:08 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/incl-local/internal/elf-macros.s: Remove warning notes as
	GAS no longer faults resulting instructions when a tab is included.
	* source/incl-local/internal/aof-macros.s: Always assemble a non-PIC
	instruction in AOF.

Wed Nov 22 19:33:04 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/common/_atomic.s: Declare function for ELF DSO.
	* source/common/_exist.s: Add PIC instructions and declare
	functions and objects for ELF DSO.
	* source/common/_riscosify.s: Likewise.

Tue Nov 21 20:34:20 2006  Lee Noar  <leenoar@ntlworld.com>

	* elf/convert-unixlib.pl: Only handle labels that begin
	with a '.' if they are delimited by '|' to prevent
	clashes with assembler directives.

Mon Nov 20 20:26:46 2006  Lee Noar  <leenoar@ntlworld.com>

	* elf/configure.ac: Enable libtool support to build both
	static and shared versions of libunixlib.

Mon Nov 20 19:57:46 2006  Lee Noar  <leenoar@ntlworld.com>

	* elf/convert-unixlib.pl:
	Alter label handling to allow them to start with a '.'.
	Add include/unixlib/stubs.h to list of install headers.
	Change *_SOURCES and *_LIBRARIES variables to libtool
	versions.
	Make sure libtool doesn't try to link libunixlib against
	itself by passing -nostdlib to compiler.
	Change nostackfiles dependencies to work with libtool.
	Add elf/libtool.m4 to list of files to copy.
	Add include path to aclocal-1.9 command to ensure it picks
	up the elf/libtool.m4 file.

Mon Nov 20 19:00:46 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/clib/dlfcn.h: New file. Provide defines, etc for
	dynamic linker.

Sun Nov 19 19:37:30 2006  Lee Noar  <leenoar@ntlworld.com>

	* elf/libtool.m4: New file to provide alternative versions
	of autoconf macros AC_LIBTOOL_SYS_DYNAMIC_LINKER,
	AC_LIBTOOL_PROG_COMPILER_PIC and AC_LIBTOOL_DLOPEN_SELF.
	These override the standard macros to allow RISC OS target
	to be detected during configuring of Unixlib.

Sun Nov 19 17:01:30 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/netlib/getnameinfo.c: Only compile for static library to
	prevent multiple definition of getnameinfo() (also defined in
	netlib/getaddrinfo.c) when linking shared library.

Sun Nov 19 16:05:12 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/incl-local/internal/aof-macros.s:
	Add macro to define word of data to mirror same
	macro in elf-macros.s.
	Add NOP macros to mirror those in elf-macros.s that
	are used for the ELF shared library.

Sun Nov 19 14:58:12 2006  Lee Noar  <leenoar@ntlworld.com>

	* source/incl-local/internal/elf-macros.s:
	Disable macro extension to allow quoted macro arguments.
	Change label names in NAME macro to allow multiple use.
	Add macros to declare type and size of functions and objects
	defined in assembler.
	Add macros to conditionally assemble PIC instructions for shared
	library.
	Add macro to define word of data with or without GOT relocation
	depending on library being built.

Tue Nov  7 19:44:12 2006  Lee Noar  <leenoar@ntlworld.com>

	* unixlib/elf/convert-unixlib.pl: Added code to generate stubs header
	for ELF version (adapted from gen-makefiles.pl).

Sun Oct  8 19:38:58 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/sys/elf.h: Added (copy of Lee Noar's GCCSDK 3.4.6 patch
	of his ELF work).

Wed Oct  4 22:22:30 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* Removed all CVS identifiers, updated Copyright statements and years
	based on SVN history (but UnixLib history starts before CVS/SVN so
	start dates are not always correct).

Sun Oct 01 01:02:06 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	Start of UnixLib 5.0 as RISC OS RunTime lib in ELF format.
	* source/debug/dvsprintf.c: renamed isxdigit()/isdigit()/tolower()/
	toupper()/strnlen() to local_* as this gave warnings and an error
	with GCC 4.1.1.
	* source/common/riscosify.c: temporary disabled RO_ENV support as
	GCC 4 ELF build does not have support for this.
	* source/sys/_syslib.s: temporary disabled the XScale test as it
	not supported by the convert-unixlib.pl right now.
	(__builtin_return_address): Added (code from Nick Burrett).
	* elf/convert-unixlib.pl: updated so it works with the current
	UnixLib code base and the build system we've now setup for GCC 4.1.
	* !Help: Update version to 5.0.
	* source/clib/features.h (__ULIBC__, __ULIBC_MINOR__): Updated it to
	5.0.

[ ^^^ Here starts UnixLib 5.0 ^^^ ]
-----------------------------------------------------------------------
Sun Jul 29 20:17:09 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* Docs/ReadMe: update section on pthread & Wimp behaviour after recent
	progress in this area.

Sun Jul 29 15:00:17 CET 2007  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/sys/__getcpuarch.s(__get_cpu_arch): wrong result for ARM
	architecture 3 processors.

-----------------------------------------------------------------------
[ vvv Here ends UnixLib 4.6 vvv ]

Sun Jul 15 13:52:59 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* !Help: Update version to 4.6.
	* source/clib/features.h (__ULIBC_MINOR__): Bump minor version to 6.

Sun Jul  8 19:14:58 CET 2007  John-Mark Bell  <jmb@netsurf-browser.org>
                              John Tytgat  <John.Tytgat@aaug.net>

	* source/pthread/_context.s: enabled pthread Wimp filter code after
	fixing following:
	(start_call_every,stop_call_every) full register + processor flag
	preserve.
	(__pthread_start_ticker, __pthread_stop_ticker) post filter mask was
	inverted.
	(__pthread_start_ticker) recheck if we're not yet a task since last
	check.
	* source/sys/_syslib.s: don't write bogus GBL_TASKHANDLE when
	Wimp_ReadSysInfo fails.
	* source/test/pthread/create-join.c: new pthread test case.

Wed May 23 20:31:26 2007  Alex Waugh  <alex@alexwaugh.com>

	* source/include/unixlib/types.h: Fix typo in typedef.

Sun Apr 29 17:55:43 CET 2007  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/unix/unix.c(find_redirection_type): don't go beyond start of
	cmdline when it starts with the redirection_type character or one or
	more digits followed by the redirection_type character.

Tue Mar 27 01:48:55 CET 2007  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/unixlib/unix.h(__get_cpu_arch): Declare.  Gives rough
	indication which ARM architecture we're running on.
	* source/sys/_getcpuarch.s(__get_cpu_arch): New file.
	* unix/uname.c(uname): changed utsname.sysname from "riscos" into
	"RISC OS" and utsname.machine from "arm-acorn" into "armvxl" with 'x'
	the major ARM architecture digit.

Thu Jan 18 21:59:26 2007  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/errno.h: Change EDEADLK value for TCPIPLibs
	compatibility and add ENOTSUP.

Sun Jan 14 16:38:22 2007  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/errno.h: Change EAGAIN value to the same as
	EWOULDBLOCK, to match TCPIPLibs and Linux.

Thu Jan 11 21:48:46 CET 2007  Martin Wuerthner  <martin@mw-software.com>

	* source/common/riscosify.c (__riscosify_scl): Incorrect program name
	  determination for programs run as "*Run MyLibrary:myprog".

Sun Dec 24 15:01:25 PST 2006  Peter Naulls <peter@chocky.org>

	* source/sys/exec.c: Add to the hack that checks whether we use
	 argv[0] or not - canonicalise RISC OS versions of the filenames before
	 comparing.

Mon Dec 04 01:59:39 2006  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/string/strnicmp.c: Compare lowercased versions of strings
	rather than uppercase. This matches the manpage (and what stricmp
	does).

Tue Nov 21 21:45:22 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/sync.c (fsync): Don't error on files open with 
	  O_RDWR

Sat Oct 21 22:38:13 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/regex.h: Made it usable for C++ programs.

Wed Oct  4 23:13:35 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/sys/exec.c (execve): Made code slightly less obfuscated.

Tue Sep 26 23:14:57 2006  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/time/mktime.c: Fix corruption of input structure (bug #152)

[ ^^^ Here starts UnixLib 4.x ^^^ ]
-----------------------------------------------------------------------
[ vvv Here ends UnixLib 4.5 vvv ]

Thu Sep 14 01:25:05 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* !Help: Update version to 4.5.
	* source/clib/features.h (__ULIBC_MINOR__): Bump minor version to 5.
	* Docs/ReadMe: reformated last change.

Wed Sep 13 22:13:35 2006  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/common/riscosify.c (riscosify_scl): Add support for
	  UnixEnv$foo$sfix.

Sat Sep  9 12:24:32 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/dirent.c (readdir_r): Fix suffix swapping code.
	  Fix the result value (POSIX states it should be the value of
	  entry, or NULL).

Fri Sep  8 16:42:35 2006  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/common/unixify.c: Fix unixify early exits to return pointer to
	  buffer rather than pointer to NULL terminator.
	* source/test/testunixify.c: Add test for "..".

Mon Sep  4 06:43:03 PDT 2006  Peter Naulls  <peter@chocky.org>

	* source/Makefile.in, source/common/riscosify.c: Avoid using hard-wired
	  "/home/riscos/env/" path.
	* source/clib/bits/posix_opt.h: Refine further.

Sat Aug 26 16:59:31 CET 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/pthread/{*.c,*.s}: Removed CVS keywords and made Copyright
	  statements conforming.
	* source/pthread/_context.s: Fixed comment.
	* source/pthread/_yield.s: Renamed callback_return to
	  __pthread_yield_return and gave it an APCS function name so we see
	  the thread waiting in the backtrace.
	* source/pthread/_ints.s: Use SWP instead off swp_arm2 macro.
	* source/pthread/_exit.s: Small optimisation.
	* source/signal.post.c(__write_backtrace,__write_backtrace_thead):
	  output backtrace per created thread.
	* source/signal/_signal.s: Updated comments.
	  (__h_exit) Setup signal stackhandler as the USR26/USR32 registers
	  can not be trusted (e.g. TaskManager calling OS_Exit when <Alt><Break>
	  gets pressed).
	* source/clib/unixlib/buildoptions.h: Removed __UNIXLIB_SWP_SUPPORTED. No
	  longer supporting or pretending to support ARM2.
	* source/incl-local/internal/aof-macros.s: Removed swp_arm2 macro.
	* source/incl-local/internal/elf-macros.s: Likewise.
	* source/sys/_syslib.s: Likewise.  Tabbified.

Sun Aug 13 11:45:32 PDT 2006  Peter Naulls  <peter@chocky.org>

	* source/sys/_syslib.s: Improve XScale check (from John-Mark Bell /
	  Adrian Lees).
	* source/wchar/mbsrtowcs.c: Add alias.

Sat Aug 12 07:15:40 PDT 2006  Peter Naulls  <peter@chocky.org>

	* source/unix/sync.c: More robust handling of file handles.

Thu Aug 10 20:48:03 PDT 2006  Peter Naulls  <peter@chocky.org>

	* source/clib/bits/posix_opt.h: Revise further
	* Docs/ReadMe: Update with notes about POSIX compatibility

Thu Aug 10 13:53:58 PDT 2006  Peter Naulls  <peter@chocky.org>

	* source/sys/_syslib.s: Check for RISC OS 5 when built for XScale.

Sun Aug  6 12:47:09 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/Makefile.in: Mark generated clib/unixlib/buildoptions.s file
	  clearly as a derived file.
	* debug/dvsprintf.c: don't make use of routines which have stack
	  checking enabled.  Write all info via __os_print() and not via stderr.
	* source/clib/unixlib/buildoptions.s: Removed (it will be generated
	  in the build).
	* source/clib/unixlib/asm_dec.s: Added SIGSTAK as alias for SIGEMT.
	* source/clib/bits/signum.h: Made SIGSTAK an alias for SIGEMT instead
	  of allocating an unique signal number (which is already beyound
	  the currently 32 supported signal set).
	* source/signal/signame.c: Reformated.
	* source/clib/unixlib/sigstate.h,source/signal/post.c,
	  source/signal/_demangle.s: respect the __cxa_demangle() API, i.e. all
	  its buffers are heap buffers.
	* sys/stackalloc.c: Include sys/debug.h when #define DEBUG is done.
	  (incr_downards): add check if downwards stack increasing doesn't mean
	  going lower than zero page.

Sat Aug  5 16:33:17 PDT 2006  Peter Naulls  <peter@chocky.org>

	* source/clib/bits/posix_opt.h: Be less optimistic about what
	  we support.
	* source/clib/bits/signum.h: Declare SIGSTAK for compatibility
	  with Acorn C.

Wed Aug  2 08:41:59 PDT 2006  Peter Naulls  <peter@chocky.org>

	* source/clib/unistd.h, source/clib/bits/posix_opt.h: Add
	  posix_opt header and set RISC OS features.  In particular,
	  set flags indicating UnixLib supports POSIX threads, required
	  by X libraries.

Sun Jul 30 19:12:17 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/unixlib/sigstate.h,source/signal/_demangle.s
	  (__unixlib_cxa_demangle): via WEAK symbol, make libstdc++'s
	  __cxa_demangle routine available internally when it's possible.
	* source/signal/post.c(extract_name): make use of
	  __unixlib_cxa_demangle during __write_backtrace.
	* source/signal/post.c(__write_backtrace): don't output registers
	  when __ul_callbackfp is NULL as then they don't make any sense.
	* source/stdlib/_rand48.c: Removed bogus CVS tags.
	* source/signal/_signal.s,source_sys/_syslib.s: Minor comment
	  improvement.
	* Docs/Changelog: char 0xA0 -> 0x20.

Sat Jul 15 21:35:32 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/unix/tty.c,source/clib/unixlib/fd.h: minor src code cleanup.
	* source/clib/unixlib/unix.h,source/common/funcallerr.c: made
	  __UNIXLIB_PARANOID build working again and added extra test on
	  function pointers be lower than __ul_memory.appspace_himem value.

Sun Jul  9 13:52:36 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/common/unixify.c: Remove part of previous change so that
	  names such as foo/bar.c get translated correctly.

Fri Jun 16 12:03:17 2006  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/stdio/scanf.c: Fix handling of width-limited character classes.
	  Previously re-read the last character that matched the format string.
	* source/test/stdio/tsscanf.c: Testcase for the above.

Thu Jun  8 00:17:00 2006  John Tytgat  <John.Tytgat@aaug.net>

	* !Help: Update version to 4.4
	* source/clib/features.h (__ULIBC_MINOR__): Bump minor version to 4.
	* source/signal/post.c (__write_backtrace): show explicitly the
	  processor mode and flags when in 26bit mode; show memory contents of
	  disassembled part as words and ASCII interpretation of its bytes.

Wed Jun  7 22:52:47 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/sys/_syslib.s: Search for SUL in UnixLib:Modules
	  as well as System:Modules.

Sun May 21 20:36:42 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/common/unixify.c: Don't do suffix swapping if the leafname
	  has a / in it.
	* source/test/testriscosify.c: Add extra testcase.

Tue Apr 11 17:40:56 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/module/sul.s: Allocate some memory to store the head of the
	  linked list so user mode code does not need to access the module
	  private word.
	  Fixed R4 corruption of SWI SharedUnixLibrary_RegisterUpCall.

Fri Mar 10 21:25:47 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/unix.c: Prevent canonicalising program name if it is
	  just a leafname.

Thu Mar  9 19:33:31 2006  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/unistd.h: Add lchown().
	* source/unistd/lchown.c: New file.

Sun Feb 26 23:51:25 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/netlib/getaddrinfo.c(gai_strerror): Always wrongly returned
	  "Unknown error".
	* source/resolv/gethnameaddr.c(gethostbyname2): Use hosts file as
	  fallback when resolv query failed.

Tue Feb 14 23:31:18 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/features.h (__ULIBC_MINOR__): Bump minor version to 3.

Mon Feb 14 00:39:17 2006  John Tytgat  <John.Tytgat@aaug.net>

	* !Help: Update version to 4.3
	* Docs.ReadMe: Current iconv module version is 0.07.  Also using more
	  stable URL.

Sun Feb 12 17:31:43 2006  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/common/unixify.c: Obey __RISCOSIFY_NO_REVERSE_SUFFIX.

Sun Feb 12 13:29:24 2006  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/stdio.h (__io_mode): Changed struct into union so that
	  all bits can be set to zero in __getmode() in a more clean way.
	* source/stdio/fclose.c (fclose): Following stdio.h(__io_mode) change.
	* source/stdio/fflush.c (fflush): Likewise.
	* source/stdio/filbuf.c (check_stream): Likewise.
	* source/stdio/fopen.c (fopen, fdopen): Likewise.
	* source/stdio/fpos.c (fseek, ftell): Likewise.
	* source/stdio/fread.c (fread): Likewise.
	* source/stdio/freopen.c (freopen): Likewise.
	* source/stdio/fwrite.c (fwrite): Likewise.
	* source/stdio/getc.c (fgetc): Likewise.
	* source/stdio/newstream.c (__stream_init, __getmode): Likewise.
	* source/stdio/popen.c (pclose): Likewise.
	* source/stdio/printf.c (vsnprintf): Likewise.
	* source/stdio/putc.c (fputc): Likewise.
	* source/stdio/scanf.c (vsscanf): Likewise.
	* source/stdio/setbuf.c (setvbuf): Likewise.
	* source/stdio/ungetc.c (ungetc): Likewise.
	* source/stdio/vfprintf.c (__vfprintf): Likewise.
	* source/gcccompat/_galloca.s: Added missing END.
	* source/unix/dirent.c: Reduced compiler warnings.
	* source/unix/open.c: Likewise.
	* source/unix/select.c: Likewise.
	* source/unix/unix.c: Likewise.

Sun Jan 29 00:29:13 2006  John Tytgat  <John.Tytgat@aaug.net>

	* Docs/ReadMe: DRenderer is now part of GCCSDK where further development
	  can take place.

Wed Dec 14 21:07:03 2005  Peter Naulls  <peter@chocky.org>

	* !Help: Update version to 4.2
	* source/sound/dsp.c: Buffer calculation improvements 
	  from Alan Buckley.
	* source/clib/local.h, source/common/unixify.c:
          New __unixify_ext function.

Sun Dec  4 17:11:31 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/common/unixify.c: Don't convert absolute filenames that
	  are already in Unix format.

Wed Nov 16 03:38:56 2005  John Tytgat  <John.Tytgat@aaug.net>

	* Removed EMBED_RCSID.
	* Removed 'register' keyword in all non-imported source files.

Sun Nov 13 15:44:22 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/module/sul.s: Cope with command lines where RISC OS has
	  stripped the temporary FS from the start.

Sat Nov 12 17:43:11 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/sys/exec.c: Strip any spaces before the command.
	* source/unix/dev.c (__pipeselect): Don't block on EOF.
	* source/unix/fcntl.c: Search for next free file descriptor rather
	  than assuming the one given is unused.
	* source/unix/unix.c (__alloc_file_descriptor): Allow starting
	  descriptor to be specified.
	  (check_fd_redirection): Use dup2 rather than fcntl so old
	  descriptor gets closed.
	* source/clib/unixlib/fd.h (__alloc_file_descriptor): Add parameter.
	* source/netlib/accept.c: Likewise.
	* source/netlib/socket.c: Likewise.
	* source/unix/open.c: Likewise.
	* source/unix/pipe.c: Likewise.

Sun Nov  6 14:38:12 2005  Alex Waugh  <alex@alexwaugh.com>

	* gen-makefiles.pl: Attempt to strip out incorrect dependencies added
	  by gcc -M.

Mon Oct 10 14:20:00 2005  Peter Naulls  <peter@chocky.org>

	* Docs/ReadMe: Misc corrections and updates.
	* source/sys/_swi.s: Correct _swix() output arguments.
	  Fix from Bob Brand.
	* source/unix/mkdir.c: Spot more directory creation
	  failure variants.

Sat Sep 24 22:24:47 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/module/sul.s: Add an additional check of the command line
	  when searching for a process struct to use (Bug#142).

Sat Sep 24 20:39:23 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/fcntl.c: Close-on-exec flag should be cleared on
	  duplicated file descriptors (Bug#146).

Fri Aug 26 00:12:33 2005  John-Mark Bell  <jmb@netsurf-browser.org>

	* regexp/{COPYRIGHT,regcomp.c,regcustom.h,regc_color.h,regc_cvec.h,
	          regc_lex.h,regc_locale.h,regc_nfa.h,regerror.c,regerrs.h,
	          regexec.c,rege_dfa.h,regfree.c,regguts.h}, clib/regex.h:
	  Import regex implementation from PostgreSQL - this is significantly
	  faster than the existing implementation.
	* regexp/{cclass.h,cname.h,engine.h,regex2.h,utils.h}: Remove redundant
	  files.
	* Docs/Copyright: Add details of regex implementation licencing.

Sun Jul 31 16:17:49 2005  John Tytgat  <John.Tytgat@aaug.net>

	* clib/unixlib/{asm_dec.s,unix.h}, sys/_syslib.s: For some time UnixLib
	  required the FPEmulator so __fpflag is not really needed.  Renamed to
	  __notused1 (and not longer exported) so that we can reuse the space for
	  something else in the future. Renamed GBL_FPFLAG to GBL_NOTUSED1.

Sat Jul 23 13:45:59 2005  Peter Naulls  <peter@chocky.org>

	* common/unixify.c: Fully fix earlier fix.
	* clib/unixlib/os.h, signal/_signal.s: Make __ul_seterr
	  return -1 on error.
	* stdlib/alloc.c: Allow debug version to compile.
	* debug/dvsprintf.c: Use stderr for output once initialised.
	* unix/fcntl.c: Dummy file locking functionality.
	* unix/mkdir.c: Set ENOENT when the RISC OS error is "Not found".

Wed Jul 20 19:27:41 2005  Peter Naulls  <peter@chocky.org>

	* source/common/unixify.c: Correct conversion case when
	  file is in root directory.
	* elf/convert-unixlib.pl: Correct install location for GCC 4.1.

Thu Jul 14 23:29:00 2005  John Tytgat  <John.Tytgat@aaug.net>

	* unix/unix.c (__unixinit): Terminating NULL in environment list
	  could sometimes be written outside allocated buffer.

Fri Jul  8 15:34:42 2005  Peter Naulls  <peter@chocky.org>

	* UnixLib 4.2 release.

Fri Jul  8 14:23:04 2005  Peter Naulls  <peter@chocky.org>

	* pthread/keydest.c: Use free_unlocked instead of free to
	  match allocation.
	* sys/brk.c: Fix spelling mistake.
	* unix/unix.c: Convert process filename to Unix format;
	  patch from John Tytgat.

Fri Jun 17 11:05:25 2005  Nick Burrett  <nick@sqrt.co.uk>

	* libm-support/libm.c: New file.

Thu Jun 16 20:44:38 2005  Alex Waugh  <alex@alexwaugh.com>

	* time/utimes.c: Fix time convertion.

Thu Jun 16 14:51:14 2005  Alex Waugh  <alex@alexwaugh.com>

	* pthreads/context.c: Ensure the first thread in the list can
	  be freed when it is idle.

Thu Jun 16 14:24:59 2005  Theo Markettos  <theo@markettos.org.uk>

	* common/riscosify.c: Add support for mapping /home/riscos/env/foo
	  to foo:
	* test/testriscosify.c: Add more tests.

Mon Jun 13 14:55:30 2005  Peter Naulls  <peter@chocky.org>

	* clib/netdb.h: Remove bogus extra AI_PASSIVE.
	* clib/bits/sched.h, clib/pthread.h, clib/sched.h: Arrange
	  things a bit more like glibc (Allows problems with files named
	  sched.h to build).
	* gcccompat/_galloc.s, libm-dbl64/s_isnan.c,
	  incl-local/internal/math.h: Norcroft compatibility.
	* module/sul.s: Increase file handles to 256 as per UnixLib.
	  Bump version to 1.07.
	* source/sys/_syslib.s: Required SharedUnixLibrary 1.07.

Sat May 28 21:52:15 2005  Peter Naulls  <peter@chocky.org>

	* common/unixify.c: Ensure we don't run off the end of the input
	  buffer.
	* clib/errno.h: #define errno as itself, to allow for checks
	  that errno exists to work.
	* clib/sys/ioctl.h: Some TCPIPLibs compatibility (not implemented).

Mon May 16 22:30:29 2005  Peter Naulls  <peter@chocky.org>

	* stdio/fwrite.c (fwrite): Make (v)snprintf with null parameters
	  work properly.  Correct byte count.

Fri May 13 22:17:31 2005  Peter Naulls  <peter@chocky.org>

	* test/pthread/fork.c: Correct spelling.
	* Makefile.in: Stronger warning flags.
	* clib/features.h, libm-dbl64/s_finite.c, libm-flt32/s_finitef.c,
	  search/hsearch.c, search/hsearch_r.c, search/lsearch.c,
	  vfprintf.c: Make code work with new flags
	* stdio/fwrite.c (fwrite): Tidy and correctly return number of
	  items written.
	* stdio/printf (vsnprintf): Correctly terminate buffer.
	* stdio/putc.c (putc_unlocked): Implement new function.

Sat May  7 16:35:02 2005  Nick Burrett  <nick@sqrt.co.uk>

	* features.h (__ULIBC_MINOR__): Bump version to 1.

Sat May  7 16:08:52 2005  Stefan Bellon  <sbellon@sbellon.de>

	* signal/post.c (sigsetup): Casting fixes for Norcroft compatibility
	* sys/exec.c (execve): Likewise.

Sat May  7 10:14:36 2005  Nick Burrett  <nick@sqrt.co.uk>

	Software-floating point support.
	* source/Makefile.in (LIBM_FLAGS): Remove.
	* incl-local/math_private.h (LITTLE_ENDI): Define flags here according
	to value of __FLOAT_WORD_ORDER.
	(HIGH_HALF): Define.
	(LOW_HALF): Define.
	(BIG_ENDI): Define
	* endian.h (__FLOAT_BIT_ORDER): Define.
	(__FLOAT_WORD_ORDER): Define.
	* ieee754.h: Redefine unions according to values of __FLOAT_BIT_ORDER
	and __FLOAT_WORD_ORDER.
	* gdtoa/fpmath.h: Likewise.
	* gdtoa/arith.h: Include endian.h.
	* incl-local/internal/elf-macros.s (__SOFTFP__): Define to zero,
	if not defined.
	* incl-local/internal/math.h: Include endian.h.  Add structures
	to cope with little-endian __FLOAT_WORD_ORDER.
	* libm-dbl64/branred.c: Include <math_private.h> first, drop
	inclusion of endian.h.
	* libm-dbl64/{dosincos.c, e_asin, e_atan2.c, e_exp.c}: Likewise.
	* libm-dbl64/{e_log.c, e_pow.c, e_remainder.c, mpa.c}: Likewise.
	* libm-dbl64/{mpatan.c, mpatan2.c, mpexp.c, mplog.c}: Likewise.
	* libm-dbl64/{mpsqrt.c, mptan.c, s_atan.c, s_sin.c}: Likewise.
	* libm-dbl64/{sincos32.c, slowexp.c, slowpow.c}: Likewise.
	* libm-dbl64/upow.h: Swap ordering of 'static' and 'const'.

	* fenv/fclrexcpt.c: Use __SOFTFP__ rather than __SOFT_FLOAT__.
	* fenv/fedisblxcpt.c: Likewise.
	* fenv/fegetexcept.c: Likewise.
	* fenv/feholdexcpt.c: Likewise.
	* fenv/fesetenv.c: Likewise.
	* fenv/fraiseexcpt.c: Likewise.
	* fenv/fsetexcptflg.c: Likewise.
	* fenv/ftestexcept.c: Likewise.

	* stdlib/alloc.c (malloc): Check for __pthread_system_running
	before enabling/disabling interrupts.
	(free, realloc, memalign, valloc, pvalloc, calloc): Likewise.
	(cfree, malloc_trim): Likewise.

	* bits/signum.h: New file.
	* signal.h: Move all signal number definitions e.g. SIGHUP into
	bits/signum.h.
	(SIG_ERR, SIG_DFL, SIG_IGN, NSIG): Likewise.

Fri May  6 11:54:07 2005  Peter Naulls  <peter@chocky.org>

	* UnixLib 4.1 release.

Fri May  6 10:10:16 2005  Peter Naulls  <peter@chocky.org>

	* clib/sys/select.h: Add NFDBITS constant.
	* sys/_syslib.s: Require SharedUnixLibrary 1.06

Tue May  3 15:56:47 2005  John-Mark Bell  <jmb@netsurf-browser.org>

	* clib/sys/queue.h: Update to more recent version including more
	  queue types.
	
Mon May  2 14:51:58 2005  Nick Burrett  <nick@sqrt.co.uk>

	* module/sul.s (sul_fork): For consistency, shrink parent pid to
	30-bits.
	* gcccompat/galloca.c: New file for GCC 4 alloca implementation.
	* gcccompat/_galloca.s: New file for GCC 4 alloca implementation.
	* pthread/_exit.s (__pthread_exit): Call __gcc_alloca_thread_free_all.

Mon May  2 14:24:06 2005  Peter Naulls  <peter@chocky.org>

	* fenv/fclrexcpt.c, fenv/fedisblxcpt.c, fenv/egetexcept.c,
	  fenv/feholdexcpt.c, fenv/fesetenv.c, fenv/fraiseexcpt.c,
	  fenv/setexcptflg.c, fenv/testexcept.c: Do nothing interesting
	  when using soft-float.
	* pthread/_context.s: Don't save FP regs when using soft-float
	* sys/_jmp.s: Similarly.
	* sys/_syslib.s: Leave FP status register alone when using soft-float
	* incl-local/internal/aof-macros.s: Add missing END.

Mon May  2 13:45:54 2005  Nick Burrett  <nick@sqrt.co.uk>

	* module/sul.s (alloc_proc): Shrink the stored pid to 30-bits
	to work around applications that test for fork failure by testing
	(pid < 0).
	(sul_fork): Expand/shrink pid to/from 32-bits where necessary.
	(sul_exec): Likewise.
	(sul_exit): Likewise.

Sun May  1 15:54:36 2005  Nick Burrett  <nick@sqrt.co.uk>

	* module/sul.s (help): Move tab char onto seperate line to aid
	ELF conversion script.

Sun May  1 13:17:47 2005  Nick Burrett  <nick@sqrt.co.uk>

	* string/strtok_r.c (strtok_r): Check for a NULL save_ptr.
	* string/stricmp.c (stricmp): Corner case fix.

Sun May  1 11:22:00 2005  Nick Burrett  <nick@sqrt.co.uk>

	* stdlib/strtol.c: Import from FreeBSD libc, includes bug fixes.
	* stdlib/strtoul.c: Likewise.
	* stdlib/atoi.c: New file, split from strtol.c.
	* stdlib/atol.c: New file, split from strtol.c.
	
Sat Apr 30 16:15:13 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unix/features.c (__get_program_name): For ELF, dereference weak
	symbol to verify whether it exists.
	* sys/mman.c (mmap): Likewise.

Sat Apr 30 14:55:04 2005  Nick Burrett  <nick@sqrt.co.uk>

	Ease the conversion from AOF to ELF.
	* gcccompat/_divdi3.s: Change local label names to support ELF syntax.
	* gcccompat/_udivdi3.s: Likewise.
	* gcccompat/_moddi3.s: Likewise.
	* gcccompat/_umoddi3.s: Likewise.
	* sys/_jmp.s (__longjmp_fatal_msg): Ease translation to ELF syntax.
	* incl-local/internal/elf-macros.s (macro NAME): Place quotes around
	name.  Move .altmacro directive out of macro.
	* common/_exist.s: Remove quotes from NAME statements.
	* common/_riscosify.s: Likewise.
	* signal/_signal.s: Likewise.
	* sys/_syslib.s: Likewise.
	
Sat Apr 30 13:32:23 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/asm_dec.s: Move MACRO definitions to aid ELF conversion ...
	* incl-local/internal/aof-macros.s: ... here.
	* incl-local/internal/elf-macros.s: New file, providing ELF versions
	of the AOF macros.

Sat Apr 30 12:36:51 2005  Nick Burrett  <nick@sqrt.co.uk>

	* common/__stat.c: Renamed from common/stat.c to avoid filename
	clash with unix/stat.c.

Sat Apr 30 11:14:07 2005  Nick Burrett  <nick@sqrt.co.uk>

	* sys/exec.c (execve): Fix call usage of malloc_trim_unlocked.

Fri Apr 29 19:23:19 2005  Peter Naulls  <peter@chocky.org>

	* clib/assert.h: Make NDEBUG work under C++.
	* clib/netdb.h, netlib/getaddrinfo.c: getaddrinfo and friends
	  implementation.

Fri Apr 29 13:43:24 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/unix.h (struct ul_memory): Remove double-underscore
	prefix from 'unixlib_stack', 'robase', 'rwlomem', 'rwbase',
	'unixlib_stack_limit' and 'old_himem'.
	Change types for those variables from void* to 'unsigned int'
	as they aren't pointers and it reduces the number of explicit
	casts.
	(__stackalloc_incr_wimpslot): Change parameter types.
	* resource/initialise.c (__resource_initialise): Fix accordingly.
	* resource/ulimit.c (ulimit): Likewise.
	* debug/debug.c (__debug): Likewise.
	* common/funcallerr.c (__funcall_error): Likewise.
	* signal/post.c (sigsetup): Likewise.  Change types for 'low' and
	'high' and 'handler_addr' to unsigned int to avoid a lot of
	unnecessary casts.
	* sys/exec.c (execve): Use new variable names.  Call unlocked
	variant of malloc_trim.
	* sys/stackalloc.c (__stackalloc_incr_wimpslot): Change return
	type to 'unsigned int'.
	(incr_upwards): Renamed from '__stackalloc_incr_upwards'.
	(incr_downards): Renamed from '__stackalloc_incr_downwards'.
	(__stackalloc): Use new function names.

	* math.h (struct exception): Add const qualifier to 'name' to clear up
	compile-time warnings.
	* resolv/resolv.h (struct res_sym): Likewise for 'name' and
	'humanname'.
	
	Norcroft fixes from Stefan Bellon.
	* pthread/atfork.c: Include malloc.h.
	* pthread/key.c: Include malloc.h.
	* stdlib/alloc.c (malloc_trim): Cast return type of
	malloc_trim_unlocked.

Fri Apr 29 11:02:07 2005  Nick Burrett  <nick@sqrt.co.uk>

	Remove the dual-purpose use of 'rwlomem' and '__unixlib_break'
	for both read/write application memory and dynamic areas.
	* unixlib/asm_dec.s (MEM_RWBREAK, MWM_DABREAK): New constants,
	split from MEM_UNIXLIB_BREAK.
	* unixlib/unix.h (struct ul_memory): Add 'dalomem'
	Remove the ambiguity of '__unixlib_break' by replacing it with
	'rwbreak' and 'dabreak'. 
	* debug/debug.c (__debug): Add code to show the dynamic area
	memory limits.
	* resource/initialise.c (__resource_initialise): Use new variables.
	* sys/_syslib.s (__main): Use new variables.  When creating a
	dynamic area, set 'dalomem' and 'dabreak', rather than 'rwlomem'
	and 'unixlib_break'
	(__ul_memory): Add new fields.
	* sys/brk.c (__internal_brk): Delete function, moving code into
	two new functions ...
	(brk_da): ... this one for dynamic areas.  Use new 'da' variables.
	(brk_rw): ... this one for read/write data area in application space.
	(brk): Use new worker functions.
	(sbrk): Likewise.

Thu Apr 28 20:49:34 2005  Alex Waugh  <alex@alexwaugh.com>

	* sys/_syslib.s: Add missing spaces.

Thu Apr 28 13:47:20 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/unix.h (struct ul_memory): Rename '__image_rw_himem' to
	'appspace_himem'.
	* debug/debug.c: Use 'appspace_himem'.
	* sys/brk.c: Likewise.
	* sys/vfork.c (__fork_post): Likewise.
	* sys/stackalloc.c (__stackalloc_init): Likewise.
	(__stackalloc_incr_upwards): Likewise.
	(__stackalloc_incr_wimpslot): Likewise.
	* unixlib/asm_dec.s (MEM_APPSPACE_HIMEM): Renamed from
	MEM_IMAGE_RW_HIMEM.
	* sys/_syslib.s (__main): Use it.
	(__check_stack): Use it.

Thu Apr 28 12:14:15 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/unix.h (struct ul_memory): Rename '__unixlib_real_break'
	to 'dalimit'.
	Rename '__unixlib_real_himem' to 'appspace_limit'.

	* sys/brk.c (__internal_brk): Use 'dalimit'.
	Remove 32K check hack as system resource limits are setup before
	the first call to 'brk'.  Add more explanatory comments.
	* unix/unix.c (__unixinit): Call '__resource_initialise' before
	setting up pthreads.
	* unixlib/asm_dec.s (MEM_DALIMIT): Renamed from MEM_UNIXLIB_REAL_BREAK.
	(MEM_APPSPACE_LIMIT): Renamed from MEM_UNIXLIB_REAL_HIMEM.
	* sys/_syslib.s (__main): Use it.  In the non-dynamic area case
	do not set MEM_DALIMIT as it will remain unused throughout the
	execution of the application.
	* sys/_signal.s (__h_cback): Use 'MEM_APPSPACE_LIMIT'.

	* sys/stackalloc.c (__stackalloc_incr_wimpslot): Use 'appspace_limit'.
	If the request for increasing the wimpslot fails, don't adjust
	value of 'appspace_limit'.
	* sys/vfork.c (__fork_pre): Reference globals through '__ul_global'.
	(__fork_post): Use 'appspace_limit'.

Thu Apr 28 10:25:00 2005  Nick Burrett  <nick@sqrt.co.uk>

	* signal/post.c (sigsetup): Perform address validation for the
	user supplied signal handler function and the user supplied
	signal stack.
	(extract_name): New function.
	(sigsetup): In DEBUG mode, use 'extract_name' to provide the
	function name of the signal handler, where possible.  Improve
	general debugging information.
	(post_signal): Likewise.

Wed Apr 27 18:38:51 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/asm_dec.s (MEM_RWLOMEM): Renamed from MEM_UNIXLIB_RWLIMIT.
	(MEM_IMAGE_RW_LOMEM): Deleted.
	* unixlib/unix.h (struct ul_memory): Rename __unixlib_rwlimit
	to __rwlomem.
	Delete __image_rw_lomem.
	Constify __robase, __rwlomem and __rwbase as these values should
	never change during the execution of a program.
	* sys/_syslib.s (__main): Fixup accordingly.
	* debug/debug.c (__debug): Use __rwlomem instead of __image_rw_lomem.
	* resource/initialise.c (__resource_initialise): Likewise.
	* resource/ulimit.c (ulimit): Likewise.
	* sys/brk.c (__internal_brk): Likewise.
	(__unixlib_real_break): Delete extern reference.

	* string/_memcpy.s: AREA should be 'C$$code' as the 'C' defines
	the language type for the run-time environment, not the type
	of language used in the source unit.

Wed Apr 27 17:00:00 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/unix.c (struct ul_global): Move fields __image_rw_himem,
	__unixlib_stack, __robase, __unixlib_rwlimit,
	__image_rw_lomem, __unixlib_break, __unixlib_stack_limit,
	__rwbase, __unixlib_real_break, __unixlib_real_himem and __old_himem
	into new structure 'ul_memory'.
	Delete 'extern' declarations of those variables and therefore
	make them non-exportable.
	Delete '__image_ro_base' and convert all references to use '__robase'.
	* sys/syslib.s (__ul_global): Delete those fields from here and
	remove EXPORT lines.
	(__ul_memory): Declare.
	* unixlib/asm_dec.s (GBL_*): Adjust accordingly.
	(MEM_*): New definitions for referencing fields of 'ul_memory'.
	* common/funcallerr.c: Fix all occurances to the above variables to
	use 'ul_memory' structure and change references of '__image_ro_base'
	to '__robase'.
	* debug/debug.c: Likewise.
	* resource/initialise.c: Likewise.
	* resource/ulimit.c: Likewise.
	* signal/_signal.s: Likewise.
	* sys/_alloca.s: Likewise.
	* sys/_syslib.s: Likewise.
	* sys/_vfork.s: Likewise.
	* sys/exec.c: Likewise.
	* sys/vfork.c: Likewise.
	* sys/brk.c: Likewise and comes with improved code efficiency.
	* sys/stackalloc.c: Likewise.
	(REMOVE_FROM_FREELIST): Convert from a macro to an inline
	function.
	(ADD_TO_FREELIST): Likewise.

Wed Apr 27 12:14:41 2005  Nick Burrett  <nick@sqrt.co.uk>

	* stdlib/alloc.c: Cleanup code, remove WIN32 and non-STDC code.
	Re-write public facing functions to disable pthread context
	switching around internal malloc calls.
	Rename functions to be the correct C function names, rather than via
	some macro mangling.
	Drop strange-case in function names, renaming all to lower-case.
	Internal versions of malloc, free, realloc are renamed to an
	unlocked variant.
	(largebin_index): Delete i386 specific code.
	(malloc_init_state): Declare inline.
	(malloc_unlocked): Don't perform malloc initialisation check.
	(malloc_consolidate): Likewise.
	(iALLOc, iCALLOc, iCOMALLOc): Delete functions.
	(mUSABLe, mALLINFo, mSTATs, mALLOPt): Delete functions.
	(__ul_malloc_init): New function.

	* sys/_syslib.s (__main): Call __ul_malloc_init.
	(__ul_global): Add entries for '__mutex' and 'malloc_state'.
	
	* malloc.h (malloc_unlocked): Add prototype.
	(free_unlocked, realloc_unlocked): Add prototypes.
	(malloc_trim_unlocked): Add prototype.
	(__ul_malloc_init): Add prototype.
	* unixlib/asm_dec.s (GBL_OLD_HIMEM): Add.
	(GBL_MUTEX, GBL_MALLOC_GBL): Add.
	* unixlib/unix.h (struct ul_global): Add definition.
	(__ul_global): Declare.

	* pthread/atfork.c (pthread_atfork): Use __ul_global structure
	and use unlocked variants of malloc rather than SUL malloc.
	* pthread/context.c (__pthread_cleanup_idle): Likewise.
	* pthread/create.c (pthread_create): Likewise.
	* pthread/detach.c (pthread_detach): Likewise.
	* pthread/exit.c (pthread_exit): Likewise.
	* pthread/join.c (pthread_join): Likewise.
	* pthread/newnode.c (__pthread_new_node): Likewise.
	* pthread/pthinit.c (__pthread_prog_init: Likewise.

	* pthread/key.c (pthread_key_create): Use unlocked variants of
	malloc and ensure they are called with interrupts disabled.
	(pthread_key_delete): Likewise.
	(pthread_setspecific): Likewise.

	* debug/dvsprintf.c: Compile without stack-checking.
	* source/Makefile.in (debug/dvsprintf.o): New target.

	* unix/open.c (__open_fh): Type fixes for Norcroft [from Stefan
	Bellon].

Tue Apr 26 23:32:44 2005  John Tytgat  <John.Tytgat@aaug.net>

	* unixlib/dev.h (__getdevtype): Added explicit riscosify control
	parameter (not necessarily equal to the __get_riscosify_control()
	value).
	* unix/dev.c (__getdevtype): Likewise.
	* unix/stat.c: Likewise.
	(__fsclose): Don't close RISC OS filehandle when dflag
	FILE_HANDLE_FROM_OS bit is set.
	* unixlib/fd.h: Added comment.
	* unixlib/local.h (__open_fn): Renamed from __open().
	(__open_fh): Similar call to __open_fn() but instead of a filename,
	this gets a RISC OS file handle (from OS).
	* unix/open.c: Likewise.
	* unix/reopen.c: Likewise.
	* stdio/stdio.c: Capitalised first char of __unixlib_fatal() strings.
	* unix/unix.c: Likewise.
	(initialise_unix_io): Directly use the RISC OS filehandles in case of
	CLI redirection.  This results in a significant speed improvement.

Tue Apr 26 15:20:03 2005  Nick Burrett  <nick@sqrt.co.uk>

	Provide new internal debugging function.
	* sys/debug.h (debug_printf): Add prototype.
	* debug/dvsprintf.c: New file.
	* debug/debug.c: Moved here from sys/debug.c.  Re-written
	to use new 'debug_printf' function.
	* unix/unix.c: Use new debug_printf function.
	* sys/stackalloc.c: Likewise.

Mon Apr 25 19:28:15 2005  Nick Burrett  <nick@sqrt.co.uk>

	* sys/_mem.s: Delete file.

Mon Apr 25 13:32:29 2005  Stefan Bellon  <sbellon@sbellon.de>

	Norcroft compatibility.
	* math.h (isinf, isnan): Provide Norcroft specific definitions.
	* sys/cdefs.h (strong_alias): Fix typo in definition.
	* libm-complex/cabs.c: When __UNIXLIB_NO_COMPLEX is defined,
	do not compile functions that use complex types.
	* libm-complex/{cabsf.c, cabsl.c, carg.c, cargf.c}: Likewise.
	* libm-complex/{cargl.c, cimag.c, cimagf.c, cimagl.c}: Likewise.
	* libm-complex/{conj.c, conjf.c, conjl.c, creal.c}: Likewise.
	* libm-complex/{crealf.c, creall.c}: Likewise.
	* libm-generic/{s_cacos.c, s_cacosf.c, s_cacosh.c}: Likewise.
	* libm-generic/{s_cacoshf.c, s_casin.c, s_casinf.c}: Likewise.
	* libm-generic/{s_casinh.c, s_casinhf.c, s_catan.c}: Likewise.
	* libm-generic/{s_catanf.c, s_catanh.c, s_catanhf.c}: Likewise.
	* libm-generic/{s_ccos.c, s_ccosf.c, s_ccosh.c, s_ccoshf.c}: Likewise.
	* libm-generic/{s_cexp.c, s_cexpf.c, s_clog.c, s_clog10.c}: Likewise.
	* libm-generic/{s_clog10f.c, s_clogf.c, s_cpow.c, s_cpowf.c}: Likewise.
	* libm-generic/{s_cproj.c, s_cprojf.c, s_csin.c, s_csinf.c}: Likewise.
	* libm-generic/{s_csinh.c, s_csinhf.c, s_csqrt.c}: Likewise.
	* libm-generic/{s_csqrtf.c, c_ctan.c, s_ctanf.c, s_ctanh.c}: Likewise.
	* libm-generic/{s_ctanhf.c}: Likewise.

	* libm-generic/s_nextafter.c (nexttoward): Disable aliasing hack
	for Norcroft.
	* libm-generic/w_dremf.c (__dremf): ANSIify function definition.

	* libm-dbl64/s_isinf.c: For Norcroft, #undef __isinf.
	* libm-dbl64/s_isnan.c: For Norcroft, #undef __isnan.

	* string/memrchr.c: For Norcroft and LCC, define the double-underscore
	variant of the function name to the variant without.
	* string/strchrnul.c: Likewise.
	* string/strndup.c: Likewise.
	* string/strnlen.c: Likewise.
	
Sun Apr 24 22:11:02 2005  Alex Waugh  <alex@alexwaugh.com>

	* unix/unix.c (convert_command_line): Prevent >> type redirections
	  getting added to argv.

Sun Apr 24 21:24:36 2005  John Tytgat  <John.Tytgat@aaug.net>

	* sys/resource.h (getpriority): Use id_t instead of int.
	(setpriority): Likewise.
	* resource/getprior.c (getpriority): Likewise.
	* resource/setprior.c (setpriority): Likewise.
	* unixlib/dev.h (__getdevtype): const non-ptr return value doesn't
	make much sense therefore removed const.
	* unix/dev.c: Likewise.
	* unixlib/os.h: Relaxed several prototypes concerning __nonnull.
	* unixlib/sigstate.h (__backtrace_getfp): Return type is now void*
	instead of int*.
	(__ul_callbackfp): Changed type from int* to unsigned int*.
	* unix.h (struct __sul_process): Changed types of maxfd, fdsize,
	fdhandlesize and environ_size from int to unsigned int.
	Removed __OS_ARTHUR & __OS_RISCOS_* defines.
	(__decstrtoui): Changed constify end parameter.
	(__intenv): Decorated prototype with __nonnull and/or __wur.
	(__runtime_features): Likewise.
	(__atomic_modify): Likewise.
	(__unixlib_signal_initialise): Likewise.
	(__resource_initialise): Likewise.
	(__stackalloc): Likewise.
	(__free_stack_chain): Likewise.
	(__stackalloc_incr_wimpslot): Likewise.
	(__free_process): Likewise.
	(__get_program_name): Likewise & also renamed from get_program_name.
	* unix/unix.c (__decstrtoui): Changed constify end parameter.
	* netlib/htons.s (htons): Removed.
	* netlib/htonl.s (ntonl): Removed.
	* netlib/_bswap_16.s: Exported __bswap_16 as htons and ntohs.
	* netlib/_bswap_32.s: Exported __bswap_32 as htonl and ntohl.
	* netlib/getnameinfo.c: Compiler warning fixing.
	* signal/post.c: Likewise.
	* sys/debug.c: Likewise.
	* time/strftime.c: Likewise.
	* unix/dirent.c: Likewise.
	* unix/select.c: Likewise.
	* unix/sync.c: Likewise.
	* unix/syslog.c: Likewise.
	* unix/tty.c: Likewise.
	* unix/unlink.c: Likewise.
	* signal/_coredump.s (__backtrace_fp): Add functionname in object code.
	* signal/_signal.s: "Unixlib" -> "UnixLib".
	* sys/_syslib.s: Likewise.
	* unix/custom.c: Likewise.
	* stdio/rename.c (rename): Failure to delete destination file is no
	longer ignored.
	* sys/_os.s: CMP -> TEQ for consistency reasons.
	* sys/mman.c: Rename get_program_name to __get_program_name.
	* unix/features.c: Likewise.
	* unix/getenv.c: 0 -> NULL.
	* unix/nice.c (nice): Added unistd.h include to get nice() prototype.

Sun Apr 24 21:04:12 2005  Alex Waugh  <alex@alexwaugh.com>

	* common/unixify.c: Fix buffer overflow.

Sun Apr 24 12:34:09 2005  Peter Naulls  <peter@chocky.org>

	* clib/dirent.h, clib/grp.h: Make types used visible by including
	  sys/types.h instead.

Sun Apr 24 11:08:07 2005  Nick Burrett  <nick@sqrt.co.uk>

	* stdlib/atoll.c: New file.

Sun Apr 24 10:54:22 2005  Nick Burrett  <nick@sqrt.co.uk>

	* stdlib/strtoll.c: Import from FreeBSD, includes bug fixes.
	* stdlib/strtoull.c: Likewise.
	* limits.h: Add namespace visibility for _POSIX and _POSIX2 limits.
	(LLONG_MIN, LLONG_MAX, ULLONG_MAX): New ISO C99 limits.
	(WORD_BIT, LONG_BIT): New limits, defined for XOPEN.

Sat Apr 23 13:14:00 2005  Nick Burrett  <nick@sqrt.co.uk>

	Norcroft compatibility.
	* libm-generic/w_lgammal_r.c: Delete file.
	* libm-generic/e_lgammal_r.c: Delete file.
	* complex.h: No implementation for Norcroft or LCC compilers.
	* sys/cdefs.h (__UNIXLIB_NO_COMPLEX): Define for Norcroft and LCC
	compilers.

Sat Apr 23 11:51:31 2005  Stefan Bellon  <sbellon@sbellon.de>

	Norcroft compatibility.
	* time/setitmr.c (__inline): Renamed from __inline__.
	(__inline__): Delete macro as it is provided in sys/cdefs.h.
	* stdlib/alloc.c (mUSABLe): Compile out prototype.
	(mSTATs, mALLOPt, mALLINFo): Likewise.
	* search/lsearch.c (lfind): Casting fixes.
	(lsearch): Casting fixes.

	* libm-dbl64/s_nexttoward.c: Delete empty file.
	* libm-dbl64/{k_cos.c, k_sin.c, s_cos.c, e_acos.c}: Likewise.

Sat Apr 23 11:42:48 2005  Nick Burrett  <nick@sqrt.co.uk>

	Initial work on accessing internal UnixLib variables through
	one structure -- __ul_global.  Apply small optimisations
	based on a common symbol address.
	* unixlib/asm_dec.s (GBL_*): New definitions.
	* pthread/_context.s (__pthread_start_ticker): Use new __ul_global
	structure.
	(pthread_call_every): Likewise; improve code density.
	(__pthread_callback): Likewise.
	(__pthread_callback_semaphore): Delete.
	(__pthread_system_running): Delete.
	(__pthread_callback_missed): Delete.
	* pthread/_ints.s (__pthread_return_address): Delete.
	(__pthread_worksemaphore): Delete.
	* pthread/_yield.s (pthread_yield): Use __ul_global structure.
	* signal/_signal.s (raise): Use __ul_global structure.
	(__h_cback): Likewise.
	(__h_cback_common): Likewise.
	(__setup_signalhandler_stack): Likewise.
	(__executing_signalhandler): Delete.
	(__signalhandler_sl): Delete.
	(__signalhandler_sp): Delete.
	* pthread/context.c (__pthread_num_running_threads): Delete.
	* sys/_syslib.s (__main): Use 'GBL_' definitions for referencing
	__ul_global.
	(signalhandler_overflow): Likewise.
	(__unixlib_fatal): Likewise.
	(_kernel_fpavailable): Likewise.
	(__upcall_handler_addr): Move into __ul_global structure.
	(__upcall_handler_r12): Likewise.
	(__ul_global): Defined.  Renamed from 'struct_base'.
	(__upcall_handler_addr, __upcall_handler_r12): Define.
	(__pthread_return_address, __pthread_worksemaphore): Define.
	(__pthread_callback_semaphore, __pthread_system_running): Define.
	(__pthread_callback_missed): Define.
	(__pthread_num_running_threads): Define.
	(__executing_signalhandler): Define.
	(__signalhandler_sl, __signalhandler_sp): Define.

	* pthread/atfork.c (pthread_atfork): If called, set
	__pthread_system_running.

Fri Apr 22 15:33:14 2005  Nick Burrett  <nick@sqrt.co.uk>

	Norcroft compatibility.
	* unixlib/asm_dec.s (__get_errno): Change PTHREADS check to
	__UNIXLIB_ERRNO_THREADED.  Import 'errno' symbol only
	when ERRNO_THREADED is 0.
	(__set_errno): Likewise.
	* sys/_syslib.s (errno): Delete definition as it breaks Norcroft
	assembler.
	* stdlib/errno.c: New file.

	* sys/cdefs.h: Provide Norcroft and LCC specific macro definitions.
	(__SYS_CDEFS_H): Renamed from _SYS_CDEFS_H.
	* features.h: Use __SYS_CDEFS_H.

	* signal/_signal.s (__seterr): Check __pthread_running_thread
	is valid and exit fatally if not.

	* signal/post.c (__valid_address): Delete function.  To preserve
	stack space during signal handling, re-write in assembler.
	* sys/_syslib.s (__valid_address): New function.

	Fix pthread race conditions and improve commentary.
	* pthread/_context.s (__pthread_callback): Check that we are
	actually going to perform a context switch before setting up
	an otherwise unnecessary signal handler stack.  Turn IRQs off
	earlier, therefore setting more internal state without the chance
	of interruption.
	(skip_contextswitch): Fall through rather than using common code
	of the old callback_return.
	* pthread/newnode.c (__pthread_new_node): Use SUL memory functions
	for allocating space for pthread structure to prevent a race
	condition between 'free' and __pthread_cleanup_idle.
	* pthread/contex.c (__pthread_cleanup_idle): Use the SUL memory
	functions.
	* pthread/create.c (pthread_create): Don't call __pthread_init.
	Set __pthread_system_running directly.  Use SUL memory functions.
	* pthread/detach.c (pthread_detach): Use SUL memory functions.
	* pthread/exit.c (pthread_exit): Enable interrupts around call
	to __pthread_exit to prevent possible assertion failure when
	freeing 'alloca' chains.
	* pthread/join.c (pthread_join): Use SUL memory functions.
	* pthread/pthinit.c (__pthread_prog_init): Allocate 'saved_context'
	memory here.
	(__pthread_init): Delete function and move useful functionality
	into __pthread_prog_init.
	* pthread.h (__pthread_init): Delete prototype.
	
	Compilation fixes.
	* common/fdname.c (__fd_to_name): Add explicit cast for malloc.
	* common/riscosify.c (__sfixinit): Likewise.
	* common/unixify.c (__unixify): Likewise.
	* crypt/crypt-entry.c: Convert function definitions to ISO-C form.
	* crypt/crypt_util.c: Likewise.
	(_ufc_clearmem, _ufc_copymem): Ensure we use 'memset' and 'memcpy'
	rather than slow internal versions.
	* crypt/md5-crypt.c: Convert function definitions to ISO-C form.
	(b64t): Fix array size.
	* crypt/md5.c: Convert function definitions to ISO-C form.
	* gdtoa/dmisc.c (nrv_alloc): Constify 's'.
	* gdtoa/gdtoaimp.h (nrv_alloc): Fix prototype accordingly.

Fri Apr 22 09:32:50 2005  Nick Burrett  <nick@sqrt.co.uk>

	* dirent.h (alphasort): Change to BSD and MISC visibility.

Thu Apr 21 16:53:32 2005  Nick Burrett  <nick@sqrt.co.uk>

	Norcroft compatibility.
	* libm-dbl64/tbl_asincos.h: Renamed from asincos.tbl.
	* libm-dbl64/tbl_powtwo.h: Renamed from powtwo.tbl
	* libm-dbl64/tbl_root.h: Renamed from root.tbl
	* libm-dbl64/tbl_sincos.h: Renamed from sincos.tbl
	* libm-dbl64/tbl_uatan.h: Renamed from uatan.tbl
	* libm-dbl64/tbl_uexp.h: Renamed from uexp.tbl
	* libm-dbl64/tbl_ulog.h: Renamed from ulog.tbl
	* libm-dbl64/tbl_upow.h: Renamed from upow.tbl
	* libm-dbl64/tbl_utan.h: Renamed from utan.tbl
	* libm-dbl64/dosincos.c: Use new filenames.
	* libm-dbl64/{e_asin.c, e_atan2.c, e_exp.c, e_log.c}: Likewise.
	* libm-dbl64/{e_pow.c, e_sqrt.c, s_atan.c, s_sin.c}: Likewise.
	* libm-dbl64/s_tan.c: Likewise.

	* unixlib/buildoptions.s: Commit auto-generated file.

Thu Apr 21 16:02:24 2005  Nick Burrett  <nick@sqrt.co.uk>

	* pthread/sem.c (sem_check_validity): New function.
	(sem_alloc): Delete function; incorporate into sem_init.
	(sem_init): 'sem' is already allocated memory; use it rather than
	making our own internal allocation with malloc.
	(sem_free): No need to free sem structure here.  Make inline.
	(sem_destroy): Always check for errors using sem_check_validity.
	(sem_trywait): Likewise.
	(sem_post): Likewise.
	(sem_getvalue): Likewise.
	(sem_wait): Likewise.  Cope with an empty usem_waiters queue.
	Add PTHREAD_SAFE_CANCELLATION.

Wed Apr 20 18:10:04 2005  Nick Burrett  <nick@sqrt.co.uk>

	* stpcpy.c: Move into string subdirectory.
	* stpncpy.c, strcat.c, strchr.c, strcmp.c, strcspn.c: Likewise.
	* strdup.c, strichr.c, stricmp.c, strncat.c: Likewise.
	* strncmp.c, strncpy.c, strnicmp.c, strpbrk.c: Likewise.
	* strrchr.c, strrichr.c, strsep.c, strsignal.c: Likewise.
	* strspn.c, strstr.c, strtok.c, strtok_r.c: Likewise.
	* strtol.c, strtoll.c, index.c, memccpy.c: Likewise.
	* memchr.c, memcmp.c: Likewise.

	* strtoumax.c: Move into inttypes subdirectory.
	* strtoimax.c: Likewise.

	* strtol.c: Move into stdlib subdirectory.
	* strtoll.c, strtoul.c, strtoull.c: Likewise.
	* abort.c, atexit.c, bsearch.c, div.c, qsort.c: Likewise.
	* alloc.c, system.c: Likewise.

	* assert.c: Move into assert subdirectory.

	* ctype.c: Move into ctype subdirectory.
	* ctypeproc.c: Likewise.

	* opensock.c: Move into resolv subdirectory.

	* psignal.c: Move into signal subdirectory.

	* termcap.c: Move into termios subdirectory. 

Wed Apr 20 17:54:40 2005  Nick Burrett  <nick@sqrt.co.uk>

	* stdio/vfprintf.c (__vfprintf): Output of printf("%#.0o", 0)
	should print 0.
	* stdio/fwrite.c (fwrite): When handling fd of -1, return early
	if we have no space in the output buffer.
	* signal/post.c (__write_backtrace): Account for 26-bit mode
	when disassembling.

Wed Apr 20 14:15:44 2005  Nick Burrett  <nick@sqrt.co.uk>

	Norcroft compatibility.
	* stdio.h (__vfprintf): Add prototype.
	* stdio/vfprintf.c (__find_arguments [TP_SIZET]): Use 'size_t'
	[from Stefan Bellon].
	* stdio/printf.c (vsnprintf): Remove '__' from function name.
	(vsprintf, snprintf, sprintf): Likewise.
	(vprintf, fprintf, printf): Likewise.
	* internal/math.h: Add macros to remove the double-underscores
	from function.
	* libm-generic/s_fma.c: Include math_private.h to pick up this change.
	* libm-generic/s_fmaf.c: Likewise.
	* libm-generic/s_fdim.c: Likewise.
	* libm-generic/s_fdimf.c: Likewise.
	* libm-generic/s_fmax.c: Likewise.
	* libm-generic/s_fmaxf.c: Likewise.
	* libm-generic/s_fmin.c: Likewise.
	* libm-generic/s_fminf.c: Likewise.
	* libm-generic/s_cacos.c: Likewise.
	* libm-generic/s_cacosf.c: Likewise.
	* libm-generic/s_casin.c: Likewise.
	* libm-generic/s_casinf.c: Likewise.
	* libm-generic/s_casinh.c: Likewise.
	* libm-generic/s_casinhf.c: Likewise.
	* libm-generic/s_ccos.c: Likewise.
	* libm-generic/s_ccosf.c: Likewise.
	* libm-generic/s_cpow.c: Likewise.
	* libm-generic/s_cpowf.c: Likewise.
	* libm-generic/s_cproj.c: Likewise.
	* libm-generic/s_cprojf.c: Likewise.
	* libm-generic/s_nan.c: Likewise.
	* libm-generic/s_nanf.c: Likewise.
	* libm-generic/w_drem.c: Likewise.

	* sys/types.h (ino_t): Define.
	* dirent.h (ino_t): Only define if __USE_XOPEN.

	* unixlib/buildoptions.h: Add comment to remind us why defining
	__UNIXLIB_ERRNO_THREADED is a bad idea.
	
Tue Apr 19 19:52:29 2005  Nick Burrett  <nick@sqrt.co.uk>

	* iconv.h (EILSEQ): Kill definition.
	
Tue Apr 19 19:28:59 2005  Nick Burrett  <nick@sqrt.co.uk>

	Make threaded 'errno' a compile time option.
	* unixlib/buildoptions.h (__UNIXLIB_ERRNO_THREADED): Define as zero.
	* pthread/context.c (__pthread_context_switch): When above
	macro is zero, save the global errno between context switches.
	* errno.h (errno): Only use the threaded version if
	__UNIXLIB_FEATURE_PTHREADS and __UNIXLIB_ERRNO_THREADED are
	non-zero.
	* sys/_syslib.s (errno): Define if __UNIXLIB_ERRNO_THEADED is
	non-zero.

Tue Apr 19 09:48:33 2005  Stefan Bellon  <sbellon@sbellon.de>

	Norcroft compatibility.
	* unixlib/asm_dec.s (__set_errno): IMPORT __pthread_running_thread.
	(__get_errno): Likewise.
	* signal.h (sigpause): Fix comment termination typo.
	* common/riscosify.c (sfix_hash): Use __inline for Norcroft
	compatibility.
	* locale/iconv.c: Change ordering of includes.
	(iconv_open): Add explicit cast to return value.
	* stdio/asprintf.c: Include stdio.h
	(asprintf): Renamed from __asprintf.
	* stdio/vasprintf.c (vasprintf): Renamed from __vasprintf.
	* sys/_syslib.s (errno): Fix __UNIXLIB_FEATURE_PTHREADS check.
	* stdlib/atof.c: New file.

Mon Apr 18 22:25:46 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/stdcmac.h: Delete file.
	* unixlib/stdsmac.s: Delete file.
	* unixlib/buildoptions.h: Reformat and remove 'COMMENT' and 'END'.
	* source/Makefile.in (clib/unixlib/buildoptions.s): New target.
	* unixlib/asm_dec.s: Use it rather than buildoptions.h
	* gen-makefiles.pl: For assembler files, depend on buildoptions.s.

	* pthread/context.c (__pthread_context_switch): Don't save/restore
	global errno between contexts.

Mon Apr 18 20:40:46 2005  Nick Burrett  <nick@sqrt.co.uk>

	* errno.h: Use correct path to features.h.
	* features.h: Move the inclusion of unixlib/stdcmac.h and
	unixlib/buildoptions.h outside of __UNIXLIB_INTERNALS.

Mon Apr 18 20:27:21 2005  Nick Burrett  <nick@sqrt.co.uk>

	* errno.h: Change #ifdef to #if for __UNIXLIB_FEATURE_PTHREADS.

Mon Apr 18 18:03:56 2005  Nick Burrett  <nick@sqrt.co.uk>

	Make 'errno' thread local.
	Add option to __seterr to prevent the setting of 'errno',
	rename to __ul_seterr and update all callers.
	* signal/_signal.s (__ul_seterr): Renamed from '__seterr'.
	If 'a2' is non-zero, then do not set errno.
	Perform NULL-check on __pthread_running_thread.
	* unixlib/os.h (__ul_seterr): Add seterrno parameter to prototype.
	* unixlib/asm_dec.s (__set_errno): For thread support, use the
	local thread errno rather than the global errno.
	(__get_errno): Likewise.
	* errno.h (__set_errno): Likewise.
	* errno.c: Delete file.
	* sys/_syslib.s (errno): Define when not compiling with thread
	support.
	
	* pthread/pthinit.c (__pthread_prog_init): Die if __pthread_new_node
	fails.

	* gdtoa/gdtoaimp.h (ACQUIRE_DTOA_LOCK): Check __pthread_system_running
	rather than __pthread_running_thread.
	(FREE_DTOA_LOCK): Likewise.
	
	* common/fdname.c (__fd_to_name): Don't set errno.
	* common/objattr.c (__object_get_attrs): Likewise.
	(__object_set_attrs): Likewise.
	* locale/iconv.c (iconv_error): Likewise.
	* netlib/_net_error.s (__net_error): Likewise.
	* unix/chmod.c (chmod): Likewise.
	* unix/dev.c (__fsfsstat): Likewise.
	* unix/dirent.c (readdir_r): Likewise.
	* unix/fchmod.c (fchmod): Likewise.
	* unix/rmdir.c (rmdir): Likewise.

	* locale/iconv.c (iconv_open): Set errno.
	* sound/dsp.c (__dspopen): Likewise.
	(__dspwrite): Likewise.
	* sys/mman.c (munmap): Likewise.
	(mremap): Likewise.
	* time/clk_gettime.c (clock_gettime): Likewise.
	* time/gettod.c (gettimeofday): Likewise.
	* time/time.c (time): Likewise.
	* unix/chdir.c (chdir): Likewise.
	* unix/dev.c (__fsopen): Likewise.
	(__fsclose, __fsread, __fswrite, __fslseek): Likewise.
	(__randomopen, __randomread): Likewise.
	* unix/dirent.c (newstream): Likewise.
	* unix/getcwd.c (getcwd): Likewise.
	* unix/getenv.c (__getenv_from_os): Likewise.
	* unix/gethostnam.c (fakehostname): Likewise.
	* unix/mkdir.c (mkdir): Likewise.
	* unix/setenv.c (__addenv_to_os): Likewise.
	* unix/sync.c (fsync): Likewise.
	* unix/truncate.c (ftruncate): Likewise.
	(truncate): Likewise.
	* unix/unlink.c (unlink): Likewise.
	* unix/utime.c (utime): Likewise.
	* scl/_kswi.s: Likewise.
	* scl/_ksetenv.s: Likewise.
	* scl/_kosrdch.s: Likewise.
	* scl/_kosgbpb.s: Likewise.
	* scl/_kosfind.s: Likewise.
	* scl/_kosfile.s: Likewise.
	* scl/_koscli.s: Likewise.
	* scl/_kosbyte.s: Likewise.
	* scl/_kosargs.s: Likewise.
	* scl/_kgetenv.s: Likewise.
	* scl/_kernel.s: Likewise.
	
	* unix/unix.c (__unixinit): Drop call to '__seterr'.
	* scl/_kosbput.s: Likewise.
	* scl/_kosbyte.s: Likewise.

	* unix/rename.c (rename): Set 'errno'.  Don't need to preserve 'errno'
	across function.

	* sys/mman.c (__munmap_all): Remove PTHREAD_UNSAFE as the thread
	system should not be running at this time.

	* scl/_koswrch.s: Delete file.
	* scl/_kosword.s: Delete file.
	* sys/_os.s (__os_vdu): Define _kernel_oswrch to the same function.
	Set return value to zero on success.
	(__os_word): Simarly for _kernel_osword.
	
Mon Apr 18 14:44:24 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unix/getpagesiz.s: Delete file.
	* unistd/getpagesiz.c: New file.
	* sys/_syslib.s (__main): Call XOS_ReadMemMapInfo and store the
	system page size.
	(__ul_pagesize): Define.
	* unixlib/unix.h (__ul_pagesize): Declare.
	* sys/mman.c (page_size): Delete.
	(page_align): Define in terms of __ul_pagesize.
	(mmap): Don't call 'getpagesize', use the internal variable directly.
	* unix/sysconf.c (sysconf): Likewise.
	* alloc.c (malloc_getpagesize): Use __ul_pagesize.

	Make the malloc functions thread safe.
	* alloc.c (USE_MALLOC_LOCK): Define.
	(MALLOC_PREACTION): Check pthread system is running first.
	(MALLOC_POSTACTION): Likewise.
	(mALLOc): Delete PTHREAD_UNSAFE.
	(fREe): Likewise.
	(rEALLOc): Likewise.
	(mEMALIGn): Likewise.
	(cALLOc): Likewise.
	(iALLOc): Likewise.
	(vALLOc): Likewise.
	(pVALLOc): Likewise.
	(mTRIm): Likewise.

Mon Apr 18 12:26:48 2005  Peter Naulls  <peter@chocky.org>

	* source/unix/rmdir.c, clib/unixlib/unix.h: Improve language.
	* clib/unixlib/dev.h, source/unix/custom.c: Add a function to
	  hide some internal structures from programs trying to override
	  file descriptor handling. 

Thu Apr 14 23:59:26 2005  John-Mark Bell  <jmb@netsurf-browser.org>

	* endian.h: Update missed file

Thu Apr 14 17:01:30 2005  Nick Burrett  <nick@sqrt.co.uk>

	* search.h: New file.
	* search/insremque.c: New file.
	* search/lsearch.c: New file.
	* search/hsearch.c: New file.
	* search/hsearch_r.c: New file.
	* search/tsearch.c: New file.

	* signal.h: Improve namespace and type conformance.
	Add GCC's 'nonnull' attribute to prototypes.
	Remove __THROW for any functions that are cancellation points.
	* time.h: Likewise.
	* pthread/pthsignal.c (sigwait): Mark as a safe cancellation point.

Thu Apr 14 16:15:32 2005  Nick Burrett  <nick@sqrt.co.uk>

	* clib/unixlib/swiparams.h: Move file ...
	* incl-local/internal/swiparams.h: ... here.

	* clib/unixlib/tty.h: Move file ...
	* incl-local/internal/tty.h: ... here.

	* common/objattr.c: Use new swiparams.h location.
	* common/riscosify.c: Likewise.
	* common/unixify.c: Likewise.
	* sound/dsp.c: Likewise.
	* stdio/rename.c: Likewise.
	* unix/chmod.c: Likewise.
	* unix/custom.c: Likewise.
	* unix/dev.c: Likewise.
	* unix/dirent.c: Likewise.
	* unix/fchmod.c: Likewise.
	* unix/fstat.c: Likewise.
	* unix/mkdir.c: Likewise.
	* unix/rmdir.c: Likewise.
	* unix/stat.c: Likewise.
	* unix/unix.c: Likewise.
	* unix/unlink.c: Likewise.
	* unix/utime.c: Likewise.

	* unixlib/unix.h: Use new tty.h location.
	* unix/tty.c: Likewise.

Thu Apr 14 15:26:01 2005  Nick Burrett  <nick@sqrt.co.uk>

	Import an accurate IEEE math library
	* bits/fenv.h: New file.
	* bits/huge_valf.h: New file.
	* bits/huge_vall.h: New file.
	* bits/huge_val.h: Split into its constituent parts.
	* bits/inf.h: New file.
	* bits/nan.h: Use builtin for GCC 3.3 and later.
	* bits/cmathcalls.h: Bring in line with new math library.
	* bits/mathcalls.h: Likewise.
	* bits/mathdef.h: Likewise.
	* bits/mathinline.h: Likewise.
	* fenv.h: Likewise.
	* math.h: Likewise.
	* complex.h: Likewise.
	* fpu_control.h: New file.
	* ieee754.h: Moved here from machine/ieee754.h.
	* endian.h: Moved here from machine/endian.h.

	* complex: Delete directory.
	* math: Delete directory.
	* math-asm: Delete directory.

	* fenv: New directory.
	* libm-complex: New directory.
	* libm-dbl64: New directory.
	* libm-flt32: New directory.
	* libm-generic: New directory.
	* libm-support: New directory.

	* fpu_control.h (__unixlib_get_fpstatus): Moved here from
	unixlib/unix.h.
	(__unixlib_set_fpstatus): Likewise.
	* unixlib/unix.h: Delete above prototypes.

	* incl-local: New directory.  Container for all UnixLib build
	specific header files.
	* incl-local/README: New file.
	* incl-local/math_private.h: New file, for source code compatibility
	with main libm library.
	* incl-local/internal/math.h: Renamed from unixlib/math.h
	and updated for new IEEE math library.

	* Makefile.in (INCLUDES): Use 'incl-local'.
	(LIBM_FLAGS): Define.
	(CROSS_CFLAGS): Include LIBM_FLAGS.
	(WARNINGS): Drop -Wno-long-long.
	* gen-makefiles.pl (find_headers): Support multiple include dirs.
	Search 'incl-local' for headers.

	* clib/stdio_ext.h: Delete file.
	* incl-local/stdio_ext.h: New blank file.
	* clib/stdio-common/stdio_ext.h: Delete file.

	* unixlib/os.h (__os_swi): Remove __wur.
	(__os_byte): Remove __nonnull and __wur.

Thu Apr 14 13:12:07 2005  Nick Burrett  <nick@sqrt.co.uk>

	* grp.h: Improve namespace and type conformance.
	Add GCC's 'nonnull' attribute to prototypes.
	Remove __THROW for any functions that are cancellation points.
	* kernel.h: Likewise.
	* locale.h: Likewise.
	* nl_types.h: Likewise.
	* pwd.h: Likewise.
	* unixlib/os.h: Likewise.
	* semaphore.h: Likewise.

	* locale/iconv.c (iconv_open): Add PTHREAD_SAFE_CANCELLATION.
	Use __os_swi rather than _swix.  Specify a minimum module version
	of 0.04.
	(iconv): Likewise.
	(iconv_close): Likewise.

	* grp/fgetgrent.c (fgetgrent): Add PTHREAD_UNSAFE_CANCELLATION.
	* grp/getgrgid.c (getgrgid): Likewise.
	* grp/getgrnam.c (getgrnam): Likewise.
	* grp/fgetgrentr.c (fgetgrentr): Add PTHREAD_SAFE_CANCELLATION.
	* grp/getgrgid_r.c (getgrgid_r): Likewise.
	* grp/getgrnam_r.c (getgrnam_r): Likewise.
	* grp/getgrent.c (getgrent): Add PTHREAD_UNSAFE_CANCELLATION.
	(setgrent): Likewise.
	(endgrent): Likewise.
	(getgrent_r): Mark as a safe cancellation point.
	* grp/getgroups.c (initgroups): Change to PTHREAD_UNSAFE_CANCELLATION.
	(getgroups): Likewise.
	* pwd/fgetpwent.c (fgetpwent): Mark as an unsafe cancellation point.
	* pwd/getlogin.c (getlogin): Likewise.
	* pwd/fgetpwentr.c (fgetpwentr): Mark as a safe cancellation point.
	* pwd/getpwnam_r.c (getpwnam_r): Likewise.
	* pwd/getpwuid_r.c (getpwuid_r): Likewise.
	* pwd/getpwent.c (getpwent_r): Likewise.
	(getpwent): Make as an unsafe cancellation point.
	(endpwent): Likewise.
	(setpwent): Likewise.
	* pwd/getpwnam.c (getpwnam): Likewise.
	* pwd/getpwuid.c (getpwuid): Likewise.
	* pwd/putpwent.c (putpwent): Likewise.

	* stdio.h (struct __iobuf): Add 'lock' as a placeholder for
	multithreaded I/O support.
	(fgets): Fix definition.
	* stdio/fgets.c (fgets): Fix function definition.

	* pthread.h (struct __pthread_thread): Rename 'param' to '__param'.
	Add '__policy'.
	(pthread_getschedparam): Fix prototype.
	* pthread/schedparam.c (pthread_getschedparam): Fix function
	definition and get thread policy.
	(pthread_setschedparam): Set thread policy.

	* ulimit.h (ulimit): Correct prototype.
	* resource/ulimit.c (ulimit): Function takes a variable number
	of args.  Adjust accordingly.

	* unistd.h (sync): Function never returns a result
	* unix/sync.c (sync): Don't bother with any errors returned
	by __os_args call.
	(fsync): Mark that this is a cancellation point.

	* dirent.h (ino_t): Define here.
	* sys/types.h (ino_t): Remove definition from here.

	* abs.c: Delete file.
	* stdlib/abs.c: New file.
	* stdlib/labs.c: New file.
	* stdlib/llabs.c: New file.

	* pthinit.c: Renamed from init.c for ELF compatibility.
	* pthsignal.c: Renamed from signal.c for ELF compatibility.
	
Wed Apr 13 20:17:24 2005  Nick Burrett  <nick@sqrt.co.uk>

	* sys/cdefs.h (__NTH): Declare for non-GCC compilers.
	(__attribute_warn_unused_result__): Declare.
	(__wur): Declare (shorthand for above).

	* string.h: Improve namespace and type conformance.
	Add GCC's 'nonnull' attribute to prototypes.
	Remove __THROW for any functions that are cancellation points.
	* sys/stat.h: Likewise.
	* sys/select.h: Likewise.
	* sys/resource.h: Likewise.
	* netdb.h: Likewise.
	* crypt.h: Likewise.
	* dirent.h: Likewise.
	* fcntl.h: Likewise.
	* setjmp.h: Likewise.
	* stdio.h: Likewise.
	* stdlib.h: Likewise.
	* unistd.h: Likewise.

	* sys/resource.h (ulimit): Remove declaration.
	(nice): Likewise.
	* ulimit.h: New file.
	* unistd.h (nice): Add prototype.
	* resource/ulimit.c: Include ulimit.h.
	
	* alloca.h (alloca): Remove __THROW.  Add GCC variant.
	* assert.h (assert): Add noreturn attribute.
	(__ASSERT_CAST): Define with better C++ support.
	(assert): Use it.

	* ctype.h (isascii): Set visibility for SVID, MISC and XOPEN only.

	* iconv.h: Don't include errno.h.
	(iconv): Add 'restrict' to certain parameters.
	* locale/iconv.c: Include errno.h.

	* sys/select.h (__NFDBITS): Rename from NFDBITS.  Define sizeof
	in terms of variable name, rather than type.
	(__FDELT): Rename from FDELT.
	(__FDMASK): Rename from FDMASK.
	(__fd_set): Fix according to new macro names.
	(FD_SET): Likewise.
	(FD_CLR): Likewise.
	(FD_ISSET): Likewise.
	(fd_mask): Only define if __USE_MISC.
	(select): Add C99's 'restrict' qualifier.
	(pselect): Likewise.

	* sys/stat.h (struct stat): Change the types of 'st_blksize'
	and 'st_blocks'.

	* sys/time.h (timeradd): Define.
	(timersub): Define.

	* unix/dirent.c (opendir): Mark as an unsafe cancellation point.
	(readdir_r): Likewise.
	(readdir): Likewise.
	(closedir): Likewise.
	(scandir): Likewise.

	* features.h (BSD): Undefine.
	(__builtin_expect): Only undefine for non-GCC compilers.
	(__GLIBC_PREREQ): Delete macro.
	(__ULIBC_PREREQ): Define macro.
	* resolv/gethnamaddr.c (BSD): Define.

	* pthread.h: Make compatible with C++.
	(pthread_setschedparam): Add prototype.
	(pthread_getschedparam): Add prototype.
	(struct __pthread_thread): Add 'param'.
	* schedparam.c: New file.

	* time/time.c (time): Fix shadow parameter warning.
	* time/setitmr.c (add_ticker): Likewise.
	(check_ticker): Likewise.
	* resource/getrusage.c (getrusage): Likewise.
	* time/strftime.c (strftime): Likewise.
	(territory_convert): Adjust prototype to reduce warnings.
	(territory_standard): Likewise.
	* signal/post.c (__write_backtrack): Fix printf warnings.
	* crypt/crypt.c (_ufc_doit_r): Use ANSI-style declarations.
	* common/unixify.c (__unixify): Add parenthesis to resolve an
	ambiguity.
	* bsearch.c (bsearch): Fix warnings.

Fri Apr  8 23:31:14 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/unixlib/unix.h (__escape_disabled): Define variable.
	* source/unix/unix.c: Record if the escape key is disabled on
	  program initialisation.
	* source/sys/vfork.c: Disable escape on return to parent if necessary.
	* source/unix/tty.c (__tty_console_gterm, __tty_console_sterm): Don't
	  alter escape status if it was disabled.
	  (__tty_console_swinsz): Don't set the text window size when running
	  in a taskwindow.

Fri Apr  8 20:20:41 2005  Nick Burrett  <nick@sqrt.co.uk>

	* common/attrib.c (__set_protection): When translating,
	take into account group ownerships.
	(__get_protection): Likewise.

Fri Apr  8 20:12:29 2005  Nick Burrett  <nick@sqrt.co.uk>

	* string/_ffs.s (ffs): Be a 'ffs' rather than a 'clz' algorithm.

Fri Apr  8 18:02:00 2005  Nick Burrett  <nick@sqrt.co.uk>

	Improve accuracy of converting IEEE numbers to ASCII, fix
	many formatting errors in printf and add C99 conformance.

	* gdtoa/{arith.h, fpmath.h, gdtoa.h, gdtoaimp.h}: New files.
	* gdtoa/{dmisc.c, dtoa.c, g_ddfmt.c, g_dfmt.c}: New files.
	* gdtoa/{gdtoa.c, gethex.c, g_ffmt.c, g__fmt.c}: New files.
	* gdtoa/{glue.c, gmisc.c, g_Qfmt.c, g_xfmt.c}: New files.
	* gdtoa/{g_xLfmt.c, hd_init.c, _hdtoa.c, hexnan.c}: New files.
	* gdtoa/{_ldtoa.c, misc.c, smisc.c, strtod.c}: New files.
	* gdtoa/{strtodg.c, strtodI.c, strtof.c, strtoId.c}: New files.
	* gdtoa/{strtoIdd.c, strtoIf.c, strtoIg.c, strtoIQ.c}: New files.
	* gdtoa/{strtoIx.c, strtoIxL.c, strtopd.c, strtopdd.c}: New files.
	* gdtoa/{strtopf.c, strtopQ.c, strtopx.c, strtopxL.c}: New files.
	* gdtoa/{strtord.c, strtordd.c, strtorf.c, strtorQ.c}: New files.
	* gdtoa/{strtorx.c, strtorxL.c, sum.c, ulp.c}: New files.
	* gdtoa/README: New file.

	* strtod.c: Remove file.  Replaced by the gdtoa library.
	* stdlib/strtof.c: Likewise.

	* stdio/vfprintf.c: New file, taken from FreeBSD libc.
	* stdio/printf.c (vfprintf): Delete function.
	* stdio/floatio.h: New file.

	* stdio/fwrite.c (fwrite): Special handling of a file descriptor
	of -1, for new vfprintf function.

	* stdio/asprintf.c: New file.
	* stdio/vasprintf.c: New file.
	* stdio.h (vasprintf): Add prototype.
	(asprintf): Add prototype.

	* bits/nan.h (NAN): For GCC 3.3 and later, use the builtin.
	* bits/byteswap.h: Re-enable __bswap_64.
	* string/byteswap.h (__BYTESWAP_H): Renamed from _BYTESWAP_H for
	consistency with other header files.

	* stdio.h (vfprintf): Remove __THROW on functions that are
	cancellation points.
	(vfprintf): Likewise.
	(fprintf): Likewise.
	(printf): Likewise.
	(fscanf): Likewise.
	(vscanf): Likewise.
	(vfscanf): Likewise.
	* unistd.h (sleep): Likewise.
	(usleep): Likewise.

Thu Apr  7 19:44:29 2005  Nick Burrett  <nick@sqrt.co.uk>

	* features.h (__STDC_ISO_10646__): Don't use C99 comments.
	(___program_name): Don't define if compiling for ELF.
	(___dynamic_da_name): Likewise.
	(__program_name): If compiling for ELF, then add WEAK attribute.
	(__dynamic_no_da): Likewise.
	(__dynamic_da_name): Likewise.
	(__dynamic_da_max_size): Likewise.

	* unixlib/buildoptions.h (__UNIXLIB_ELF): Define, temporarily.

	* sys/_syslib.s (no_dynamic_area): Don't reserve 128 bytes of
	stack for Objective-C.
	(___program_name): If compiling for ELF, then don't export.
	(___dynamic_da_name): Likewise.
	(___dynamic_da_max_size): Likewise.
	(___dynamic_no_da): Likewise.
	(__check_chunk_l2): Use MOV rather than old 'return' MACRO.
	(__unixlib_fatal_got_msg): Use SWI calls direct.
	(__robase): Provide ELF alternative.
	(__unixlib_rwlimit): Likewise.
	(__rwbase): Likewise.

	* sys/mman.c (__munmap_all): Provide ELF alternative for accessing
	__dynamic_da_name.
	* unix/features.c (get_program_name): Similarily for __program_name.

Thu Apr  7 19:37:19 2005  Nick Burrett  <nick@sqrt.co.uk>

	* common/riscosify.c (__sdirinit): Use __os_swi rather than
	_kernel_swi.

Thu Apr  7 19:36:09 2005  Nick Burrett  <nick@sqrt.co.uk>

	* sys/_os.s (__os_prhex): Build buffer directly.
	(__os_setfiletype): New function.

	* sys/os.h (__os_setfiletype): Add prototype.

Thu Apr  7 19:33:46 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unix/unix.c (convert_command_line): Cope with arguments that
	are effectively empty strings.

Thu Apr  7 19:31:46 2005  Nick Burrett  <nick@sqrt.co.uk>

	* sys/cdefs.h (__nonnull): Define.
	(__THROW): Update for later GCC releases.
	(__NTH): Likewise.
	(strong_alias): Define.
	(weak_alias): Define.
	(hidden_def): Define.
	(libm_hidden_def): Define.
	(INTDEF): Define.
	* stdlib.h (atof): Remove __THROW from inline version.
	(atoi): Likewise.
	(atol): Likewise.
	(atoll): Likewise.
	* math/llrintf.c: Fix weak_alias decl.
	* math/lrintf.c: Likewise.
	* resolv/inet_addr.c: Likewise.
	* netlib/getpeernam.c (getpeername): Remove __THROW from decl.
	* sys/mount.c (mount): Likewise.
	(umount): Likewise.
	(umount2): Likewise.

Wed Apr  6 21:10:21 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/dirent.c (opendir): Remove check on whether
	  __riscosify returned a filetype.

Tue Apr  5 22:30:34 2005 Peter Naulls  <peter@chocky.org>

	* source/string/_memset.s: Fixed version of Adrian's memset.
	* source/clib/unixlib/dev.h, source/unix/custom.c,
	  source/unix/dev/c: Custom device handling.

Tue Apr  5 22:09:32 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/termios/tcdrain.c (tcdrain): Remove ioctls that have
	  no effect.
	* source/termios/tcgetattr.c (tcgetattr): Use a single ioctl to get
	  the attrs directly and avoid loss in converting between formats.
	* source/termios/tcsetattr.c (tcsetattr): Likewise.

Mon Apr  4 19:37:26 2005 Peter Naulls  <peter@chocky.org>

	* source/string/_memset.s: Revert; Adrian's version seems to have
	  problems.

Mon Apr  4 12:57:46 2005 Peter Naulls  <peter@chocky.org>

	* source/memcpy.c, source/memset.c: Removed - bzero, bcopy
	  included in assembler.
	* source/string/_strcpy.s, source/string/_strlen.s: Adrian
	  says cache alignment may improve performance.
	* source/sys/_memset.s: Removed
	* source/string/_memset.s, source/string/_memcpy.s: Faster
	  implementations from Adrian Lees.
	* source/signal/post.c: Experiment with provding disassembly
	  in backtrace.

Sat Apr  2 22:03:12 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/dirent.c (readdir_r): Take account of
	  __feature_imagefs_is_file.

Sat Apr  2 09:28:42 2005  Stefan Bellon <sbellon@sbellon.de>

	* source/sys/debug.c: Fix compile error.
	* objs/.cvsignore: Add more filenames to ignore.

Fri Apr  1 17:05:51 2005  Peter Naulls  <peter@chocky.org>

	* source/strcpy.c, source/strlen.c: Removed
	* source/string/_strcpy.s, source/string/_strlen.s: New
	  faster versions from Adrian Lees.
	* source/unix/dev.c: Remove old free call.

Thu Mar 31 13:55:25 2005  Nick Burrett  <nick@sqrt.co.uk>

	* sched.h (sched_yield): Add prototype.
	* sched/syield.c: New file.

	* Makefile.in (CROSS_CFLAGS): Set compiler to the C99 standard.

Thu Mar 31 13:50:43 2005  Nick Burrett  <nick@sqrt.co.uk>

	* setlocale.c (setlocale): Only build ctype tables when they
	are actually being changed.

Thu Mar 31 12:38:23 2005  Nick Burrett  <nick@sqrt.co.uk>

	* signal/sleep.c (nanosleep): New function.
	* time.h (nanosleep): Add prototype.

Thu Mar 31 12:26:20 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unix/dev.c (__fsopen): Reduce OS_FSControl canonicalisation
	calls by using a fixed buffer from the stack.

Thu Mar 31 10:52:14 2005  Nick Burrett  <nick@sqrt.co.uk>

	* signal/post.c (__unixlib_raise_signal): Remove PROCMAGIC
	check.

Thu Mar 31 10:44:49 2005  Nick Burrett  <nick@sqrt.co.uk>

	* locale/localeconv.c (xfree): New function.
	(struct lonv lc): Initialise correctly.
	(localeconv): Use 'xfree' instead of 'free'.
	(read_byte_list): Remove DEBUG code because it is incompatible
	and can cause recursion with 'printf'.

Thu Mar 31 10:37:49 2005  Nick Burrett  <nick@sqrt.co.uk>

	* clk_getres.c: New file.
	* clk_gettime.c: New file.
	* clk_settime.c: New file.
	* time.h (clock_getres): Add prototype.
	(clock_gettime): Add prototype.
	(clock_settime): Add prototype.
	* unistd.h (_POSIX_MONOTONIC_CLOCK): Define.

Thu Mar 31 10:25:40 2005  Nick Burrett  <nick@sqrt.co.uk>

	* unixlib/sigstate.h (__valid_address): Prepend '__' as this is
	a globally defined function.  Set args to 'void *' to reduce
	explicit-casting in source.
	(__write_backtrace): Add prototype.
	* signal/post.c (__valid_address): Adjust accordingly.
	(__write_backtrace): Make global.
	(__unixlib_raise_signal): Stablise signal handling in unpredictable
	situations, or die when we find parts of the environment are
	in a bad state.

Wed Mar 30 22:37:44 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/tty.c (__ttyicanon): Restore the previous escape
	  state, rather than just assuming it was set.

Tue Mar 29 23:44:37 2005  Peter Naulls  <peter@chocky.org>

	* source/unix/getenv.c, source/unix/select.c: Avoid
	  NULL pointer reading.

Mon Mar 28 15:56:14 2005  John Tytgat  <John.Tytgat@aaug.net>

	* kernel.h: Better describe its intention; Added prototypes
	  __rt_allocauto() and __rt_freeauto().
	* signal/post.c: Added ptr to int cast avoiding Norcroft compiler
	  error.
	* sys/_alloca.s: Exported __rt_allocauto() and __rt_freeauto()
	  as aliases for alloca() and nop.  For Norcroft users.

Sat Mar 26 23:32:09 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/signal/post.c (post_signal): Open a command window if the
	  backtrace would otherwise get lost.

Mon Mar 21 12:03:23 2005  Peter Naulls  <peter@chocky.org>

	* source/clib/pthread.h, source/pthread/lock.c: Tidy comments.
	* source/pthread/context.c: Fix spelling.
	* clib/unixlib/unix.h, source/unix/unix.c, source/sys/_syslib.s:
	  Avoid creating FP exceptions on overflows and other FP operations
	  more like Unix behaviour.

Sun Mar 20 15:44:23 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/common/riscosify.c, source/common/unixify.c,
	  source/unix/dirent.c: Use __os_swi instead of _kernel_swi to avoid
	  modifying errno (Bug#140).

Sat Mar 19 19:26:16 2005  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/sys/_swi.s, source/test/test1-swi.c: Fix handling of return
	  registers > r3. Update testcase appropriately.

Sat Mar 19 11:54:53 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/dev.c (__fsread): Fix potential buffer overflow.
	  (__fslseek): Cope with being called for a directory.
	  (__fsfstat): Fix double free when called for a directory.

Tue Mar 15 22:07:05 2005  Alex Waugh  <alex@alexwaugh.com>

	* Docs/ReadMe: Document new behaviour of environment variables.
	  Update fork/wimpslot section.
	* source/clib/stdlib.h (unsetenv, putenv): Fix prototypes.
	* source/clib/unixlib/unix.h: Add/remove prototypes.
	* source/common/prefix.c, source/unix/features.c: Add extra
	  parameter to __getenv_from_os calls.
	* source/unix/{getenv.c, putenv.c, setenv.c}: Change environment
	  variable behaviour to use global RISC OS environment for anything
	  with a $ in the name, and the process' private environment otherwise.
	* source/unix/unix.c: Populate environ on program initialisation.

Sun Mar 13 19:37:45 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/module/sul.s: Fix logic for out of memory error handling.

Sun Mar 13 17:34:18 2005  John Tytgat  <John.Tytgat@aaug.net>

	* source/module/sul.s: error_active address doesn't need module_start
	  compensation in ADR usage.

Sun Mar 13 10:05:00 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/locale/localeconv.c (localconv): Ensure everything we free
	  was malloced in the first place.

Sat Mar 12 13:32:27 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/unix.c: stdin/stdout should only be opened if we
	  haven't inherited them from a parent.

Sat Mar 12 10:29:12 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/setjmp.h, source/sys/_jmp.s: Remove unused entry from
	  jmp_buf.

Sun Mar 6 21:48:34 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/module/sul.s: Fix unpredictable MUL instruction.

Sat Mar 5 15:45:00  2005  John Tytgat  <John.Tytgat@aaug.net>

	* source/common/unixify.c (__unixify): __RISCOSIFY_FILETYPE_EXT
	  support got broken.

Fri Mar 4 21:55:54  2005  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/unistd.h, source/clib/unixlib/{asm_dec.s,
	  buildoptions.h, dev.h, fd.h, local.h, tty.h, unix.h},
	  source/common/{_atomic.s, sockvalid.c},  source/module/sul.s,
	  source/netlib/{accept.c, bind.c, connect.c, getpeernam.c,
	  getsocknam.c, getsockopt.c, listen.c, recv.c, recvfrom.c, recvmsg.c,
	  send.c, sendmsg.c, sendto.c, setsockopt.c, shutdown.c, socket.c},
	  source/pthread/_context.s, source/resource/{getegid.c, geteuid.c,
	  getgid.c, getpgrp.c, getpid.c, getppid.c, getprior.c, getuid.c,
	  seteuid.c, setgid.c, setpgrp.c, setprior.c, setuid.c},
	  source/signal/{kill.c, post.c}, source/sound/dsp.c,
	  source/stdio/{fopen.c, stdio.c, tmpfile.c}, source/sys/{_exec.s,
	  _syslib.s, _vfork.s, debug.c, exec.c, stackalloc.c, vfork.c},
	  source/termios/{tcgetattr.c, tcsetattr.c}, source/unistd/{fchdir.c,
	  fchown.c}, source/unix/{close.c, dev.c, dup2.c, fchmod.c, fcntl.c,
	  features.c, fstat.c, ioctl.c, isatty.c, ispipe.c, lseek.c, open.c,
	  pathconf.c, pipe.c, proc.c, read.c, readv.c, reopen.c, select.c,
	  stat.c, sync.c, truncate.c, tty.c, umask.c, unix.c, wait4.c, write.c,
	  writev.c}:
	  Rewrite large parts of vfork() and exec(), and add better support
	  for fork(). Make SUL aware of processes, and improve file descriptor
	  handling.

Wed Mar 2 22:54:07 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/unix.c: Fix parsing for commandline redirection when
	  the command line contains quotes.

Sat Feb 12 13:44:21 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/pthread/_context.s: Disable context switching in
	  taskwindows, as it doesn't work reliably.

Wed Feb 9 23:13:58 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/select.c (__return_fd_set): Only clear fds that are
	  sockets.

Wed Feb 9 21:09:05 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/pthread.h, source/clib/signal.h,
	  source/pthread/newnode.c, source/pthread/signal.c: Add partial
	  implementation of sigwait().

Mon Feb 7 14:52:18 2005  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/regexp/{cclass.h, cname.h, engine.h, regcomp.c,
	  regexec.c, regerror.c, regfree.c, utils.h, COPYRIGHT}:
	  Use regex implementation from NetBSD CVS. The previous
	  version appeared to be non-POSIX compliant.
	* source/regexp/{regexp.c, regmagic.h, regsub.c}: Remove unused files

Sun Feb 6 19:48:21 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/module/sul.s: Change upcall handler to refuse all new
	  applications from starting. This avoids bugs in the current
	  upcall handler.

Sun Jan 30 16:04:32 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/pipe.c, source/unix/dev.c, source/clib/unixlib/unix.h:
	  Remove linked list of all open pipes, as the same functionality can
	  be achived simply by setting the O_UNLINKED flag on the pipe.

Sat Jan 29 17:23:04 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/pthread/context.c (__pthread_context_switch): Remove thread
	  from condition variable list if it times out waiting for the
	  condition variable.

Mon Jan 24 16:44:19 2005  Peter Naulls  <peter@chocky.org>

	* source/regexp/regex2.h, source/regexp/regfree.c,
	  source/regexp/utils.h: Added: regfree() support.
	* source/pthread/key.c: Reuse key structure if it's already
	  allocated for a given ID.
	* source/pthread/keydest.c: Fix spelling.
	* source/pthread/lock.c: Return EBUSY when trying for a lock.

Sun Jan 23 21:27:23 2005  John Tytgat  <John.Tytgat@aaug.net>

	* features.h: More constify __program_name, ___program_name,
	  __dynamic_da_name and prototyped ___dynamic_da_name.
	* source/sys/_syslib.s: Defined ___dynamic_da_name.
	* source/sys/mman.c (mmap): DA name is __dynamic_da_name when defined,
	  otherwise <program name> + " MMap". Suggestion of Alex in bug #138.

Sun Jan 23 20:27:33 2005  John Tytgat  <John.Tytgat@aaug.net>

	* Docs/ReadMe: Added more info on what <program name> really is.
	Changed iconv URL into a version independent link.
	* source/clib/features.h: Added prototypes for ___program_name (internal)
	  and __program_name (WEAK public symbol).
	* source/clib/fenv.h: Updated comment for FE_TONEAREST.
	* source/clib/unixlib/unix.h: Made get_program_name() available.
	* source/sys/_longlong.s: Updated comments.
	* source/sys/_syslib.s: Support for __program_name (up to 32 chars).
	* source/sys/mman.c: DA name is <program name> + " MMap". This addresses
	  bug #138.
	* source/unix/features.c (get_program_name): Support for __program_name.

Sat Jan 22 00:06:21 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/unixlib/unix.h (_PROCMAGIC): Change magic number as a
	  temporary workaround for bug#137

Sun Jan 16 18:25:33 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/unix.c (find_redirection_type): Don't treat <
	  and > inside quoted arguments as redirection characters.

Sun Jan  9 23:26:02 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/locale/nl_langinfo.c (nl_langinfo): Change CODESET value to
	  a format that iconv recognises.

Wed Jan  6 23:42:25  John Tytgat  <John.Tytgat@aaug.net>

	* Docs/Copyright: consistent spelling of UnixLib.
	* source/test/{test1-swi.c, test2-seg.c, test3-fpe.c}: Likewise.

Wed Jan  6 23:13:25  John Tytgat  <John.Tytgat@aaug.net>

	* source/sys/_syslib.s: Removed export of non-existing __os_version
	  symbol.

Wed Jan  6 23:07:25  John Tytgat  <John.Tytgat@aaug.net>

	* gen-makefiles.pl: Generated stubs.h file contains a gen-makefiles.pl
	  reference; clean target removes all obj subdirectories instead of
	  the objects in the o sub-directories.
	* obj/Makefile.in: Likewise.
	* source/gcccompat/{_divdi3.s, _moddi3.s, _udivdi3.s, _umoddi3.s}:
	  0/0 didn't raise despite previous fix; modulo result wasn't correct
	  when numerator was zero.  Bugs reported by Stefan Bellon.
	* source/regexp/{regexp.c, regsub.c}: Norcroft compilation fixes.
	* source/resolv/inet_net_pton.c: Likewise.
	* source/sys/{_smod.s, _umod.s}: Added "IMPORT raise" for objasm
	  compatibility.

Wed Jan  5 11:33:20 2005  Peter Naulls  <peter@chocky.org>

	* Docs/ReadMe36c1, Docs/ReadMe36c2, Docs/ReadMe36d, Docs/ReadMe36e,
	  Docs/ReadMe37a, Docs/ReadMe37b, Docs/ReadMe38: Remove - out
	  of date information.
	* Docs/Copyright: Draft of new UnixLib copyright statement.
	* source/clib/regex.h: Matching header file for source.

Tue Jan  4 22:50:42 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/common/unixify.c (add_directory_name): Slashes should be
	  converted to dots.

Tue Jan  4 00:30:47 2005  Peter Naulls  <peter@chocky.org>

	* source/regex.c: Removed.
	* source/regexp/COPYRIGHT, source/regexp/regerror.c,
	  source/regexp/regexp.c, source/regexp/regmagic.h,
	  source/regexp/regsub.s: Added: Alterntate regex implementation.

Mon Jan  3 23:33:47 2005  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/sys/types.h: Define int64_t and u_int64_t for Norcroft
	  users.
	* source/gcccompat/{_divdi3.s, _moddi3.s, _udivdi3.s, _umoddi3.s}:
	  Raise SIGFPE when there is an integer division by zero.
	* source/sys/{_sdiv.s, _smod.s, _udiv.s, _umod.s}: Likewise.
	* source/string/rawmemchr.c: Workaround for Norcroft users.
	* source/sys/_divtest.s (__rt_divtest, x$divtest): No longer console
	  writing of a division by zero and a SIGFPE raise instead of a
	  SIGABRT raise.
	* source/sys/_longlong.s: License statement didn't cover complete
	  source; Implementation of _ll_urdv and _ll_srdv got argument order
	  wrong.

Mon Jan  3 16:28:34 2005  Alex Waugh  <alex@alexwaugh.com>

	* source/pthread/_context.s (__pthread_stop_ticker): Stack register
	  that gets corrupted.
	* source/pthread/exit.c (pthread_exit): Fix potential race condition.

Mon Dec 27 19:38:27 2004  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/sys/_swi.s: Simplify _BLOCK and _RETURN handling. 
	  Modify return of PC to work on <ARMv3.
	* source/test/test1-swi.c: Improve test case.
	  
Sun Dec 26 18:09:45 2004  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/sys/_swi.s: Clean implementation of this file.

Wed Dec 22 23:32:12 2004  John Tytgat  <John.Tytgat@aaug.net>

	* source/strsignal.c (strsignal): Add the RISC OS error string to the
	  return value in case of SIGOSERROR.
	* source/sys/exec.c (execve): Extended the hack to recognize
	  "/bin/sh -c" execs.  This solves bug 86.

Sat Dec 25 10:23:30 2004  Peter Naulls  <peter@chocky.org>

	* source/clib/libgen.h, source/misc/dirname.c,
	  source/stdlib/xpg_basename.c, source/string/memrchr.c,
	  source/string/rawmemchr.c, source/clib/string.h:
	  Add libgen.h functionality (dirname, basename) and related
	  changes in support of these functions.
	* source/stdio/printf.c: libscl compatibility - this is a temporary
	  workaround for libscl varargs.

Thu Dec 23 20:51:31 2004  Peter Naulls  <peter@chocky.org>

	* source/sound/dsp.c, source/clib/swis.h, source/clib/unixlib/dev.h,
	  source/unix/dev.c, source/unix/write.c: Complete rewrite of
	  DSP support to use streaming interface in DigitalRenderer
	  and therefore suffer less lag.  Also will yield during write
	  to prevent blocking, and better support for some ioctls.
	* source/signal/signal.c, source/sys/_syslib.s: Fix typos.
	* source/unix/unix.c: Ensure DigitalRenderer deregister on
	  an abort.  

Mon Dec 20 16:18:55 2004  Peter Naulls  <peter@chocky.org>

	* source/math-asm/_fabsf.s: Added fabsf function.
	* source/sys/_mem.s, source/sys/_memset.s:  Replaced
	  our memset with hopefully faster (and simpler) one
	  from glibc.
	* source/clib/sys/queue.h: Add sys/queue.h functionality.

Sat Dec 18 18:37:52 2004  John Tytgat  <John.Tytgat@aaug.net>

	* source/sys/debug.c: Removed __debugnl(); Added debug print of
	  struct proc::cli and struct proc::dde_prefix.
	* source/sys/exec.c (execve): First shift contents of struct proc::envp
	  array and then the array ptr (and not visa versa).  Bug reported by
	  Steve Ellacott.

Thu Dec 16 17:09:18 2004  Peter Naulls  <peter@chocky.org>

	* source/common/riscosify.c: Handle use of ~ in filenames
	  by substituting our HOME value.

Thu Dec 16 11:32:48 2004  Peter Naulls  <peter@chocky.org>

	* source/termios/tcsetattr.c: Compare the correct flags before
	  setting CBREAK/RAW.
	* source/unix/tty.c: Do ICRNL only when INLCR is not set.
	  Don't clear all the flags when CBREAK is set (corrects
	  returning CR instead of LF in non-canonical mode).   

Wed Dec 15 17:54:07 2004  Peter Naulls  <peter@chocky.org>

	* source/common/unixify.c: Pull in functionality from rname.c,
	  so unixify works much better.

Tue Dec 14 23:10:26 2004  Peter Naulls  <peter@chocky.org>

	* source/common/riscosify.c: Make riscosify really work for
	  libscl.
	* source/unix/fchmod.c: Allow to build when cross compiling.

Sat Dec 11 15:02:57 2004  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/unixlib/swiparams.h: Added OSFILE_WRITECATINFO_ALL,
	  OSFILE_DELETENAMEDOBJECT, OSFILE_CREATEDIRECTORY,
	  OSFILE_CREATEEMPTYFILE_FILETYPE; Consult the __UNIXLIB_USEFILEPATH
	  value instead of checking on its existence (which is now always the
	  case).
	* source/stdio/rename.c: Using new OSFILE_* constants.
	* source/unix/chmod.c: Likewise.
	* source/unix/{dev.c, fchmod.c, mkdir.c, unlink.c, utime.c}: Likewise.
	* source/pthread/{context.c, create.c, error.c, exit.c):
	  __os_print("\r\n") -> __os_nl()
	* source/signal/post.c: Likewise.
	* source/stdio/{flsbuf.c, fopen.c, fpos.c, fwrite.c, newstream.c,
	  unix.c}: Likewise.
	* source/sys/{brk.c, debug.c, exec.c, execvp.c, statckalloc.c, vfork,c}:
	  Likewise.
	* source/unix/{dev.c, dirent.c, getenv.c, open.c, stat.c, unix.c}:
	  Likewise.
	* souce/sys/_syslib.s (__unixlib_fatal): Added useful reminder as
	  comment.
	* source/unix/unix.c: Fill RISC OS error buffer before calling
	  __unixlib_fatal(); When __UNIXLIB_SET_DDEPREFIX is defined, always set
	  DDEPrefix to its value at startup; Added malloc()/realloc() return
	  value check.

Wed Dec  8 16:11:55 2004  Peter Naulls  <peter@chocky.org>

	* source/unix/dev.c (__fsopen): Only close the file if
	  attribute setting whilst the file is open fails.

Tue Dec  7 22:54:45 2004  Alex Waugh  <alex@alexwaugh.com>

	* source/stdio/fflush.c (fflush): Don't return an error if a read
	  only stream is flushed.

Sat Dec  4 23:07:00 2004  John Tytgat  <John.Tytgat@aaug.net>

	* source/unix/select.c: Norcroft compatibility; unsigned modulo
	  instead of signed for better code.

Sat Dec  4 15:10:37 2004  Alex Waugh  <alex@alexwaugh.com>

	* source/pwd/pwdread.c (__pwddefault): Prevent potential NULL
	  dereference, and ensure pw_dir is not returned as NULL.

Fri Dec  3 11:34:41 2004  Peter Naulls  <peter@chocky.org>

	 * source/clib/unixlib/dev.h. source/netlib/accept.c,
	   source/netlib/socket.c, source/unix/close.c,
	   soure/unix/select.c:  More select() speed improvements.
           These make a noticeable difference.

Thu Dec  2 14:42:35 2004  Peter Naulls  <peter@chocky.org>

	* source/clib/termios.h: Add arbitrary value for XCASE.
	* source/sound/dsp.c: Modify buffer sizes for slightly better
	  behaviour.
	* source/unix/dev.c: Make fopen "w+" work over ShareFS.
	* source/unix/select.c: Attempt some speed improvements.
	* source/unix/unix.c: Make command line arguments with apostrophes work.

Sun Nov 28 22:01:02 2004  John Tytgat  <John.Tytgat@aaug.net>

	* !Help: mention APCS-32 explicitly.
	* Docs/ReadMe: UnixLib$pcnt is another internally used environment
	  variable.
	* source/psignal.c (psignal): Get rid of 'register'.
	* source/clib/errno.h: Remove __set_errno multiple define protection
	  as this shouldn't be needed.
	* source/clib/stdio.h (getc): Always use the getc() function instead
	  of using the macro equivalent (bug 122).
	* source/clib/unixlib/asm_dec.s (NetSWI*): Let all the macros import
	  __net_error themselves; Updated their comments; Simplified the
	  NetSWIsimple(0) even further.
	* source/clib/unixlib/buildoptions.h (__UNIXLIB_SET_DDEPREFIX): Added.
	* source/clib/unixlib/sigstate.h: __write_unrecoverable, __backtrace,
	  __core: Removed as it was nowhere used; __backtrace_getfp,
	  __ul_callbackfp: Added.
	* source/clib/netlib/{_accept.s, _bind.s, _connect.s, _getpeers.s,
	  _getpeerna.s, _getsockna.s, _getsockop.s, _gettsize.s, _listen.s,
	  _readv.s, _recv.s, _recvfrom.s, _recvmsg.s, _sclose.s, _select.s,
	  _send.s, _sendmsg.s, _sendto.s, _sendtosm.s, _setsockop.s,
	  _shutdown.s, _sioctl.s, _socket.s, _sockstat.s, _sread.s, _swrite.s,
	  _writev.s}: Removed IMPORT __net_error_simple_entry.
	* source/clib/netlib/_net_error.s: Updated comments; Removed
	  __net_error_simple_entry as direct calling __net_error from
	  NetSWIsimple(0) macros is possible; Removed preserve of ip.
	* source/scl/{_kernel.s, _kswi_c.s}: _kernel_NONX feature wasn't
	  working at all.
	* source/signal/_signal.s: Removed needless IMPORT of
	  __write_unrecoverable; Updated a couple comments; Take a snapshot
	  of CPSR during each hardware exception handler; Renamed __ul_errfp
	  to __ul_callbackfp as this should only be the fp and valid during
	  CallBack handler code (shared by the hardware exception handlers too),
	  during error handler this is NULL; Instead of reseting the exception
	  FP flags, we temporary disable FP traps (cfr bug 119); Pull
	  __ul_callbackfp in C$$data area.
	* source/signal/post.c: Removed needless __write_unrecoverable; Updated
	  write_backtrace so it becomes more useful and foolproof.
	* source/stdio/flsbuf.c: Replaced -1 by EOF.
	* source/stdio/fwrite.c: Likewise.
	* source/sys/_syslib.s: Updated some comments.
	* source/unix/unix.c: Make use of new __UNIXLIB_SET_DDEPREFIX build
	  option.
	* source/unix/write.c: Test on existence of SIGPIPE is no longer
	  needed when we're already checking for __UNIXLIB_FEATURE_PIPEDEV.
	* source/unix/writev.c: Added test on __UNIXLIB_FEATURE_PIPEDEV.

Sun Oct 10 17:37:38 2004  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/unix.c: Change default back to not setting
	  DDEUtils_Prefix

Sat Oct 23 19:00:00 2004  John Tytgat  <John.Tytgat@aaug.net>

	* source/unix/dev.c: RMEnsure CryptRandom 0.12; Removed
	  __UNIXLIB_NO_COMMON_DEV support;
	* source/clib/unixlib/dev.h: Constify __dev; Removed
	  __UNIXLIB_NO_COMMON_DEV support.
	* source/unix/tty.c: Removed __UNIXLIB_NO_COMMON_DEV support.
	* Docs/ReadMe: Documented the usage of CryptRandom module and its home
	  URL.
	* source/clib/stdio.h: Removed personal comment.
	* source/clib/unixlib/buildoptions.h: Fixed spelling mistake.
	* source/clib/unixlib/os.h (__seterr): Added more info on its behaviour.
	* source/locale/iconv.c (iconv): RMEnsure at least Iconv 0.02 and use
	  ModuleTooOld error number instead of 0.
	* source/sound/dsp.c (__dspopen): Use ModuleTooOld error number instead
	  of 0.
	* source/pthread/{_ints.s, _yield.s}: Talk about APCS-32 instead of
	  APCS.
	* source/signal/sigexec.s: Likewise.
	* source/sys/_syslib.s: Likewise.
	* source/signal/_signal.s: Likewise. Temporary workaround for
	  _kernel_last_oserror() in __seterr() which changes error number 0
	  into 1.
	* source/sys/errlist.c: Removed register usage.
	* source/unix/fnmatch.c: Reverted back to 1.2 version because making
	  1.3 to work involves pulling in too many other GLIBC based code.

Sun Oct 17 18:19:00 2004  John Tytgat  <John.Tytgat@aaug.net>

	* Docs/ReadMe: Added 'Building' section.
	* objs/Makefile.in: target 'clean' removes UnixLib:o.UnixLib too.
	* source/clib/{fnmatch.h, langinfo.h, nl_types.h, bits/locale.h}: Added
	  CVS/RCS keyword header.
	* source/clib/string.h: Remove #define ffsl. Declared ffsll too for
	  Norcroft users.
	* source/clib/unixlib/asm_dec.s, source/common/_exist.s,
	  source/gcccompat/{_divdi3.s, _moddi3.s, _udivdi3.s, _umoddi3.s},
	  source/netlib/{_getsockop.s, _recvfrom.s, _select.s, _sendto.s,
	  _setsockop.s}, source/pthread/{_context.s, _ints.s},
	  source/scl/{_kernel_swi.s, _kgetenv.s, _kosargs.s, _kosbget.s,
	  _kosbput.s, _kosbyte.s, _koscli.s, _kosfind.s, _kosgbpb.s, _kosrdch.s,
	  _kosword.s, _koswrch.s, _ksetenv.s}, source/sys/{_alloca.s,
	  _longlong.s, _mem.s, _mman.s, _modsi3, _os.s, _syslib.s, _vfork.s}:
	  Removed stackreturn macro.
	* source/clib.unixlib/asm_dec.s, source/unix/getpagsiz.s,
	  source/time/_clock.s, source/sys/{_umod.s, _udiv10.s, _udiv.s,
	  _syslib.s, _smod.s, _sdiv10.s, _sdiv.s, _profile.s, _os.s, _mem.s,
	  _longlong.s, _jmp.s, _divtest.s, _alloca.s, _ffsll.s, _ffs.s,
	  _signal.s, _memchk.s, _kswi_c.s, _kcurskch.s},
	  source/pthread/{_ints.s, _exit.s, _context.s},
	  source/netlib/{htons.s, htonl.s, _net_error.s, _bswap32.s},
	  source/math-asm/{_tanhf.s, _tanh.s, _tanf.s, _tan.s, _sqrt.s,
	  _sinhf.s, _sinh.s, _sinf.s, _sincos.s, _sin.s, _signbit.s, _powf.s,
	  _pow.s, _modf1f.s, _modf1.s, _logf.s, _log10f.s, _log10.s, _log.s,
	  _ldexpf.s, _ldexp.s, _isnan.s, _isinf.s, _hypot.s, _ftstexcpt.s,
	  _fsetexcpt.s, _fraiseexc.s, _floorf.s, _floor.s, _finite.s,
	  _fesetroun.s, _fesetenv.s, _feholdexc.s, _fegetrnd.s, _fegetenv.s,
	  _fclrexcpt.s, _fabs.s, _expf.s, _exp.s, _coshf.s, _cosh.s, _cosf.s,
	  _cos.s, _copysign.s, _ceilf.s, _ceil.s, _atanf.s, _atan2f.s,
	  _atan2.s, _atan.s, _asinf.s, _asin.s, _acosf.s, _acos.s},
	  source/gcccompat/{_umodi3.s, _udivdi3.s, _moddi3.s, _divdi3,s},
	  source/common/{_riscosify.s, _exist.s}: Removed return macro.
	* source/string/{_ffs.s, _ffsll.s}: Added.  Short & fast asm versions
	  instead of ffs.c and ffsll.c.
	* source/string/{ffs.c, ffsll.c}: Removed.  Replaced by _ffs.s and
	  _ffsll.s.
	* source/clib/unixlib/{buildoptions.h, stdcmac.h, stdsmac.h}:
	  Added.  buildoptions.h is now the only file containing build related
	  options.  stdcmac.h and stdsmac.h are support files allowing
	  buildoptions.h be used in C and ASM files.
	* source/clib/unixlib/features.h: Removed.
	* source/clib/unixlib/asm_dec.s: Moved build options to buildoptions.h.
	* source/math-asm/{_acosf.s, _asinf.s, _atan2f.s, _atanf.s, _ceilf.s,
	  _cosf.s, _coshf.s, _expf.s, _floorf.s, _ldexpf.s, _log10f.s, _logf.s,
	  _modf1f.s, _powf.s, _sinf.s, _sinhf.s, _tanf.s, _tanhf.s}:
	  Uses build option __UNIXLIB_NORCROFT_BUILD to determine which float
	  ABI is used (GCC vs Norcroft).
	* source/unix/fnmatch.c: Disabled calling versioned_symbol(),
	  strong_alias(), compat_symbol() and libc_hidden_ver().
	* source/clib/arpa/{inet.h, nameser.h}, source/clib/bits/huge_val.h,
	  source/clib/{alloca.h, complex.h, crypt.h, ctype.h, dirent.h,
	  fcntl.h, fenv.h, glob.h, grp.h, iconv.h, inttypes.h, kernel.h,
	  locale.h, math.h, nl_types.h, pthread.h, pwd.h, setjmp.h, sgtty.h,
	  stdint.h, string.h, swis.h, termcap.h, termios.h, time.h, unistd.h,
	  utime.h, wchar.h}, source/clib/machine/ieee754.h, source/clib/net/if.h,
	  source/clib/netinet/{in.h, in_systm.h, ip_icmp.h, ip_var.h, tcp.h,
	  udp.h}, source/clib/resolv/resolv.h, source/clib/rpc/netdb.h,
	  source/clib/sys/{byteorder.h, cdefs.h, debug.h, file.h, ioctl.h,
	  mman.h, netdb.h, poll.h, resource.h, select.h, socket.h, stat.h,
	  statfs.h, syslog.h, time.h, timeb.h, times.h, uio.h, utsname.h,
	  wait.h}, source/clib/unixlib/{dev.h, fd.h, local.h, os.h, sigstate.h,
	  tty.h}, source/crypt/crypt-private.h: Changed unixlib/features.h into
	  features.h.
	* source/common/stat.c, source/stdlib/random.c, source/sys/{alarm.c,
	  exec.c, stackalloc.c, vfork.c}, source/unix/{dev.c, pipe.c, tty.c,
	  write.c}: Removed unixlib/features.h.
	* source/crypt/crypt_util.c: No need to define __GNU_LIBRARY__
	  explicitly because this is now done in features.h.

Tue Oct 12 09:11:22 2004  Peter Naulls  <peter@chocky.org>

	* source/regex.c, source/realpath.c, source/time/mktime.c,
	  source/unistd/getpass.c: Work better with Norcroft.
	* source/clib/assert.h, source/clib/getopt.h, source/clib/netdb.h,
	  source/clib/stdio.h, source/clib/strings.h, source/clib/types.h,
	  source/clib/unixlib/types.h, source/unixlib/unix.h:
          Reference moved features.h
	* source/clib/unixlib/features.h: Warning if we use the old
	  features.h file path.
	* source/module/sul.s: Fix inadvertant change to SWI base.

Sun Oct 10 17:37:38 2004  Alex Waugh  <alex@alexwaugh.com>

	* source/unix/uname.c: Cope with OS_ReadSysInfo returning 0

Fri Oct  8 12:56:32 2004  Peter Naulls  <peter@chocky.org>

	* source/clib/signal.h, source/signal/signal.c: Stub siginterrupt
	* source/clib/time.h, source/time/mktime.c, source/time/dysize.c,
	  source/time/timegm.c: Add support for mktime, timelocal, dysize.
	* source/clib/features.h, source/clib/unixlib/features.h:
	  Move features.h to same location as glibc. Make unixlib/features.h
	  include former for time being.
	* source/clib/sys/mount.h, source/sys/mount.c: Stub mount.h
	  functionality.
	* source/common/riscosify.c: Modify to work with libscl too.
	* source/unix/fnmatch.c: Update functionality.
	* source/locale/iconv.c, source/clib/iconv.h: Work with Norcroft
	  properly.

Tue Oct  5 16:24:01 2004  Peter Naulls  <peter@chocky.org>

	* source/clib/swis.h, source/locale/iconv.c: Update to sync with
	  John-Mark Bell's changes.
	* source/clib/netdb.h: Further improve visibility of macros
	  for unsupported functions.
	* source/unix/unix.c: Improve comment.
	* Docs/ReadMe: Update iconv URL.

Fri Sep 24 00:09:00 2004  John Tytgat  <John.Tytgat@aaug.net>

	* objs/Makefile.in: Predefined _GNU_SOURCE as quick fix for Norcroft
	  users after the 12 Sept 2004 change in post.c.  Better fix would
	  probably be to make sure that UnixLib is compilable with and without
	  _GNU_SOURCE defined.
	* source/clib/sys/debug.h (__debug): Added comment what __debug is
	  doing.
	* source/clib/unixlib/sigstate.h (valid_address): constify its
	  parameters
	* source/signal/post.c (valid_address): Likewise.
	* source/clib/unixlib/unix.h: Minor comment updating.
	* source/scl/_koscli.s: Likewise.
	* source/pthread/_ints.s: Reverted the signed/unsigned compare change
	  from 7 Sep 2004 on request from Alex.
	* source/sound/dsp.c: Test result of first __os_cli("RMEnsure...
	  call too.
	* source/locale/iconv.c: Likewise; Added CVS/RCS keyword header.
	* source/signal/_signal.s (return_quickly/__h_cback_common): Removed
	  unnessary teq pc,pc test (partly revert from 7 Sep 2004 change).
	  Feedback from Alex.
	* source/sys/_longlong.s (_ll_ufrom_d, _ll_sfrom_d, _ll_ufrom_f,
	  _ll_sfrom_f): Added, based on a patch from Jeffrey Lee for
	  gccsdk/gcc/libgcc/lib1aof.s.
	* source/sys/debug.c (__debug): Avoid crash when __u is bogus; Print
	  the has_process value too.
	* source/sys/exec.c (execve): execve() after fork() still means that
	  there is a parent so has_parent may not be reset.  Also necessary
	  to correctly identify when dde_prefix needs to be set & used in
	  unix.c (__unixinit, _exit).
	* source/unix/unix.c (__unixinit, _exit): dde_prefix may only be updated
	  and used to reset process' CSD when the process isn't a child; Added
	  assert that has_parent is always set in a process struct found via
	  UnixLib$env; (_exit) Removed test based on has_parent/___vret because
	  we want both parent & child to exit via __exit() and not directly
	  via __vret (resumely legacy code).

Fri Sep 17 19:20:35 2004  Peter Naulls  <peter@chocky.org>

	* Docs/ReadMe: Updated documentation.
	* source/clib/fnmatch.h: Updated fmatch.h from glibc.  Needs matching
	  C support still.
	* source/clib/langinfo.h, source/clib/nl_types.h,
	  source/clib/bits/locale.h, source/clib/locale/nl_langinfo.c:
	  Very basic langinfo support.
	* source/clib/netdb.h: Hide getaddrinfo declaration.
	* source/clib/stat.h, source/unix/stat.c: Make stat/stat64
	  more like glibc to avoid problems with forward declarations.
	* source/signal/signal.c: Remove warning.  

Fri Sep 17 19:20:35 2004  John-Mark Bell  <jmb@netsurf-browser.org>

	* source/clib/semaphore.h, source/pthread/sem.c,
	  source/clib/pthread.h: Semaphore support.
	* source/clib/netdb.h, source/netlib/getnameinfo.c: getnameinfo
	  support.
	* source/clib/resource.h: define values that are implemented.  

Sun Sep 12 09:20:31 2004  Peter Naulls  <peter@chocky.org>

	* source/signal/post.c: Remove warnings
	* source/sound/dsp.c: Be more careful about opening and closing
	  the DRender: filesystem.
	* source/clib/swis.h, source/clib/iconv.h, source/clib/iconv.c:
	  Interface to John-Mark Bell's iconv support module, instead
	  of requiring the large external iconv library.

Thu Sep  9 13:54:55 2004  Peter Naulls  <peter@chocky.org>

	* source/clib/unixlib/dev.h, source/unix/dev.c: Add __dsplseek
	* source/sound/dsp.c: Implement __dsplseek, rearrange for
	  NULL parameter checking.  Close and reopen device if playback
	  values are changed.
	* source/termios/tcgetattr.c: Fix getting of VMIN/VTIME
	* source/termios/tcsetattr.c: Fix setting of VMIN/VTIME
	* source/unix/ioctl.c: NULL arguments to ioctl are ok.
	* source/unix/tty.c: Implement usage of VTIME, correct setting/usage
	  of VMIN. 

Wed Sep  8 18:04:02 2004  John Tytgat  <John.Tytgat@aaug.net>

	* objs/.cvsignore: Added sound directory.
	* source/sys/_mem.s: Go back to v1.4 (i.e. before the Sep 7 2004 changes)
	  as there were, yet unidentified, problems with it.
	* source/sound/dsp.c (__dspopen): Enforce DigitalRenderer version 0.51.
	* source/sys/vfork.c: Include sys/debug.h instead of stdio.h when DEBUG
	  is defined.

Wed Sep  8 10:13:16 2004  Peter Naulls  <peter@chocky.org>

	* source/sys/_mem.s: Revert memcpy breakage (shows up on RISC OS 5)
	* source/sound/dsp.c: Improve stereo support, and add additional
	  ioctls.

Tue Sep  7 18:47:59 2004  Peter Naulls  <peter@chocky.org>

	* source/clib/swis.h, source/clib/sys/soundcard.h,
	  source/clib/unixlib/dev.h, source/sound/dsp.h,
	  source/unix/dev.c: Experimental /dev/dsp support.

Tue Sep  7 16:03:14 2004  John Tytgat  <John.Tytgat@aaug.net>

	* Docs/ReadMe: Documented UnixLib$env as private UnixLib environment
	  variable.
	* source/clib/setjmp.h: Aesthetic change.
	* source/clib/stdlib.h: Likewise.
	* source/clib/unixlib/asm_dec.s: Likewise.
	* source/clib/unixlib/local.h: Likewise.
	* source/stdio/fopen.c: Likewise.
	* source/sys/exec.c: Likewise.
	* source/clib/unistd.h: Added lseek64() prototype.
	* source/clib/sys/stat.h: Added lstat64(), fstat64() prototype.
	* source/clib/sys/un.h: Added RCS/CVS keywords.
	* source/clib/unixlib/asm_dec.s: Moved chunk and error definitions from
	  source/module/sul.s to here as SharedUnixLibrary_SWIChunk and
	  SharedUnixLibrary_ErrorChunk; Formally defined the
	  SharedUnixLib_Error_* errors; Incorrect SWI error exit code was
	  generated with objasm; TABified.
	* source/clib/unixlib/sigstate.h: Aesthetic change; declared
	  valid_address().
	* source/clib/unixlib/unix.h: Removed __env_read() declaration.
	  Adjusted comment on UnixEnv environment prefix.
	* source/common/unixify.c (__unixify): Suffix swapping could access
	  memory before start of path.
	* source/module/sul.s: Moved chunk and error definitions to
	  source/clib/unixlib/asm_dec.s.
	* source/pthread/_ints.s: Signed -> unsigned compares.
	* source/sys/_mem.s: Likewise; Space injections.
	* source/signal/_signal.s: Added comments; (__h_sigill, __h_sigsegv0,
	  __h_sigsegv1, __h_sigsys) removed useless instruction; (__h_event)
	  simplified; (__h_cback) exit sequences were not 26 bit system
	  compatible; Removed abortpc; CMP -> TEQ if only (non)equivalence test
	  is needed.
	* source/signal/post.c (valid_address): Exported.
	* source/sys/_exec.s: Space injections.
	* source/sys/_syslib.s: Introduced startup errors instead of VDU
	  writing; Ensuring SUL v1.02 instead of v1.00; Rename __cli ->
	  __uixlib_cli, __himem -> __image_rw_himem; a1 (on entry) of OS_Exit
	  must point to a filled in RISC OS error block; Define stack_corrupt_msg
	  and stack_corrupt conditionally; Calling __unixlib_fatal a 2nd time
	  results in panic calling OS_Exit; (stack_overflow_common) executing
	  signalhandler stack check *before* validity stack check otherwise you
	  get the wrong fatal error message.
	* source/sys/_vfork.s: Added comments.
	* source/sys/mman.c (__munmap_all): Updated comments.
	* source/sys/vfork.c: Minor cleanup.
	* source/unix/unix.c: Removed __unixlib_cli declaration; Be more
	  paranoid on the validity of __u as it might be an UnixLib$env value
	  picked up by another TaskWindow UnixLib based process doing fork()s.
	* source/unix/tty.c (__ttyioctl): Removed excessive break usage. 
	
Mon Sep  6 09:35:03 2004  Peter Naulls  <peter@chocky.org>

	* source/clib/pthread.h: Fix spelling mistakes. Add comment about
	  Wimp_Poll.
	* source/unix/open.c, source/unix/stat.c: Add some optional debug.
	* source/unix/select.c: Prevent blocking by judicious use of pthread
	  control.
	* source/unix/unix.c: Prevent atexit handlers being called more
	  than once.

Mon Aug 16 22:31:00 2004  John Tytgat  <John.Tytgat@aaug.net>

	* source/gcccompat/_divdi3.s: Return useful remainder in a3 & a4.
	* source/gcccompat/_udivdi3.s: Likewise.
	* source/gcccompat/_moddi3.s: Updated comment.
	* source/gcccompat/_umoddi3.s: Likewise.
	* source/sys/_longlong.s: Defined _ll_udiv, _ll_urdv, _ll_sdiv and
	  _ll_srdv.

Mon Aug 16 21:10:06 2004  John Tytgat  <John.Tytgat@aaug.net>

	* gen-makefies.pl: Create source.clib.o directory for Norcroft case.
	* objs/Makefile.in: Remove useless quotes for the .c.o and .c.s rules.
	* source/clib/errno.h: TABing.
	* source/clib/signal.h: Likewise.
	* source/clib/limits.h: Defined RE_DUP_MAX as 0x7fff instead of
	  _POSIX2_RE_DUP_MAX (same definition as in regex.h).
	* source/clib/math.h: Norcroft compatibility; Added __sincos()
	  declaration.
	* source/clib/wchar.h: Definition of WCHAR_MIN/WCHAR_MAX was not
	  the same as in stdint.h.
	* source/clib/sys/param.h: Conditional define of MAXHOSTNAMELEN.
	* source/clib/sys/time.h: "#define __timeval_defined" -> "#define
	  __timeval_defined 1".
	* souce/clib/unixlib/asm_dec.s: Added advise concerning signal list
	  definition.

Sun Aug  8 12:57:59 2004  Graham Shaw  <gdshaw@sagitta.demon.co.uk>

	* source/unix/features.c: Make environment variables work
	  as advertised.

Sun Aug  8 12:28:48 2004  Peter Naulls  <peter@chocky.org>
	* source/clib/features.h: Stop pretending we have full unicode
	  support.
	* source/clib/netinet/in.h: Include sys/param.h for type visibility
	  as per glibc.
	* source/clib/stdio.h: define putc_unlocked.
	* source/common/riscosify.c: Add a case for filenames that
	  GCC 3.4 sometimes constructs.

Fri Jun 18 22:56:14 2004  Alex Waugh  <alex@alexwaugh.com>

	* unix/lseek.c, unix/fstat.c: Add trailing newline.

Fri Jun 18 19:21:03 2004  Nick Burrett  <nick@dsvr.net>

	* errno.h: Drop requirement on unixlib/features.h as there is
	nothing in this header that is C++ incompatible.

Sat Jun 12 11:56:18 2004  Peter Naulls  <peter@chocky.org>

	* source/Makefile.in: Some files require _GNU_SOURCE to be defined.

Sat Jun 12 09:36:14 2004  Peter Naulls  <peter@chocky.org>

	* source/regex.c: Fix type usage
	* source/clib/math.h, source/clib/clib/bits/mathcalls.h,
	  source/clib/bits/mathdef.h, source/clib/mathinline.h,
	  source/clib/bits/nan.h: Add glibc math headers.
	* source/clib/machine/huge_val.h, source/clib/machine/nano.h:
          Remove old math headers.
	* source/clib/netdb.h: Add missing EAI_* defines.
	* source/clib/regex.h: Updated header from glibc
	* source/clib/stdlib.h: Extra include for sys/types.h as per
	  glibc to make correct types visible.
	* source/clib/bits.in.h: Avoid upsetting C++.
	* source/clib/unixlib/features.h: Include definitions from glibc,
	  fix wording.
	* source/math/j1.c, source/math/fmod: Prevent warnings
	* source/netlib/getpeernam.c: Update function header to match
	  declaration
	* source/unix/fstat.c, source/unix/lseek.c, source/unix/lstat.c:
	  Add 64-bit variants.
	* source/clib/unixlib/unix.h, source/common/funcallerr.c,
	  source/resource/initialise.c, source/resource/setprior.c,
	  source/resource/ulimit.c, source/signal/_signal.s,
	  source/sys/_alloca.s, source/sys/_exec.s, source/sys/_syslib.s,
	  source/sys/_vfork.s, source/sys/brk.c, source/sys/debug.c,
	  source/sys/exec.c, source/sys/stackalloc.c, source/unix/unix.c:
	  Rename __base, __lomem, __himem, and other unixlib internal
	  values delcared in unix.h as per discussion GCCSDK mailing list. 

Sun Jun  6 13:22:36 2004  John Tytgat  <John.Tytgat@aaug.net>

	* source/unix/uname.c: support for extracting RISC OS part number.

Sat Jun  5 21:49:35 2004  John Tytgat  <John.Tytgat@aaug.net>

	* source/netlib/inet_ntoa.c (inet_ntoa): sprintf() used incorrect
	  conversion specification.

Sat Jun  5 15:58:28 2004  John Tytgat  <John.Tytgat@aaug.net>

	* source/math-asm/_sincos.s (__sincos): Results got written to
	incorrect pointers.

Tue Jun  1 19:42:03 2004  Nick Burrett  <nick@dsvr.net>

	* kernel.h: Fix __THROW attribute positioning.

Mon May 31 14:40:09 2004  Alex Waugh  <alex@alexwaugh.com>

	Based on a patch from John-Mark Bell <jmb@netsurf-browser.org>
	* source/sys/_syslib.s: Limit max size of heap dynamic area according
	  to __dynamic_da_max_size or progname$HeapMax variables.
	* source/clib/unixlib/features.h (__dynamic_da_max_size): Add
	  declaration.
	* Docs/ReadMe: Document max size settings.

Tue May 18 22:43:00 2004  John Tytgat  <John.Tytgat@aaug.net>

	* source/signal/post.c: moved __ul_errbuf and __ul_fp_registers
	  declaration to errno.h; added #include errno.h; beautify output
	  of write_backtrace().
	* source/clib/errno.h: updated __ul_errbuf declaration; added
	  __ul_fp_registers declaration;  __ul_errbuf and __ul_fp_registers
	  are ony declared when __UNIXLIB_INTERNALS is defined.

Sun May 16 19:47:14 2004  Alex Waugh  <alex@alexwaugh.com>

	* signal/sigsuspend.c: Suspend only the current thread not the
	  entire process.
	* signal/sleep.c: Likewise.
	* sys/_syslib.s: Add missing IMPORTs.

Sun May 16 13:45:07 2004  James Bursa  <bursa@users.sourceforge.net>

	* signal/_signal.s: Store fp registers on a fp exception.
	* signal/post.c (post_signal): Print error buffer and fp registers.

Wed May 12 23:01:30 2004  Alex Waugh  <alex@alexwaugh.com>

	* signal/_signal.s (__setup_signalhandler_stack): Support calling from
	  USR mode.
	* sys/_syslib.s: Call __setup_signalhandler_stack before raising a
	  signal on a stack overflow.

Mon May 10 13:52:40 2004  Peter Naulls  <peter@chocky.org>

	* clib/setjmp.h: Reinstate setjmp macro so it doesn't cause problems.
	* clib/stdlib.h: Allow strtoll/ull to be seen.  This is a work around;
	  probably the whole of the stdlib.h functionality needs to be
	  rearranged to bring it into line with glibc.

Mon May 10 11:59:58 2004  Peter Naulls  <peter@chocky.org>

	* clib/netdb.h: Disable unimplemented functions.
	* clib/setjmp.h: Remove setjmp macro - it causes problems with C++.
	* clib/stdlib.h: Remove ato* macros which cause problems with C++,
	and replace with inline fucntions from glibc headers.  Also change
	other declarations as per glibc.
	* clib/strings.h: Fix ordering of #endif at the end.
	* unistd/lockf.c: Add lockf() function.

Mon May  3 18:32:45 2004  James Bursa  <james@semichrome.net>

	* unix/dev.c: Fix for fopen() then subsequent fread() on a directory
	  returning nonsense.

Sat May 01 23:33:35 2004  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/errno.h: Added EILSEQ.
	* source/sys/errlist.c: Likewise.

Wed Apr 21 20:42:11 2004  Alex Waugh  <alex@alexwaugh.com>

	* clib/fcntl.h: Don't define O_BINARY or O_TEXT if _POSIX_SOURCE.
	* netlib/accept.c: Remove unecessary use of O_BINARY.
	* netlib/socket.c: Likewise.

Tue Apr 20 21:57:51 2004  John Tytgat  <John.Tytgat@aaug.net>

	* source/assert.c (__assert_fail): Renamed to __assert2 & paremeter
	  order shuffling to match Norcroft SCL implementation.
	* source/clib/assert.h: Likewise.  Also using __func__ to print
	  function name.
	* source/wchar/wctype.c: Added RCS header.

Sat Apr 17 11:50:11 2004  Nick Burrett  <nick@dsvr.net>

	* sys/byteorder.h: Add __THROW attribute.
	* sys/file.h, sys/ioctl.h, sys/mman.h, sys/netdb.h: Likewise.
	* sys/poll.h, sys/resource.h, sys/select.h: Likewise.
	* sys/stat.h, sys/statfs.h, sys/syslog.h, sys/time.h: Likewise.
	* sys/timeb.h, sys/times.h, sys/uio.h: Likewise.
	* sys/utsname.h, sys/wait.h: Likewise.

Thu Apr 15 23:09:30 2004  Alex Waugh  <alex@alexwaugh.com>

	* assert.h: __THROW should appear before any __attribute__.
	* math.h, setjmp.h, stdio.h, stdlib.h, string.h: Likewise.
	* time.h, unistd.h: Likewise.

Mon Apr 12 14:02:24 2004  Nick Burrett  <nick@dsvr.net>

	* alloca.h: Add GCC-specific small optimiser hints to function
	definitions.
	* assert.h, complex.h, ctype.h, dirent.h, fcntl.h: Likewise.
	* fenv.h, getopt.h, glob.h, grp.h, inttypes.h: Likewise.
	* kernel.h, locale.h, math.h, setjmp.h, signal.h: Likewise.
	* stdio.h, stdlib.h, string.h, time.h: Likewise.
	* pwd.h, unistd.h: Likewise.

Mon Apr 12 10:37:35 2004  Nick Burrett  <nick@dsvr.net>

	* unix/unix.c (_exit): Set DDEUtils Prefix when parent process
	exits.  Add an assertion failure if __u is NULL.
	(__unixinit): Add more explanatory comments.

Sat Apr 10 11:23:16 2004  Nick Burrett  <nick@dsvr.net>

	* stdint.h (uintptr_t): Move declaration to be not influenced
	by __intptr_t_defined.

Sat Mar 27 12:58:06 2004  Peter Naulls  <peter@chocky.org>

	* ar.h: Add Unix 'ar' format support header.

Wed Mar 24 22:22:01 2004  Alex Waugh  <alex@alexwaugh.com>

	* source/pthread/_context.s (pthread_call_every): Check that our
	  environment handlers are in place before setting a callback.
	* source/signal/_signal.s (__h_cback): Check that the return PC is
	  within the wimpslot.
	* source/sys/_syslib.s (__upcall_handler_addr): New variable.

Wed Mar 17 20:00:14 2004  John Tytgat  <John.Tytgat@aaug.net>

	* !Help: Consisting spelling & notation.
	* Docs.ReadMe: Added "Name registration" section.
	* source/clib/sys/cdefs.h: Avoid annoying Norcroft compiler warning
	  on undefined #define symbol to be evaluated as 0.
	* source/clib/unixlib/unix.h: Changed comment on dde_prefix.
	* source/signal/sigvec.c: Static variables wrapped_handlers and
	  wrapped_masks can be (temporary ?) disabled too.
	* source/stdlib/realpath.c: Minor cleanup.
	* source/sys/exec.c: Beautify comments.
	* source/sys/vfork.c (free_process): Free process' dde_prefix.
	* source/unix/unix.c (_exit): Free process' dde_prefix. Restore
	  DDEUtils' Prefix to what it was at startup (instead of resetting
	  it what the documentation is saying).  Also don't set DDEUtils'
	  Prefix at startup with "@" because this triggers bugs in its path
	  handling on some versions of DDEUtils module.
	
Tue Mar 16 19:03:59 2004  Nick Burrett  <nick@dsvr.net>

	* unixlib/unix.h (__exec_cli): Add prototype.

Sat Mar 06 13:05:58 2004  Graham Shaw  <gdshaw@sagitta.demon.co.uk>

	* source/sys/exec.c (execve): Restore wimpslot and himem to
	  previous values before executing the command. Prevents a program
	  exec()ed from a vfork()/exec()ed child process from overwriting
	  the original parent.
	* source/sys/_exec.s (__exec_cli): New function.
	* source/sys/_syslib.s (__env_wimpslot): Separate out from
	  __env_riscos_and_wimpslot.

Sun Feb 29 16:36:30 2004  Alex Waugh  <alex@alexwaugh.com>

	* source/clib/pthread.h: Make __pthread_start/stop_ticker
	  visible to user programs.
	* source/clib/unixlib/local.h: Clarify description for
	  __RISCOSIFY_FILETYPE_NOT_SET.

Mon Feb 23 16:04:06 2004  Peter Naulls  <peter@chocky.org>

	* source/clib/unixlib/sigstate.h, source/unix/close.c,
	  source/signal/_coredump.s, source/signal/_signal.s,
	  source/signal/post.c: Enable writing of backtraces etc to
	  stderr.  This code isn't new, but wasn't previously enabled.
	  It is also somewhat imperfect, and doesn't handle all cases
	  on RISC OS 4 and 5, esp. register dumps.  You are encouraged to
	  improve it.

Sat Feb 21 20:58:10 2004  Peter Naulls  <peter@chocky.org>

	* source/clib/strings.h: Remove extra #ifdef

Sun Feb 15 18:45:16 2004  Peter Naulls  <peter@chocky.org>

	* source/clib/unixlib/types.h, source/clib/math.h,
	  source/clib/stdlib.h: Use __extension__ for long long types
	  to avoid warnings.
	* source/clib/strings.h, source/clib/string.h: Handle
	  includes as GLIBC does.

Mon Feb 09 21:09:02 2004  Alex Waugh  <alex@alexwaugh.com>

	* source/stdlib/realpath.c (realpath): Preserve any ,xyz extension.

Sun Feb 08 00:19:58 2004  Alex Waugh  <alex@alexwaugh.com>

	* Docs/ReadMe: Added sections on stack/heap changes and pthreads.

Sat Feb 07 18:07:37 2004  Alex Waugh  <alex@alexwaugh.com>

	* source/common/riscosify.c (__sfixfind): Add length parameter to ease
	  calling from rname.c
	* source/clib/unixlib/local.h: Likewise.
	* source/common/unixify.c: Likewise.
	* source/unix/dirent.c: Likewise.
	* source/unix/unlink.c: Likewise.

Sun Jan 18 16:08:06 2004  Alex Waugh  <alex@alexwaugh.com>

	* source/netlib/socketpair.c: Fix syntax error.

Thu Jan 15 00:18:59 2004  John Tytgat  <John.Tytgat@aaug.net>

	* Setup,feb: Removed.
	* gen-makefiles.pl: UnixHdr$Dir -> Unix:
	* objs/Makefile.in: Likewise.
	* source/clib/swis.h: Added DDEUtils_ReadPrefix.
	* source/clib/netinet/tcp.h: Bitfields can only be taken from int so
	  slightly different struct tcphdr & tcp_info definition (patch from
	  Theo Markettos <theo@markettos.org.uk>).
	* source/clib/sys/socket.h: Added SOMAXCONN #define (patch from Theo
	  Markettos <theo@markettos.org.uk>).
	* source/clib/unixlib/local.h: Added __get_dde_prefix().
	* source/clib/unixlib/unix.h: Added dde_prefix to "struct proc" and
	  increased _PROCMAGIC to 0xfedcfa63.
	* source/common/funcallerr.c (__funcall_error): sizeof() usage.
	* source/common/prefix.c (__get_dde_prefix): New file.
	* source/netlib/socketpair.c: Reident.
	* source/sys/vfork.c: save DDEUtils_Prefix value during __vfork() and
	  restore it at __vexit().
	* source/unix/chdir.c (chdir): make use of __get_dde_prefix() instead of
	  __getenv_from_os("Prefix$Dir").
	* source/unix/getcwd.c (getcwd): Likewise.
	* source/unix/unix.c (__unixinit): Small src cleanup; Call only
	  DDEUtils_Prefix("@") when there isn't a DDEUtils_Prefix defined.

Wed Jan 07 20:58:37 2004  Nick Burrett  <nick@dsvr.net>

	* getopt.h: Prevent inclusion of ctype.h.

Mon Jan 05 23:50:26 2004  John Tytgat  <John.Tytgat@aaug.net>

	* Docs/ReadMe: Added section on "UnixFS$/xxx" environment variables.
	* source/regex.c (re_comp, re_exec): Enabled for old BSD4.2 based
	  sources (like CVS).
	* source/strtoll.c(strtoll): Enabled for Norcroft compiler.
	* source/strtoull.c(strtoull): Likewise.
	* source/clib/limits.h(LONG_LONG_MIN, LONG_LONG_MAX, QUAD_MAX): Likewise.
	* source/clib/sys/syslog.h: Removed _PATH_LOG definition as it doesn't
	  get used (we log everything via the Syslog module if present).
	* source/clib/unixlib/unix.h(__getenv): Removed.
	* source/unix/getenv.c(__getenv): Likewise.  Its CACHE parameter was
	  always set to 1 so we could clean up this source a bit.
	* source/scl/_koscli.s: v6 doesn't need to be preserved.
	* source/unix/unix.c(_exit): Only resetting DDEUtils_Prefix when current
	  process doesn't have a parent.

Sat Jan 03 00:11:39 2004  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/termios.h: Redefined the B* baud values so that they fit
	  into a char (= variable type of sg_ispeed and sg_ospeed in struct
	  sgttyb).  Renamed __ispeed and __ospeed into c_ispeed and c_ospeed.
	* source/clib/unixlib/unix.h: Removed useless __bsd_speeds.
	* source/termios/cfgetispee.c(cfgetispeed): Added argument checking
	  and renamed __ispeed and __ospeed into c_ispeed and c_ospeed.
	* source/termios/cfgetospee.c(cfgetospeed): Likewise.
	* source/termios/cfsetispee.c(cfsetispeed): Likewise.
	* source/termios/cfsetospee.c(cfsetospeed): Likewise.
	* source/termios/tcgetattr.c(tcgetattr): __bsd_speeds is no longer
	  needed.
	* source/termios/tcsetattr.c(tcsetattr): Likewise.
	* source/unix/tty.c: Removed convert_baud_rate().  Renamed __ispeed and
	  __ospeed into c_ispeed and c_ospeed.  sg_ospeed gets now updated
	  in __ttyioctl(TIOCGETP) which makes password typing in getpass()
	  invisible.
	* source/unix/unix.c(__unixinit): Got rid of compiler warnings.

Tue Dec 30 12:02:35 2003  Peter Naulls  <peter@chocky.org>

	* source/wchar/wcstoul.c: Removed file containing duplicate
	  function.

Mon Dec 29 18:59:40 2003  Peter Naulls  <peter@chocky.org>

	* source/alloc.c, source/memchr.c, source/qsort.c, source/clib/math.h,
	  source/common/objattr.c, source/common/serial.c, source/common/stat.c,
	  source/locale/setlocale.c, source/math/j0.c, source/math/jn.c,
	  source/netlib/inet_ntoa.c, source/netlib/shutdown.c,
	  source/netlib/socketpair.c: Remove warnings

Mon Dec 29 17:51:43 2003  Peter Naulls  <peter@chocky.org>

	* source/math/modf.c, source/math/modff.c, source/netlib/ntop.c,
	  source/netlib/pton.c, source/wchar/wcstoq.c, source/wchar/wcstouq.c:
	  Remove files containing duplicate functions.

Mon Dec 29 16:34:25 2003  Peter Naulls  <peter@chocky.org>

	* source/sys/_vfork.s: Alias fork to vfork as a symbol
	* source/clib/sys/dirent.h: sys/dirent.h doesn't exist in glibc; only
	  dirent.h.
	* source/clib/dirent.h: Define MAXNAMLEN
	* source/clib/sys/un.h: Add, even though it isn't supported, it is
	  required to keep some programs happy.
	* source/pwd/pwdread.c: Improve behaviour of setting of pwd structure,
	  including determining username under Select.

Mon Dec 22 21:29:50 2003  John Tytgat  <John.Tytgat@aaug.net>

	* Docs/ReadMe: Documented the new uid feature.
	* source/clib/unixlib/unix.h (__unixlib_fatal): Documented the NULL
	  parameter behaviour.
	* source/sys/_syslib.s (__unixlib_fatal): Calling with NULL parameter
	  works again.
	* source/unix/features.c (features): Added uid feature (was formally
	  known as Unix$uid).
	* source/unix/unix.c (__unixinit): More informative __unixlib_fatal()
	  error messages; moved Unix$uid support to features.c; removed Unix$tty
	  support (use command line redirection).

Sun Dec 21 12:21:56 2003  Stefan Bellon  <sbellon@sbellon.de>

	* crypt/crypt_util.c (setkey_r): Add cast to fix Norcroft compilation.

Mon Dec 15 16:52:40 2003  Peter Naulls  <peter@chocky.org>

	* common/riscosify.c: leaf_len becomes negative in some odd
	  cases generated by 'make'.  Don't Try to copy leaf then.

Thu Dec 4 22:25:16 2003  David Marston  <david@illudium.org.uk>

	* sys/_jmp.s: Add comment.
	* sys/_vfork.s: Correct pid offset in jmp_buf.
	* sys/vfork.c: Likewise.

Sun Nov 23 22:05:07 2003  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/unixlib/asm_dec.s: Added
	  XFilter_(De)Register{Pre|Post}Filter SWI numbers.
	* source/clib/unixlib/unix.h: Renamed __wimpprogram to __taskhandle.
	* source/pthread/_context.s: Used NAME macro; pthread routines now
	  work for Wimp/TaskWindow applications too.
	* source/pthread/_exit.s: Used NAME macro.
	* source/pthread/_ints.s: Likewise.
	* source/pthread/_yield.s: Likewise.
	* source/pthread/cond.c: Added #include <stdio.h> when PTHREAD_DEBUG
	  is #define'd.
	* source/sys/_syslib.s: Instead of setting __wimpprogram to 1 when
	  we're multitasking, we fill the non zero taskhandle value in
	  __taskhandle.
	* source/signal/sleep.c: Renamed __wimpprogram to __taskhandle.
	* source/time/getitmr.c: Likewise.
	* source/time/setitmr.c: Likewise.
	* source/unix/tty.c: Likewise.
	* source/unix/unix.c: Likewise.
	* source/unix/fcntl.c: Fixed typo : "!=" -> "|=" !

Sat Nov 22 00:47:33 2003  John Tytgat  <John.Tytgat@aaug.net>

	* !Help: SharedULib has to come into !System.310.Modules, not
	  !System.Modules.  Advised to use the !System merger instead of
	  manually copying.

Fri Nov 21 21:25:47 2003  Peter Naulls  <peter@chocky.org>

	* clib/wctype.h, wchar/wctype.h: Added wctype functions.

Fri Nov 21 14:26:31 2003  Peter Naulls  <peter@chocky.org>

	* clib/time.h: Rename parameters inline with glibc, and to
	  avoid warnings
	* clib/sys/cdefs.h: Additional declarations inline with glibc
	* clib/unixlib/features.h: Remove declarations repeated in
	  cdefs.h
	* clib/unistd.h: Bring somewhat inline with glibc, and avoid
	  warnings with brk/sbrk declarations.
	* sys/brk.c: Change sbrk defintion to match above

Wed Nov 19 00:00:01 2003  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/net/if.h: Commented out declaration of the if_*()
	  routines (we don't have them implemented).
	* Boot,fe1: Removed last new-line character.
	* Run,fe1: Likewise.
	* Setup,fe1: Likewise.
	* !Help: Cleaned up "Installation" section a bit; Provided the
	  "Distributing of UnixLib based programs" section.
	* CallASWI.CallASWI,ffa: Removed (see !Help for info on obtaining the
	  latest version).
	* CallASWI.ReadMe: Likewise.

Sat Nov 01 21:40:00 2003  John Tytgat  <John.Tytgat@aaug.net>

	* source/unix/unix.c (_exit): Previous fix didn't properly unset
	  DDEUtils_Prefix.

Thu Oct 30 22:58:57 2003  Alex Waugh  <alex@alexwaugh.com>

	* unix/getcwd.c (getcwd): Canonicalise result before unixifying it.
	  Remove obscure methods for finding the cwd.

Sun Oct 26 14:15:00 2003  John Tytgat  <John.Tytgat@aaug.net>

	* objs/Makefile.in: Added rule to build SharedULib.  Also default
	  "All" rule will copy UnixLib into <UnixHdr$Dir>.UnixLib.
	* objs/.cvsignore: Added SharedULib,ffa.
	* source/clib/bits/netdb.h: Changed type of 'request' param fo ioctl
	  call from 'int' to 'unsigned long'.
	* source/clib/sys/netdb.h: Likewise.
	* source/clib/unixlib/dev.h: Likewise.
	* source/unix/dev.c: Likewise.
	* source/unix/ioctl.c: Likewise.
	* source/unix/tty.c: Likewise.  Avoided Norcroft compiler warning
	  too.
	* source/clib/sys/ioctl.h: Sync'ed with information in RISCOS Ltd.'s
	  StubsG ioctl.h file.  Added further compatibility with
	  COMPAT_INET4.
	* source/unix/unix.c: Setup DDEUtils_Prefix with "@" so that chdir()
	  calls don't change RISC OS' CSD.  When DDEUtils module is not
	  loaded, RISC OS' CSD will change.  Suggestion by Stefan Bellon.

Tue Oct 21 20:26:20 2003  David Marston  <david@illudium.org.uk>

	* module/sul.s: Fix 32-bit behaviour

Sun Oct 12 22:16:01 2003  John Tytgat  <John.Tytgat@aaug.net>

	* source/unix/dev.c (__getdevtype): Introduced rofs2dev mapping table
	  which maps RISC OS FS to Unix devices where it makes sense.  Solves
	  null: as stdin redirection problem reported by Stefan Bellon.

Mon Oct 06 20:00:01 2003  John Tytgat  <John.Tytgat@aaug.net>

	* Docs/ReadMe: Added some more info on UnixEnv$<program name>$sfix.
	* unixlib/local.h: Allocated __RISCOSIFY_STRICT_UNIX_SPECS
	  __riscosify_control bit to disable the RISC OS filename check in
	  __riscosify[_std]().
	* source/common/objattr.c (__object_get_attrs): incorrect dealing with
	  filetype derived from Unix filename.
	* source/common/riscosify.c (guess_or_null): Support for
	  __RISCOSIFY_STRICT_UNIX_SPECS.
	* source/unix/chdir.c (chdir): Disable suffix swapping for directories.
	* source/unix/dev.c (__fsstat): Likewise.
	* source/unix/dirent.c (opendir): Likewise.
	* source/unix/mkdir.c (mkdir): Likewise.
	* source/unix/rmdir.c (rmdir): Likewise.

Tue Sep 30 18:38:25 2003  Alex Waugh <alex@alexwaugh.com>

	* alloc.c: Use __riscos rather than __riscos__ to keep Norcroft happy.

Tue Sep 18 23:40:00 2003  John Tytgat  <John.Tytgat@aaug.net>

	* objs/Makefile.in: Added comment on Norcroft's "shrinkwrap bug".

Tue Aug 19 00:34:27 2003  John Tytgat  <John.Tytgat@aaug.net>

	* .cvsignore: MKDir,feb removed.  We don't generate this anymore.
	* gen-makefiles.pl: No longer generating MKDir,feb but include a .INIT
	  section in the objs\Makefile,fe1 file; Also adding a "This file is
	  automatically generated by gen-makefiles.pl" comment line.
	* Docs/ReadMe: Added info on RISCOS Ltd.'s UnixLib, sfix feature,
	  __dynamic_no_da & __dynamic_da_name WEAK symbols.
	* objs/Makefile.in: Added .INIT section.  The rest will be added by
	  gen-makefiles.pl.
	* clib/unixlib/features.h: Added definition for __dynamic_no_da and
	  __dynamic_da_name WEAK symbols.
	* common/_exist.s (__set_feature_imagefs_is_file): This commented out
	  routine contained a copy/paste error.
	* common/stat.c: Removed compiler warning.
	* common/unixify.c: Take only MimeMap into account when
	  __RISCOSIFY_FILETYPE_NOT_SET is not set.
	* unix/dirent.c: Don't generate ,xyz filetype extention when MimeMap
	  has to be taken into account (i.e. when __RISCOSIFY_FILETYPE_NOT_SET
	  is not set).
	* unix/features.c: Made __sfix_default non writable; get_program_name()
	  no longer corrupts fname_buf for very long program names.
	* common/riscosifyc.c: Removed.  It shouldn't be necessary.
	
Fri Aug 15 16:13:01 2003  John Tytgat  <John.Tytgat@aaug.net>

	* clib/unixlib/features.h: _feature_imagefs_is_file is now a WEAK
	symbol. Added routines __get_feature_imagefs_is_file() and
	__set_feature_imagefs_is_file() for internal purposes. Default value
	is 0. Patch from Stefan Bellon.
	* common/_exist.s: Likewise.
	* unix/dev.c: Likewise.
	* unix/features.c: Likewise.
	* unix/unlink.c: Likewise.
	* Docs/ReadMe: Added info on the WEAK'ly defined symbols.

Sun Aug 03 18:14:27 2003  John Tytgat  <John.Tytgat@aaug.net>

  	* common/unixify.c (__unixify): filetype extension code will first look
  	if the filetype can't be derived from the filename extension
	& MimeMap.  If so, then there won't be a filetype extension added to
	the filename.  Also, __unixify wrongly returned the end of the buffer
	(instead of the start) when the filetype extension code got activated.
  	* unix/unix.c: Disabled debug
  	* wchar/btowc.c: ANSI prototyping.
  	* wchar/mbrlen.c: Likewise.
  	* wchar/mbsinit.c: Likewise.
  	* wchar/wcsdup.c: Likewise.
  	* wchar/wctob.c: Likewise.
  	* wchar/wmemcpy.c: Likewise.
  	* wchar/wmemmove.c: Likewise.

Thu Jul 31 20:55:32 2003  Alex Waugh <alex@alexwaugh.com>

	* common/_riscosify.s: Fix typo.

Wed Jul 30 00:03:42 2003  Nick Burrett  <nick@dsvr.net>

	* stdarg.h: Force GCC to use its own internal header.
	(__gnuc_va_list): Define for all other target types.

	* varargs.h: Header is now obsolete.  Add #error lines; remove
	all other code.

	* stdio.h (fopen, freopen, fputs): Add __restrict pointer qualifier.
	(vsprintf, vfprintf, vprintf): Likewise.  Use __gnuc_va_list.
	(sprintf, fprintf, printf, sscanf, fscanf, scanf): Likewise.
	(vsnprintf): Likewise.  Add GCC __format__ attributes.
	(snprintf, vscanf, vfscanf, vsscanf): Likewise.

	* sys/syslog.h (syslog): Add GCC __format__ attribute.
	(vsyslog): Likewise.  Use __gnuc_va_list.

	* assert.c (__assert_fail): Fix compiler warning.

	* alloca.h: Get only the definition of size_t.
	* complex.h (_Complex_I): Add __extension__.

	* dirent.h: Add __restrict pointer qualifier to functions.
	* glob.h: Likewise.
	* grp.h: Likewise.
	* inttypes.h: Likewise.
	* pthread.h: Likewise.
	* pwd.h: Likewise.
	* regex.h: Likewise.
	* signal.h: Likewise.
	* stdio.h: Likewise.
	* stdlib.h: Likewise.
	* string.h: Likewise.
	* time.h: Likewise.
	* unistd.h: Likewise.

Mon Jun 23 21:10:01 2003  John Tytgat  <John.Tytgat@aaug.net>

	* MKDir,fe1: Removed objs.clib & objs.clib.o directory creation.
	* objs/Makefile.in: APCS-R builds are no longer supported.
	* source/clib/getopt.h: Full prototyping for getopt(), we don't have
	  other definitions in other libraries.
	* source/clib/setjmp.h: Added __executing_signalhandler and
	  __pthread_worksemaphore to jmp_buf; Added
	  saved_currently_handling to sigjmp_buf.
	* source/clib/unixlib/asm_dec.s: APCS-R builds are no longer supported;
	  __get_errno macros doesn't need an assert on its registers.
	* source/clib/unixlib/unix.h: Removed comment on __fpflag usage in
	  setjmp() and longjmp() (as we're minimally need FPE 4.00 now).
	* source/pthread/_context.s: APCS-R builds are no longer supported.
	* source/pthread/_yield.s: Likewise.
	* source/signal/_coredump.s: Likewise.
	* source/signal/sigexec.s: Likewise.
	* source/signal/_signal.s: Removed unnecessary IMPORT |_exit|.
	* source/sys/_jmp.s: Added __executing_signalhandler and
	  __pthread_worksemaphore to jmp_buf struct.
	* source/sys/_syslib.s: APCS-R builds are no longer supported; Moved
	  __unixlib_fatal from unix.c to here and use __signalhandler_xx
	  as stack parameters as you might not have a valid one.
	* source/sys/sigsetjmp.c: Support for saved_currently_handling in
	  sigjmp_buf.
	* source/unix/unix.c(__unixlib_fatal): Moved to _syslib.s and added
	  explicit stack setup.

Mon Jun 23 10:31:08 2003  Peter Naulls  <peter@chocky.org>

	* source/unix/fcntl.c: Patches missed from 2.95 trunk.
	  Fix use of O_EXECCL flag, and add F_SETOWN stub.

Fri Jun 20 00:50:01 2003  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/errno.h (__ul_errbuf): Not a char* but a struct
	  definition.
	* source/signal/_signal.s (_kernel_last_oserror): Small optimisation.
	* source/signal/post.c: Removed the non used extern definitions.
	* source/sys/_jmp.s: Added some comments.
	* source/sys/_os.s (__os_prdec): Stack ptr needs to be decreased
	  during the complete routine call.
	* source/sys/errlist.c: Using struct __ul_errbuf member.

Tue Jun 17 20:45:01 2003  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/unixlib/local.h: Removed obsolete __RISCOSIFY_DROP_VOWEL.

Tue Jun 17 00:09:01 2003  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/unixlib/local.h: Removed obsolete uname().  Use
	  riscosify[_std]() instead.  Removed obsolete *_TRUNCATE bits in
	  __riscosify_control.  Changed __RISCOSIFY_FILETYPE_SET into
	  __RISCOSIFY_FILETYPE_NOT_SET so that the current default value
	  __riscosify_control becomes 0 again.  Hide __get_riscosify_control()
	  behind __UNIXLIB_INTERNALS.  Defined __set_riscosify_control().
	* source/common/_riscosify.s: Defined __set_riscosify_control().
	* source/common/objattr.c: Changed __RISCOSIFY_FILETYPE_SET into
	  __RISCOSIFY_FILETYPE_NOT_SET.
	* source/common/riscosify.c: Likewise.
	* source/common/uname.c: Removed.
	* source/common/riscosifyc.c: Added comment that __riscosify_control
	  is a weak symbol.
	* source/common/serial.c: Changed comment about obsoleted __uname().
	* source/stdio/rename.c: Likewise.
	* source/unix/features.c: Removed initialisation of __riscosify_control
	  as the default value is again 0 in which is initialised in
	  source/common/riscosifyc.c.  Make use of __set_riscosify_control()
	  when the "nonametrans" feature is defined.

Mon Jun 16 22:00:01 2003  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/signal.h: Changed SISERR into SISOSERROR in order to
	  be compatible with SharedCLibrary.
	* source/clib/unixlib/asm_dec.s: Likewise.
	* source/signal/_signal.s: Likewise.
	* source/signal/signame.c: Likewise.
	* source/sys/exec.c: Likewise.

Sat Jun  7 09:31:05 2003  Alex Waugh  <alex@alexwaugh.com>

	* sys/_alloca.s: Fix non 32bit code.

Sat Jun  7 04:20:04 2003  John Tytgat  <John.Tytgat@aaug.net>

	* .cvsignore: Added MKDir,feb
	* gen-makefiles.pl: Removed cdir of objs.clib.o
	* objs/.cvsignore: Added Makefile,fe1
	* source/clib/string.h: Renamed __strnlen() into strnlen()
	* source/clib/time.h: Renamed localtime_p() into localtime_r()
	* source/clib/sys/cdef.h: Added #undef __ptr_t
	* source/clib/sys/features.h: Likewise.
	* source/common/objattr.c: Removed unused variables.
	* source/common/riscosify.c: Likewise.
	* source/signal/post.c: Likewise.
	* source/unix/chmod.c: Likewise.
	* source/unix/fstat.c: Likewise.
	* source/signal/sigvec.c: wrapper_handle() and convert_mask() are not
	  used.
	* source/sys/errlist.c: Cast away return param __set_errno().

Sun Jun  1 21:46:05 2003  Alex Waugh  <alex@alexwaugh.com>

	* clib/unistd.h (fchdir): Add decl.
	* unistd/fchdir.c: New file.
	* unix/fchown.c: Remove file, it duplicates unistd/fchown.c

Sun Jun  1 18:20:15 2003  Alex Waugh  <alex@alexwaugh.com>

	* module/sul.s: Fix non 32bit SWI returns.

Mon May 26 19:47:04 2003  Peter Naulls  <peter@chocky.org>
	* clib/wchar.h: __mbrtowc and __mbrlen don't exist - avoid
	  inline mbrlen.

Mon May 26 18:26:03 2003  Alex Waugh  <alex@alexwaugh.com>

	* pthread/create.c (__pthread_create): Initialise the saved SPSR.
	* pthread/init.c (mainthread): Fix linkage.
	* pthread/testcancel.c (pthread_testcancel): Don't cancel if
	  context switching is disabled.

Sun May 25 22:44:12 2003  Alex Waugh  <alex@alexwaugh.com>

	* MKDir,feb: Remove file, now autogenerated.
	* Makefile: Remove file, now autogenerated.
	* Makefile.in: Template for Makefile.
	* gen-makefiles.pl: Script to generate Makefiles.
	* Docs/ReadMe: Add section on stub functions.
	* Docs/stub: Remove file.
	* objs/Makefile,fe1: Remove file, now autogenerated.
	* objs/Makefile.in: Template for Makefile.
	* source/Makefile: Remove file, now autogenerated.
	* source/Makefile.in: Template for Makefile.
	* source/netlib/socketpair.c: Add #includes and casts for Norcroft.
	* source/regex.c: Likewise.
	* source/signal/sigvec.c: Comment out bits that don't compile.
	* source/unix/link.c: Remove file. Duplicates functions in unistd/*link.c
	* source/wchar/wcstod.c: Add dummy function so it compiles.
	* source/wchar/wcstof.c: Likewise.
	* source/wchar/wcstol.c: Likewise.
	* source/wchar/wcstold.c: Likewise.

Sun May 18 18:04:16 2003  Alex Waugh  <alex@alexwaugh.com>

	* objs/Makefile,fe1: Add lrintf.c and llrintf.c
	* source/Makefile: Likewise.
	* source/clib/math.h: Add decls.
	* source/math/llrintf.c: New file from glibc 2.3.1
	* source/math/lrintf.c: Likewise.

Wed May 14 00:01:05 2003  John Tytgat  <John.Tytgat@aaug.net>

	* netlib/_accept.s, netlib/_getpeerna.s, netlib/_getsockna.s,
	  netlib/_recvfrom.s, netlib/_recvmsg.s, netlib/_sendmsg.s:
	  Readded COMPAT_INET4 macros undoing Peter's change at 21 Apr 2003.
	* netlib/_net_error.s: typo spoiled the error numbers returned from the
	  Internet SWI calls.
	* unix/dev.c: Remove unused variables.  Added #include <ctype.h>.
	* unix/mkdir.c: Remove unused variable.
	* unix/rmdir.c: Likewise.
	* unix/unlink.c: Likewise.
	* unix/utime.c: Wrote corrupted RISC OS filetype.
	* !Help: Updated.
	* Docs/ReadMe: Added "Compile-time features" section.

Tue May 13 22:46:38 2003  Alex Waugh  <alex@alexwaugh.com>

	* math-asm/_acosf.s: Keep sp valid at all times.
	* math-asm/_asinf.s: Likewise.
	* math-asm/_atanf.s: Likewise.
	* math-asm/_ceilf.s: Likewise.
	* math-asm/_cosf.s: Likewise.
	* math-asm/_coshf.s: Likewise.
	* math-asm/_expf.s: Likewise.
	* math-asm/_floorf.s: Likewise.
	* math-asm/_ldexpf.s: Likewise.
	* math-asm/_log10f.s: Likewise.
	* math-asm/_logf.s: Likewise.
	* math-asm/_modf1f.s: Likewise.
	* math-asm/_sinf.s: Likewise.
	* math-asm/_sinhf.s: Likewise.
	* math-asm/_tanf.s: Likewise.
	* math-asm/_tanhf.s: Likewise.

Tue May 13 21:51:36 2003  Alex Waugh  <alex@alexwaugh.com>

	* objs/Makefile,fe1: Add getopt1.c
	* source/Makefile: Likewise.
	* source/clib/unixlib/features.h: Define __GNU_LIBRARY__
	* source/clib/getopt.h: Replace with file from glibc 2.3.1
	* source/unix/getopt.c: Likewise.
	* source/unix/getopt1.c: New file from glibc 2.3.1

Sun May 11 22:01:15 2003  Alex Waugh  <alex@alexwaugh.com>

	* sys/_os.s (__os_file, __os_fread, __os_fwrite, __os_args): Store a1
	  before clearing it.

Sun May 11 19:13:12 2003  John Tytgat  <John.Tytgat@aaug.net>

	* objs/Makefile,fe1: Specifying minimum Norcroft C version 5.53.
	* clib/unixlib/features.h: Avoid double #define's when project header
	  files #define things like __attribute__ & friends themselves.
	* source/signal/_signal.s: Removed "IMPORT __pthread_callback_pending"
	  (didn't exist).
	* source/sys/_syslib.s: Removed "IMPORT __h_upcall" (didn't exist).

Sun May 11 13:28:12 2003  John Tytgat  <John.Tytgat@aaug.net>

	* source/unix/chdir.c (chdir): chdir(".") did not work when Prefix$Dir
	  was defined.
	* objs/.cvsignore: Added.  Lets CVS ignore all derived objects when
	  using the Norcroft compiler.
	* source/clib/.cvsignore: Added.  Lets CVS ignore the created UnixLib
	  library object file.

Wed May  7 23:07:05 2003  Alex Waugh  <alex@alexwaugh.com>

	* clib/pthread.h (__pthread_key): Add a union for value, to avoid
	  const issues.
	* pthread/key.c: Use union to prevent const warning.
	* pthread/keydest.c: Likewise.
	* pthread/_ints.s: Preserve PSR bits of PC based on processor mode,
	  not APCS variant.
	* sys/_alloca.s: Likewise.
	* sys/_syslib.s: Likewise.

Tue May  6 23:29:21 2003  Alex Waugh  <alex@alexwaugh.com>

	* riscos-dist/Makefile: Remove !MKDir from binary !unixlib,
	  add !Setup to source !unixlib.
	* unixlib/objs/Makefile,fe1: Add missing files.
	* unixlib/source/Makefile: Add ffs files.
	* clib/string.h: Enable ffs decls.
	* clib/strings.h: Likewise.
	* string/ffs.c: New file implementing ffs().
	* string/ffsll.c: New file implementing ffsll().

Sat May  3 12:20:14 2003  Alex Waugh  <alex@alexwaugh.com>

	* signal/_signal.s: Move IMPORTs earlier in file for objasm.
	* resolv/res_hconf.c: Remove unneeded ;

Tue Apr 29 22:14:12 2003  Alex Waugh  <alex@alexwaugh.com>

	* unixlib/features.h: Don't pollute the userland namespace
	  with internal_function or weak_function.
	* sys/cdefs.h: Likewise.

Tue Apr 29 20:37:46 2003  Alex Waugh  <alex@alexwaugh.com>

	* sys/_syslib.s: Require FPEmulator 4.00 or higher
	* sys/_jmp.s: Remove STFE/LDFE code as SFM/LFM is available for
	  FPE >= 4.00
	* pthread/_context.s: Likewise.

Mon Apr 28 23:42:26 2003  Alex Waugh  <alex@alexwaugh.com>

	* sys/_os.s: Don't rely on flags being preserved across SWI calls.
	* sys/_syslib.s: Likewise.

Mon Apr 28 22:03:02 2003  Alex Waugh  <alex@alexwaugh.com>

	* Makefile: Remove fcrypt.c
	* fcrypt.c: Remove file, it has been replaced by crypt/*
	* opensock.c: Enable locking code for thread safety.
	* regex.c: Add standard UnixLib header.
	* system.c: Add cancellation point.
	* clib/bits/libc-lock.h: New file to map __libc_lock calls onto
	  pthread mutexes.
	* crypt/crypt_util.c: Enable locking code for thread safety.
	* netlib/accept.c: Thread safety patches.
	* netlib/bind.c: Likewise.
	* netlib/connect.c: Likewise.
	* netlib/getpeernam.c: Likewise.
	* netlib/getsocknam.c: Likewise.
	* netlib/getsockopt.c: Likewise.
	* netlib/listen.c: Likewise.
	* netlib/net.c: Likewise.
	* netlib/proto.c: Likewise.
	* netlib/recv.c: Likewise.
	* netlib/recvfrom.c: Likewise.
	* netlib/recvmsg.c: Likewise.
	* netlib/send.c: Likewise.
	* netlib/sendmsg.c: Likewise.
	* netlib/sendto.c: Likewise.
	* netlib/serv.c: Likewise.
	* netlib/setsockopt.c: Likewise.
	* netlib/shutdown.c: Likewise.
	* netlib/socket.c: Likewise.
	* netlib/socketpair.c: Add standard UnixLib header.
	* resolv/res_hconf.c: Enable locking code for thread safety.
	* signal/_signal.s: Thread safety patches.
	* signal/kill.c: Likewise.
	* signal/pause.c: Likewise.
	* signal/post.c: Likewise.
	* signal/sigaction.c: Likewise.
	* signal/sigaltstk.c: Likewise.
	* signal/sigpause.c: Likewise.
	* signal/sigpending.c: Likewise.
	* signal/sigprocmsk.c: Likewise.
	* signal/sigstack.c: Likewise.
	* signal/sigsuspend.c: Likewise.
	* signal/sigvec.c: Likewise.
	* signal/sleep.c: Likewise.
	* sys/brk.c: Likewise.
	* sys/debug.c: Likewise.
	* sys/execvp.c: Likewise.
	* sys/mman.c: Likewise.
	* sys/sigsetjmp.c: Likewise.
	* unix/waitpid.c: Likewise.

Mon Apr 28 13:05:24 2003  Alex Waugh  <alex@alexwaugh.com>

	* clib/pthread.h (__pthread_context_stack_sp,
	  __pthread_context_stack_sl): Remove.
	* clib/unixlib/asm_dec.s: Add CHGMODE macro to simplify changing
	  processor modes.
	* pthread/_ints.s (__pthread_unprotect_unsafe): Preserve a2, don't
	  yield if we are in the middle of a context switch.
	* pthread/_yield.s (pthread_yield): Improve reliability by calling
	  the context switcher directly rather than setting a callback.
	* pthread/cond.c: Formatting.
	* pthread/init.c (__pthread_init): Don't setup a stack for context
	  switcher (now uses signal handler stack).
	* pthread/lock.c: Fix typos.
	* pthread/once.c: Fix typo.
	* pthread/testcancel.c: Fix line endings in debug code.
	* signal/_signal.s, pthread/_context.s: Use a dedicated stack
	  for all signal handlers and pthread context switcher.
	  Make pthreads more tolerant of extra or missing callbacks.
	  Restore CPSR on exit from a callback.
	* sys/_syslib.s: Initialise signal handler stack.

Sun Apr 27 13:31:44 2003  John Tytgat  <John.Tytgat@aaug.net>

	* source/unix/chdir.c: Code failed when chdir() was done for a
	  subdirectory in the CSD.

Sat Apr 26 11:36:00 2003  Peter Naulls  <peter@chocky.org>
	* source/signal/signal.c, source/signal/post.c:
	  Add _GNU_SOURCE define, to allow use of sighandler_t.
	* source/strtod.c: Add an explicit atof function (as well
	  as the existing #define)

Fri Apr 25 15:14:29 2003  Peter Naulls  <peter@chocky.org>
	* clib/sys/cdefs.h: Added, from a patch by John T.  Didn't create
	  the needless misc directory in use with that, however.
	* clib/stddef.h: Add _WCHAR_T and _WINT_T defines as per glibc.
	* clib/signal.h: Add __USE_GNU wrapper to sighandler_t typedef.

Fri Apr 25 00:32:18 2003  John Tytgat  <John.Tytgat@aaug.net>

	* objs/Makefile,fe1: Forgot to specify APCS 3/32bit for assembler.
	* source/netlib/timeofday.c: Removed (duplicate of
	  source/time/gettod.c)
	* source/Makefile: Added fcrypt.c, strtoimax.c, strtoumax.c to OBJS.
	* source/time/gettod.c: Increased time results from sec to centi secs.
	* source/clib/stdlib.h (strtoll, strtoull): enable it for Norcroft
	  builds.
	* source/resolv/gethnamaddr.c(gethostbyname2): timeout in the resolver
	  requests will result in hosts file lookup.

Tue Apr 22 11:57:14 2003  Peter Naulls  <peter@chocky.org>
	* clib/stddef.h: Remove ptr_t.  Not defined in glibc, and
	  sometimes clashes in programs.
	* clib/unixlib/local.h: Fix typo.  Move stddef.h include -
	  size_t required by non UnixLib internal functions.

Mon Apr 21 16:48:12 2003  Peter Naulls  <peter@chocky.org>
	* source/Makefile: Added _longlong.s to SYS_ASM.
	* objs/Makefile,fe1: Add missing setsid, and _longlong.
	* source/sys/_longlong.s: Added (long long Norcroft helper routines,
	  from John Tytgat's addition)
	* source/unistd/getpass.c: define _GNU_SOURCE for getline().

Mon Apr 21 14:18:04 2003  Peter Naulls  <peter@chocky.org>
	* clib/unistd.h, resource/setsid.c: Dummy setsid implementation.
	* Makefile: prevent library being created 3 times.

Mon Apr 21 08:40:33 2003  Peter Naulls  <peter@chocky.org>
	* objs/Makefile,fe1: Change APCS flags to 32-bit
	* clib/unixlib/asm_dec.s: Extra definitions for 32-bit,
	  make networking macros 32-bit.
	* netlib/_accept.s, netlib/_getpeerna.s, netlib/_getsockna.s,
	  netlib/_recvfrom.s, netlib/_recvmsg.s, netlib/_sendmsg.s:
          Remove unused macro silliness
	* netlib/_net_error.s: 32-bit
	* netlib/serv.c: Fix typo
	* signal/_coredump.s, signal/_signal.s, signal/post.c:
	  32-bit, move much of the handling into C for ease of maintainence.
	* sys/_swi.s, sys/_syslib: 32-bit

Sat Apr 13 17:20:43 2003  Alex Waugh  <alex@alexwaugh.com>

	* clib/stdio.h: Thread safety patches.
	* stdio/clearerr.c: Likewise.
	* stdio/fclose.c: Likewise.
	* stdio/feof.c: Likewise.
	* stdio/ferror.c: Likewise.
	* stdio/fflush.c: Likewise.
	* stdio/fgets.c: Likewise.
	* stdio/filbuf.c: Likewise.
	* stdio/fileno.c: Likewise.
	* stdio/flsbuf.c: Likewise.
	* stdio/fopen.c: Likewise.
	* stdio/fpos.c: Likewise.
	* stdio/fputs.c: Likewise.
	* stdio/fread.c: Likewise.
	* stdio/freopen.c: Likewise.
	* stdio/fwrite.c: Likewise.
	* stdio/getc.c: Likewise.
	* stdio/getdelim.c: Likewise.
	* stdio/gets.c: Likewise.
	* stdio/getw.c: Likewise.
	* stdio/newstream.c: Likewise.
	* stdio/popen.c: Likewise.
	* stdio/printf.c: Likewise.
	* stdio/putc.c: Likewise.
	* stdio/puts.c: Likewise.
	* stdio/putw.c: Likewise.
	* stdio/rename.c: Likewise.
	* stdio/scanf.c: Likewise.
	* stdio/setbuf.c: Likewise.
	* stdio/tmpfile.c: Likewise.
	* stdio/ungetc.c: Likewise.
	* unistd/fchown.c: Likewise.

Sat Apr 12 12:32:53 2003  Alex Waugh  <alex@alexwaugh.com>

	* objs/Makefile,fe1: Add new file
	* Makefile: Likewise.
	* clib/sys/stat.h (__stat): Alter decl.
	* clib/unixlib/local.h (__object_get_attrs, __object_set_attrs):
	  Add decl.
	* clib/unixlib/swiparams.h: Add more OS_File parameters.
	* common/stat.c (__stat): Take named arguments rather than a
	  register list.
	* unix/chdir.c (chdir): Remove common code.
	* unix/chmod.c (chmod): Likewise.
	* unix/dev.c (__fsstat): Likewise.
	* unix/mkdir.c (mkdir): Likewise.
	* unix/rmdir.c (rmdir): Likewise.
	* unix/unlink.c (unlink): Likewise.
	* unix/utime.c (utime): Likewise.
	* common/objattr.c: New file containing common code for the above
	  files. Fix bug that could cause stat to return ENOENT for a file
	  where the filetype didn't match the extension mimetype lookup.

Mon Apr  7 21:09:46 2003  Alex Waugh  <alex@alexwaugh.com>

	* Makefile: Add -pedantic to assembly rule.
	* common/_riscosify.s: Add missing END directive.

Sun Apr  6 22:48:08 2003  John Tytgat  <John.Tytgat@aaug.net>

	* unix/dirent.c: Norcroft C breaks on an int64 switch argument
	  since __off_t has been changed to 64 bits.  Void'ing or using
	  the return parameter of __set_errno() to reduce warnings.
	* !MKDir: Removed, an up-to-date copy is MKDir.

Sun Apr  6 15:03:26 2003  Peter Naulls  <peter@chocky.org>

	* source/netlib/socketpair.c: socketpair() implementation
	* source/clib/regex.h, source/regex.c: regex implementation
	* source/Makefile: Add new files
	* source/clib/stdio.h: Add fseeko/ftello, wrap GNU only
	  functions up as per glibc.
	* source/stdio/fpos.c: fseeko/ftello implementation
	* source/clib/unixlib/unix.h: Add __32bit variable
	  reference (not implemented yet)
	* source/common/riscosify.c: Add hard/soft space mapping
	* source/module/sul.s: SharedUnixLibrary 1.02 update
	* source/unix/dev.c: Add ttyS0, add FIOASYNC (from 2.95.4 branch)
	* source/unix/tty.c: Check for ttyS0, and alias to rs423
	* source/clib/unixlib/types.h: Remove rouge +

Sun Apr  6 13:22:00 2003  Peter Naulls  <peter@chocky.org>

	* clib/swis.h: Include kernel.h, add new CDFS SWI.
	* clib/unixlib/types.h: LCC support, change __off_t to
	  64 bits for consistency with other types in UnixLib.
	  Minor tidying to UnixLibify.

Sun Apr  6 12:48:17 2003  Peter Naulls  <peter@chocky.org>

	* Help: Remove extra help file, and just use !Help

Sat Apr  6 11:54:16 2003  Alex Waugh  <alex@alexwaugh.com>

	* pthread.h (__pthread_running_threads): Renamed to
	  __pthread_num_running_threads.
	* pthread/context.c: Likewise.
	* pthread/create.c: Likewise.
	* pthread/exit.c: Likewise.
	* pthread/init.c: Likewise.
	* pthread/_context.s: Likewise, add missing IMPORT.

Sun Apr  6 01:00:57 2003  John Tytgat  <John.Tytgat@aaug.net>

	* source/clib/bits/netdb.h: Removed _gethostbyname() and
	  _gethostbyaddr() definition
	* source/netlib/_hostbyadd.s: Removed.
	* source/netlib/_hostbynam.s: Removed.
	* source/netlib/host.c: Removed.
	* source/Makefile: Removed _hostbyadd.o & _hostbynam.o from
	  NETLIB_ASM list.  Removed host.o from NETLIB list.
	* objs/Makefile: Likewise.
	* source/sys/_udiv10.s (_kernel_udiv10, __rt_udiv10): Made routine
	  2 instructions shorter.
	* source/sys/_sdiv10.s (_kernel_sdiv10, __rt_sdiv10): Likewise.

Sat Apr  5 13:41:35 2003  Alex Waugh  <alex@alexwaugh.com>

	* pthread.h (PTHREAD_INIT): Remove.
	* pthread/_context.s (__pthread_start_ticker): Don't start ticker if
	  there is only one thread running.
	* pthread/atfork.c (pthread_atfork): Remove unneeded initialisation.
	* pthread/cleanup.c (__pthread_cleanup_push): Likewise.
	(__pthread_cleanup_pop): Likewise.
	* pthread/cond.c (pthread_cond_timedwait): Likewise.
	* pthread/context.c (__pthread_running_threads): Change default to 1
	  running thread.
	* pthread/create.c (pthread_create): Start the ticker every time a
	  thread is created.
	* pthread/exit.c (pthread_exit): Stop the ticker if there is only one
	  thread left.
	* pthread/init.c (__pthread_init): Don't start the ticker on
	  initialisation.
	* pthread/join.c (pthread_join): Remove unneeded initialisation.
	* pthread/lock.c (__pthread_lock_lock, __pthread_lock_unlock): Likewise.
	* pthread/mutex.c (pthread_mutex_trylock, pthread_mutex_lock): Likewise.
	* pthread/rwlock.c (pthread_rwlock_rdlock, pthread_rwlock_wrlock,
	  pthread_rwlock_tryrdlock, pthread_rwlock_trywrlock): Likewise.
	* pthread/self.c (pthread_self): Likewise.

Sat Apr  5 13:14:30 2003  Alex Waugh  <alex@alexwaugh.com>

	Allow malloc or stack extention to increase the wimpslot.
	* Makefile: Compile sys/brk.c without stack checking.
	* alloc.c: Update to 2.7.2 of Doug Lea's malloc.
	* clib/unistd.h (brk, sbrk): add deprecated attribute.
	(__internal_sbrk): Add decl.
	* clib/unixlib/asm_dec.s (__4K_BOUNDARY): Remove.
	(XWimp_SlotSize): Add SWI number.
	* clib/unixlib/features.h (__4K_BOUNDARY): Remove.
	(__DA_WIMPSLOT_ALIGNMENT): Add.
	* clib/unixlib/unix.h (__real_himem): Add.
	(__stackalloc_incr_wimpslot): Add decl.
	* resource/initialise.c (__resource_initialise): Try to determine the
	  maximum possible wimpslot size.
	* sys/_exec.s (__exec_s3, __exlen): Remove __4K_BOUNDARY code.
	* sys/_syslib.s (__main): Remove __4K_BOUNDARY code, read current
	  wimpslot size on startup, move stackalloc initialisation to after
	  the environment handlers are setup, restore RISC OS environment
	  handlers on exit.
	(__env_riscos_and_wimpslot): New function.
	(__env_riscos): Don't alter wimpslot size.
	(__real_himem): Add.
	* sys/_vfork.s (return_parent): Remove debug code.
	* sys/brk.c (__internal_brk): Renamed from brk, try to increase
	  wimpslot if needed.
	(brk): Call __internal_brk
	(sbrk): Call __internal_brk
	(__internal_sbrk): New function.
	* sys/exec.c (__ushift, __dshift, execve): Cope with a non-contiguous
	  heap, remove __4K_BOUNDARY code, don't reread environment handlers.
	* sys/stackalloc.c (__stackalloc_incr_wimpslot): New function.
	(__stackalloc_incr_upwards): New function.
	(__stackalloc_incr_downwards): New function.
	(__stackalloc_incr): Remove function.
	(__stackalloc_init, __stackalloc): Allow a non-contiguous heap, and
	  wimpslot extension.
	* unix/unix.c (_exit): Don't restore RISC OS environment, now done in
	  _syslib.s instead.

Sat Apr  5 10:33:45 2003  Alex Waugh  <alex@alexwaugh.com>

	Thread safety patches
	* termios/ctermid.c: Changed.
	* termios/cuserid.c: Changed.
	* termios/tcgetattr.c: Changed.
	* time/asctime.c: Changed.
	* time/ctime.c: Changed.
	* time/setitmr.c: Changed.
	* time/stdtime.c: Changed.
	* time/tzset.c: Changed.
	* wchar/mbrlen.c: Changed.
	* wchar/mbrtowc.c: Changed.
	* wchar/wcrtomb.c: Changed.
	* unix/close.c: Changed.
	* unix/dirent.c (readdir_r): Fix return values
	(invalidate, newstream): Thready safety
	* unix/fchmod.c: Changed.
	* unix/fcntl.c: Changed.
	* unix/fstat.c: Changed.
	* unix/getcwd.c: Changed.
	* unix/getenv.c: Changed.
	* unix/gethostnam.c: Changed.
	* unix/getopt.c: Changed.
	* unix/ioctl.c: Changed.
	* unix/isatty.c: Changed.
	* unix/ispipe.c: Changed.
	* unix/lseek.c: Changed.
	* unix/open.c: Changed.
	* unix/pathconf.c: Changed.
	* unix/pipe.c: Changed.
	* unix/poll.c: Changed.
	* unix/proc.c: Changed.
	* unix/read.c: Changed.
	* unix/readv.c: Changed.
	* unix/reopen.c: Changed.
	* unix/select.c: Changed.
	* unix/setenv.c: Changed.
	* unix/stat.c: Changed.
	* unix/sync.c: Changed.
	* unix/syslog.c: Changed.
	* unix/truncate.c: Changed.
	* unix/tty.c: Changed.
	* unix/umask.c: Changed.
	* unix/unix.c: Changed.
	* unix/wait.c: Changed.
	* unix/wait4.c: Changed.
	* unix/write.c: Changed.
	* unix/writev.c: Changed.

Sat Apr  5 10:12:54 2003  Alex Waugh  <alex@alexwaugh.com>

	* sys/_syslib.s (free_stack_chunk): Preserve a2 as
	  it is used for returning 64bit results from functions

Fri Apr  4 22:51:24 2003  Alex Waugh  <alex@alexwaugh.com>

	* asm_dec.s (__set_errno, __get_errno): Revert back to using
	  global errno

Wed Jan 29 18:51:20 2003  John Tytgat  <John.Tytgat@aaug.net>

	* objs/Makefile: crypt rules had a spurious column chars at the end
	  of their lines
	* unix/dev.c (_randomread): cast 'data' ptr to int is necessary
	  for Norcroft.
	* math-asm/_atan.s: atan1 should be exported, not atanl.
	* stdint.h: Added #include <unixlib/features.h> for the
	  __extension__ definition
	* objs/Makefile: crypt rules did have a spurious column chars;
	  Removed netlib.o.htonl, netlib.o.htons, netlib.o.ntohl,
	  and netlib.o.ntohs from NETLIB_ASM list; Removed
	  netlib.o.inet_addr and netlib.o.inet_aton from NETLIB list;
	  Add Resolv src code; Added pthread.o.newnode to the PTHREAD
	  list; Add pthread.o._exit to the PTHREAD_ASM list
	* MKDir: Added cdir of objs.resolv and objs.resolv.o.
	* arpa/nameser.h: typo in the NS_PUT16() macro

Wed Jan 29 18:48:24 2003  Alex Waugh  <alex@alexwaugh.com>

	* unistd.h (__unlinksuffix): Add decl.
	* common/_exist.s (__isdir_raw): Change result according to
	setting of __feature_imagefs_is_file.
	* stdio/rename.c (rename): Delete file, then attempt to delete
	suffix directory if nothing else exists within it.
	* unix/dev.c (__fsclose): Likewise.
	* unix/unlink.c (__unlinksuffix): New function.
	(unlink): Account for setting of __feature_imagefs_is_file.

Wed Jan 29 18:43:32 2003  Alex Waugh  <alex@alexwaugh.com>

	* unix/dev.c (__randomopen): Attempt to load the CryptRandom
	module if it doesn't appear to be installed already.

Tue Jan 21 18:03:28 2003  Nick Burrett  <nick@dsvr.net>

	* grp.h (__grpread): Add buf and buflen arguments to prototype.
	* pwd.h (__pwdread): Likewise.

Tue Jan 21 17:56:18 2003  Alex Waugh  <alex@alexwaugh.com>

	Thread safety patches
	* common/fdname.c: Changed.
	* common/sockvalid.c: Changed.
	* common/uname.c: Changed.
	* locale/ctypetable.c: Changed.
	* locale/localeconv.c: Changed.
	* locale/setlocale.c: Changed.
	* math/lgamma.c: Changed.
	* stdlib/_rand48.c: Changed.
	* stdlib/erand48.c: Changed.
	* stdlib/jrand48.c: Changed.
	* stdlib/lcong48.c: Changed.
	* stdlib/lrand48.c: Changed.
	* stdlib/mrand48.c: Changed.
	* stdlib/nrand48.c: Changed.
	* stdlib/rand.c: Changed.
	* stdlib/random.c: Changed.
	* stdlib/seed48.c: Changed.
	* stdlib/srand48.c: Changed.
	* pwd/fgetpwent.c: Changed.
	* pwd/fgetpwentr.c: Changed.
	* pwd/getlogin.c: Changed.
	* pwd/getpwent.c: Changed.
	* pwd/getpwnam.c: Changed.
	* pwd/getpwnam_r.c: Changed.
	* pwd/getpwuid.c: Changed.
	* pwd/getpwuid_r.c: Changed.
	* pwd/pwdread.c: Changed.
	* resource/seteuid.c: Changed.
	* resource/setgid.c: Changed.
	* resource/setpgrp.c: Changed.
	* resource/setprior.c: Changed.
	* resource/setrlimit.c: Changed.
	* resource/setuid.c: Changed.
	* grp/fgetgrent.c: Changed.
	* grp/fgetgrentr.c: Changed.
	* grp/getgrent.c: Changed.
	* grp/getgrgid.c: Changed.
	* grp/getgrgid_r.c: Changed.
	* grp/getgrnam.c: Changed.
	* grp/getgrnam_r.c: Changed.
	* grp/getgroups.c: Changed.
	* grp/grpread.c: Changed.

Tue Jan 21 17:49:27 2003  Alex Waugh  <alex@alexwaugh.com>

	Provide /dev/random and /dev/zero emulation.
	* swis.h (CryptRandom_*): Add CryptRandom module SWIs.
	* unixlib/dev.h (DEV_ZERO): Add.
	(DEV_RANDOM): Add.
	(NDEV): Bump to 7.
	(struct dev): Add stat and fstat.
	(__getdevtype): Add prototype.
	(__fsstat): Add prototype.
	(__fsfstat): Add prototype.
	(__nullstat, __nullfstat, __zeroread, __randomopen): Likewise.
	(__randomread): Likewise.
	* unix/dev.c (__dev): Support new fields in struct dev.
	(struct sfile): New.
	(__sfile): New.
	(__getdevtype): New function.
	(__fsstat): New function.
	(__fsfstat): New function.
	(__nullstat): New function.
	(__nullfstat): New function.
	(__zeroread): New function.
	(__randomopen): New function.
	(__randomread): New function.
	* unix/fstat.c (fstat): Call fstat function from struct dev.
	* unix/open.c (struct file): Moved to unix/dev.c.
	(__sfile): Moved to unix/dev.c.
	* unix/stat.c (stat): Call stat function from struct dev.

Sun Jan  5 12:44:20 2003  Alex Waugh  <alex@alexwaugh.com>

	* common/riscosify.c:
	"./foo.c" now translates to "@.c.foo" rather than "c.foo"
	Better handling of . and .. at beginning and ends of filenames, and
	things like "./.."
	Removes ,xyz when the filename is just a leafname.
	Interprets ".svn/text-base/malloc.c.svn-base" as unix format
	not RISC OS format.

Sun Jan  5 12:41:31 2003  Alex Waugh  <alex@alexwaugh.com>

	Make UnixLib thread-safe.
	* abort.c (abort): Add PTHREAD_UNSAFE
	* assert.c (__assert_fail): Likewise.
	* atexit.c (atexit): Likewise.
	* qsort.c (qsort): Likewise.
	* strtod.c: LIkewise.
	* termcap.c (tgetent, t_tentcp, t_tgetln): Likewise.
	(t_tgetid, tgetstr, tgoto): Likewise.

	* strsignal.c (strsignal): Simplify.

Sun Jan  5 12:37:50 2003  Alex Waugh  <alex@alexwaugh.com>

	* errno.h: Always define 'errno' as errno.
	* errno.c: Remove conditional.
	* pthread/context.c (__pthread_context_switch): Preserve errno.

	* pthread.h (__pthread_saved_context): Add spsr.
	* pthread/_context.s: Store/restore the SPSR.

	* sys/_alloca.s: Various APCS-32 fixes.
	* sys/_syslib.s: Likewise.

	* sys/errlist.c: Include pthread.h.

Sun Jan  5 12:29:13 2003  Alex Waugh  <alex@alexwaugh.com>

	* sys/exec.c (execve): Change control characters to \xXX.
	Don't backslash already quoted characters.
	* unix/unix.c (__hexstrtochar): New function.

Sat Jan  4 15:27:54 2003  Nick Burrett  <nick@dsvr.net>

	* sys/_syslib.s: Revert last change.  The SCL doesn't preserve ip
	either, so the fix should be applied to GCC.

Mon Dec 30 12:05:21 2002  Nick Burrett  <nick@dsvr.net>

	* sys/_syslib.s (__rt_stkovf_split_small): Preserve 'ip'.
	(__rt_stkovf_split_big): Likewise.
	(stack_overflow_common): Restore 'ip'.

Sun Dec 22 18:21:18 2002  John Tytgat  <John.Tytgat@aaug.net>

	* MKDir: added resolv & resolv.o
	* objs/Makefile,fe1: Added resolv/*; Removed netlib.o.ntohl,
	  netlib.o.ntohs, netlib.o.inet_addr, netlib.o.inet_aton, unix.o.syslog
	  Renamed netlib.o.htonl to netlib.o._bswap_32, netlib.o.htons to
	  netlib.o._bswap_16; Added string.o.rawmemchar, string.o.strchrnul,
	  string.o.strndup, string.o.strnlen, string.o.swab, netlib.o.in6_addr.
	* source/Makefile: Likewise.
	* Makefile: added resolv

	* arpa/inet.h: Replaced by version in glibc 2.2.5
	* arpa/nameser.h: Replaced by version in glibc 2.2.5
	* arpa/nameser_compat.h: Added (glibc 2.2.5)
	* arpa/tftp.h: Added (glibc 2.2.5)

	* bits/in.h: Added (glibc 2.2.5)
	* bits/netdb.h: Added (glibc 2.2.5)
	* bits/sockaddr: Added (glibc 2.2.5)
	* bits/socket.h: Added (glibc 2.2.5)

	* byteswap.h: Added (glibc 2.2.5)
	* dirent.h: Changed __u_int32_t into __uint32_t
	* net/if.h: Replaced by version in glibc 2.2.5
	* netdb.h: Replaced by version in glibc 2.2.5
	* netinet/{in.h,in_systm.h,ip.h,ip_icmp.h,tcp.h,udp.h}:
	  Replaced by version in glibc 2.2.5
	* netinet/ip_var.h: Changed #include <sys/bytesorder.h> into
	  #include <netinet/in.h>.
	* resolv.h: Added (glibc 2.2.5)
	* resolv/resolv.h: Added (glibc 2.2.5)
	* stdio-common/stdio_ext.h: Added (glibc 2.2.5)
	* stdio_ext.h: Added (glibc 2.2.5)
	* stdint.h: When __int8_t_defined is defined, this does not
	  mean that uint8_t, uint16_t, uint32_t and uint64_t are defined (but
	  u_int8_t, u_int16_t, u_int32_t adn u_int64_t are defined).
	* string.h: Added GNU calls __rawmemchr(), strndup(),
	  strnlen() & strchrnul(); When __USE_BSD is defined, declare bcopy(),
	  bzero(), bcmp(), index(), rindex(), strcasecmp() and strncasecmp().
	* strings.h: Function calls are BSD functions calls so
	  wrapped them inside an #ifdef __USE_BSD.
	* string/byteswap.h: Added (glibc 2.2.5)
	* sys/bitypes.h: Added (glibc 2.2.5)
	* sys/byteorder.h: Removed (as htonl(), ntohl(), htons()
	  and ntohs() are defined in netinet/in.h).
	* sys/netdb.h: Removed (as the SWI veneers are now defined
	  in bits/netdb.h)
	* sys/sysmacros.h: Added (glibc 2.2.5)
	* sys/uio.h: Changed #include <unixlib/types.h> into
	  #include <sys/types.h> so that return types of readv() and writev()
	  are a defined ssize_t (was previously the internal type __ssize_t).
	* swis.h: Added Internet 5 new SWIs.
	* unixlib/asm_dec.s: Added COMPAT_INET4 (default off),
	  added Internet 5 new SWIs.
	* unixlib/features.h: Added more #define's for Norcroft C
	  compiler; Removed all sections which are also defined in
	  misc/sys/cdefs.h;
	  Defined BSD; Added #undef COMPAT_INET4
	* unixlib/math.h: Changed __u_int32_t into __uint32_t
	* unixlib/types.h: Replaced by version in glibc 2.2.5
	* sys/cdefs.h: Added (glibc 2.2.5)
	* sys/select.h: 5th param pselect() is 'const struct
	  timespec *', not 'struct timespec'.  Was also missing 6th param
	  'const __sigset *'.
	* math/acosh.c: Changed __u_int32_t into __uint32_t.
	* math/atanh.c: Likewise.
	* math/cbrt.c: Likewise.
	* math/erf.c: Likewise.
	* math/exprm1.c: Likewise.
	* math/fmod.c: Likewise.
	* math/fpclassify.c: Likewise.
	* math/jn.c: Likewise.
	* math/llrint.c: Likewise.
	* math/llround.c: Likewise.
	* math/log2.c: Likewise.
	* math/lrint.c: Likewise.
	* math/lround.c: Likewise.
	* math/modf.c: Likewise.
	* math/nearbyint.c: Likewise.
	* math/nextafter.c: Likewise.
	* math/remainder.c: Likewise.
	* math/remquo.c: Likewise.
	* math/rem_pio2.c: Likewise.
	* math/rint.c: Likewise.
	* math/round.c: Likewise.
	* math/trunc.c: Likewise.
	* misc/sys/cdefs.h: Added (glibc 2.2.5)
	* misc/sys/socket.h: Replaced by version in glibc 2.2.5
	* misc/sys/types.h: Replaced by version in glibc 2.2.5
	* netlib/accept.c: Type of last parameter of accept() is
	  socklen_t *, not int *.
	* netlib/bind.c: Type of last parameter of bind() is socklen_t,
	  not int. Removed commented out debug line.
	* netlib/connect.c: Type of last parameter of connect() is
	  socklen_t, not int. Removed commented out debug line.
	* netlib/getpeernam.c: Type of last parameter of getpeernam()
	  is socklen_t *, not int *.
	* netlib/getsocknam.c: Type of last parameter of getsocknam()
	  is socklen_t *, not int *.
	* netlib/getsockopt.c: Type of last parameter of getsockopt()
	  is socklen_t *, not int *.
	* netlib/host.c: Return types of sethostent() end endhostent()
	  are void, not int; First 2 parameters of gethostbyaddr() are const
	  void * and socklen_t, not const char * and int.
	* netlib/in6_addr.c: Added (glibc 2.2.5)
	* netlib/inet_addr.c: Removed (new code at resolv/inet_addr.c)
	* netlib/inet_aton.c: Likewise.
	* netlib/inet_lnaof.c: Return type of inet_lnaof() is in_addr_t,
	  not u_long.
	* netlib/inet_netof.c: Return type of inet_netof() is in_addr_t,
	  not u_long.
	* netlib/inet_netwo.c: Removed #include <sys/byteorder.h>;
	  Return type of inet_network() is in_addr_t, not u_long.
	* netlib/inet_mkad.c: Both parameters of inet_makeaddr() are
	  in_addr_t, not u_long.
	* netlib/net.c: Return type of setnetent() and endnetent() is
	  void, not int.  First parameter of getnetbyaddr() is uint32_t, not
	  long.
	* netlib/ntohl.s (ntohl): Removed (is implemented as
	   __bswap_32())
	* netlib/ntohs.s (ntohs): Removed (is implemented as
	   __bswap_16())
	* netlib/ntop.c: Removed #include <sys/byteorder.h>
	* netlib/proto.c: Return type of setprotoent() and endprotoent()
	  is void, not int.
	* netlib/pton.c: Removed #include <sys/byteorder.h>
	* netlib/recv.c (recv): Third parameter of recv() is
	  size_t (unsigned int), not int.
	* netlib/recvfrom.c (recvfrom): Type of third and last parameter
	  of recvfrom() is size_t and socklen_t (unsigned int) respectively,
	  not int and int.
	* netlib/send.c (send): Type of third parameter of send() is
	  size_t, not int.
	* netlib/sendto.c (sendto): Type of third and last parameter of
	  sendto() is size_t and socklen_t (unsigned int) respectively, not int
	  and int.
	* netlib/serv.c: Removed #include <sys/byteorder.h>; Return type
	  of the setservent() and endservent() routines is void, not int.
	* netlib/setsockopt.c (setsockopt): Last parameter of
	  setsockopt() is socklen_t (unsigned int), not int.
	* netlib/socket.c: Changed #include <sys/netdb.h> into #include
	  <netdb.h>
	* netlib/_accept.s: Added check for COMPAT_INET4.
	* netlib/_recvfrom.s: Likewise.
	* netlib/_recvmsg.s: Likewise.
	* netlib/_sendmsg.s: Likewise.
	* netlib/_getpeername.s: Likewise.
	* netlib/_getsockname.s: Likewise.
	* netlib/_bswap_32.s (__bswap_32): Added (was the htonl.s
	  implementation)
	* netlib/_bswap_16.s (__bswap_16): Added (was the htons.s
	  implementation)
	* opensock.c: Added (glibc 2.2.5)
	* string/strchrnul.c: Added (glibc 2.2.5)
	* string/strndup.c: Added (glibc 2.2.5)
	* string/swab.c: Added (glibc 2.2.5)
	* strsignal.c (strsignal): Changed return type to 'char *'.
	* unix/dev.c: Changed #include <sys/netdb.h> into #include
	  <netdb.h>
	* unix/fcntl.c: Likewise.
	* unix/pselect.c (pselect): Parameters were wrong.  Based
	  implementation on glibc 2.2.5.

Sun Dec 15 13:35:02 2002  Alex Waugh  <alex.waugh@arm.com>

	* common/riscosify.c: Re-write.

Sun Dec 15 13:15:39 2002  Alex Waugh  <alex.waugh@arm.com>

	POSIX threads and Stack Chunk implementation.

Fri Dec 13 11:07:21 2002  Nick Burrett  <nick@dsvr.net>

	* time.h (localtime_r): Declare.
	(gmtime_r): Declare.
	(__calendar_convert): Fixup prototype.
	* calendconv.c (__calendar_convert): Make re-entrant.
	* gmtime.c (gmtime): Fixup call to support new re-entrant version
	of `__calendar_convert'.
	* localtime.c (localtime): Likewise.
	* localtime_r.c: New file.
	* gmtime_r.c: New file.

	* errno.h (__set_errno): Add __UNIXLIB_INTERNALS guard.  This macro
	shouldn't be exposed outside of UnixLib.

Wed Nov 27 19:00:00 2002  Nick Burrett  <nick@dsvr.net>

	64-bit placeholders
	* unixlib/types.h (__off64_t): Declare.
	(__fpos64_t): Declare.
	* sys/types.h: Define __off64_t, if not defined.
	* sys/stat.h (stat64): Define as 'stat'.

Tue Nov 26 21:46:52 2002  Nick Burrett  <nick@dsvr.net>

	C99 dialect functions.
	* stdlib/strtof.c: New file.
	* stdlib/strtold.c: New file.
	
	32-bit float type C99 dialect math functions.
	* math/fmodf.c: New file.
	* math/frexpf.c: New file.
	* math/modff.c: New file.
	* math/_asinf.s: New file.
	* math/_acosf.s: New file.
	* math/_atan2f.s: New file.
	* math/_atanf.s: New file.
	* math/_ceilf.s: New file.
	* math/_cosf.s: New file.
	* math/_coshf.s: New file.
	* math/_expf.s: New file.
	* math/_floorf.s: New file.
	* math/_ldexpf.s: New file.
	* math/_log10f.s: New file.
	* math/_logf.s: New file.
	* math/_modf1f.s: New file.
	* math/_powf.s: New file.
	* math/_sinf.s: New file.
	* math/_sinhf.s: New file.
	* math/_tanf.s: New file.
	* math/_tanhf.s: New file.
	
	* math/fmod.c: Suport long double float type C99 math functions.
	* math/frexp.c: Likewise.
	* math/modf.c: Likewise.
	* math/_asin.s: Likewise.
	* math/_acos.s: Likewise.
	* math/_atan2.s: Likewise.
	* math/_atan.s: Likewise.
	* math/_ceil.s: Likewise.
	* math/_cos.s: Likewise.
	* math/_cosh.s: Likewise.
	* math/_exp.s: Likewise.
	* math/_floor.s: Likewise.
	* math/_ldexp.s: Likewise.
	* math/_log10.s: Likewise.
	* math/_log.s: Likewise.
	* math/_modf1.s: Likewise.
	* math/_pow.s: Likewise.
	* math/_sin.s: Likewise.
	* math/_sinh.s: Likewise.
	* math/_tan.s: Likewise.
	* math/_tanh.s: Likewise.

	* math.h: Create prototypes for `float' and `long double' functions.

	* strtol.c (atol): Remove explicit casts.
	* strtoll.c (atoll): New function.

	* unix/unix.c (_Exit): New function.
	(exit): Split into _Exit.  Call atexit functions here, then
	call _Exit to perform the final termination code.
	
	* stdlib.h (_Exit): New prototype.
	(atoll): New prototype.
	(strtof): New prototype.
	(strtold): New prototype.

Wed Nov 13 11:58:00 2002  Peter Naulls  <peter@chocky.org>

	* sys/socket.h (bind): Correct prototype.
	(accept, connect, recvfrom, getsockname, getpeername): Likewise.
	(_bind, _accept, _connect, _recvfrom, _getsockname): Likewise.
	(_getpeername): Likewise.
	* netlib/accept.c: Likewise.
	* netlib/bind.c: Likewise.
	* netlib/connect.c: Likewise.
	* netlib/getsocknam.c: Likewise.
	* netlib/getsockopt.c: Likewise.
	* netlib/recvfrom.c: Likewise.
	* netlib/setsockopt.c: Likewise.

	* stdio/popen.c (pclose): Correct type usage.
	* sys/execl.c (execl): Likewise.

	* unix/dev.c (__piperead): Fix pipe code to actually work.
	(__pipewrite): Don't seek on pipes.
	(__pipeselect): Likewise.
	* unix/pipe.c (pipe): Put temporary pipe files into /tmp/pipe.

	* unix/select.c (select): Fix broken comparison.

	* unix/tty.c (__tty_console_gwinsz): Change variable naming
	to better suit terminal handling.

Wed Nov 13 10:55:36 2002  Stefan Bellon  <sbellon@sbellon.de>

	* stdint.h: Norcroft version 5.50 supports long long.

	* stdio/_printf.s (_vprintf, _snprintf): New functions.
	(_vsprintf, _vsnprintf): New Norcroft compatibility functions.

Mon Oct 21 22:12:25 2002  Alex Waugh  <alex.waugh@arm.com>

	* sys/exec.c (execve): Allow a null argument list.

	* stdio/printf.c (vfprintfsub): When the buffer isn't large enough,
	return the number of characters that would be written had the
	buffer been big enough.

Mon Oct 21 21:53:21 2002  Peter Naulls  <peter@chocky.org>

	* sys/_syslib.s (__main): Move ENTRY after NAME.
	* common/riscosify.c (__riscosify): Don't default to filetype text
	if there is an error.

Sat Sep 28 16:00:00 2002  Peter Naulls  <peter@chocky.org>

	* unix/unix.c (convert_command_line): Fix argument could error
	when faced with arguments like "2> stderr".

Tue Sep 24 14:32:56 2002  Nick Burrett  <nick@dsvr.net>

	* sys/exec.c (execve): Make 2nd and 3rd param char *const [].
	* sys/execv.c (execv): Make 2nd param char *const [].
	* sys/execvp.c (execvp): Likewise.
	* unistd.h (execv, execve, execvp): Fix prototypes accordingly.

Tue Sep 24 13:08:36 2002  Nick Burrett  <nick@dsvr.net>

	* strsignal.c (strsignal): Return a char *, not const char *.
	* string.h (strsignal): Fix prototype.

Tue Sep 24 13:03:52 2002  Nick Burrett  <nick@dsvr.net>

	* sys/exec.c (execve): Make 3rd param char *const *.
	* sys/execv.c (execv): Make 2nd param char *const *.
	* unistd.h (execv, execve): Fix prototypes accordingly.

Tue Sep 24 13:00:22 2002  Nick Burrett  <nick@dsvr.net>

	* unix/proc.c (setegid): Set errno to EPERM on failure.

Tue Sep 24 12:50:37 2002  John Tytgat  <John.Tytgat@aaug.net>

	* strsignal.c (strsignal): strsignal(NSIG) wasn't detected
	as an error.
	* signal.h (sys_siglist): const'ify
	* signal/signame.c (sys_siglist):  Likewise.
	* signal/_signal.s (__h_error): Using the NAME macro.
	* sys/_alloca.s (alloca): Added some comments how this
	works; Added APCS-32 compatibility.
	* sys/_sigjmp.s (sigsetjmp): No need to save a2 & ip.

Tue Sep 24 12:28:40 2002  Peter Naulls  <peter@chocky.org>

	* netinet/in.h (struct ip_opts): Rename ip_opts to Ip_opts to
	workaround C++ incompatibility.

	* alloc.c (mmap_chunk): Fix alignment warning.
	* strcmp.c (strcmp): Retain type consistency.
	* netdb.h (gethostbyname2): Add prototype.
	* common/riscosify.c (__riscosify): Fix signed/unsigned comparison.
	* math/expm1.c (expm1): Fix warnings about uninitialised variables.
	* stdio/scanf.c (vfscanf): Fix function type usage.
	* stdio/tmpfile.c (generate_temporary_filename): Fix type consistency.
	* sys/exec.c (execve): Avoid alignment warning.

Mon Aug 19 12:50:40 2002  John Tytgat  <John.Tytgat@aaug.net>

	* objs/Makefile,fe1: module 'string' dependency was wrong; Made
	Norcroft C compiler selection the default.
	* unistd.h: Added missing #endif to fix 18-Aug-2002 19:32:36 change.
	
Sun Aug 18 22:19:01 2002  John Tytgat  <John.Tytgat@aaug.net>

	crypt implementation -- derived from glibc 2.2.5.
	* MKDir: Creating crypt & crypt.o directories.
	* objs/Makefile,fe1: Added crypt/*; Removed o.fcrypt.
	* source/Makefile: Likewise.
	* fcrypt.h: Replaced by a #include <crypt.h>.
	* stdint.h: Added long long equivalents for Norcroft C.
	* unixlib/features.h: Added __const, __THROW definitions
	for Norcroft C.
	* fcrypt.c: Remove
	* crypt.h: New file (from glibc 2.2.5)
	* crypt/crypt.c: New file.
	* crypt/crypt-entry.c: New file.
	* crypt/crypt_util.c: New file.
	* crypt/crypt-private.h: New file.
	* crypt/ufc-crypt.h: New file.
	* crypt/md5.c: New file.
	* crypt/md5-crypt.c: New file.
	* crypt/md5.h: New file.
	
Sun Aug 18 20:54:03 2002  John Tytgat  <John.Tytgat@aaug.net>
			  Nick Burrett  <nick@dsvr.net>

	Implement __riscosify_control as a WEAK variable.
	* common/_riscosify.s: New file.
	* unixlib/local.h (__get_riscosify_control): Add prototype.
	* common/riscosify.c (__riscosify_std): Use `__get_riscosify_control'
	rather than `__riscosify_control'.
	* common/unixify.c (__unixify_std): Likewise.
	* unix/dev.c (__fsopen): Likewise.
	* unix/dirent.c (opendir): Likewise.
	(readdir_r): Likewise.
	(rewinddir): Likewise.
	
Sun Aug 18 19:32:36 2002  Nick Burrett  <nick@dsvr.net>

	* string/swab.c: New file.
	* unistd.h (swab): Add prototype.

Sun Aug 18 16:15:25 2002  Nick Burrett  <nick@dsvr.net>

	[ BUG 51 ]
	* All header files: Include <unixlib/features.h>.  Use __BEGIN_DECLS
	and __END_DECLS for the extern "C" decls.
	* unix/tty.c (_BSD_SOURCE): Declare.
	
Sat Aug 17 13:58:36 2002  Nick Burrett  <nick@dsvr.net>

	* unix/fstat.c (fstat): Fix bad cast.

Sat Aug 17 12:02:23 2002  Nick Burrett  <nick@dsvr.net>

	* netlib/h_errno.c (h_errno): Change type to int. Include netdb.h.

Sat Aug 17 11:59:58 2002  Nick Burrett  <nick@dsvr.net>

	* netdb.h (h_errno): Declare.
	
Sat Aug 17 11:58:29 2002  Alex Waugh  <alex@alexwaugh.com>

	* unix/fstat.c (fstat): Return true extent, rather than file
	allocation size.

Sat Aug 17 11:51:39 2002  Peter Naulls  <peter@chocky.org>

	* unixlib/local.h (__RISCOSIFY_FILETYPE_SET): New macro.
	(__RISCOSIFY_MASK): Alter accordingly.
	* common/riscosify.c (__riscosify): Use the MimeMap module
	to match the filename extension and set the filetype appropriately.
	* unix/features.c (__runtime_features): Set riscosify default
	to setting the filetype.
	* unixlib/swiparams.h (MMM_TYPE_RISCOS): Define.
	(MMM_TYPE_RISCOS_STRING): Define.
	(MMM_TYPE_MIME): Define.
	(MMM_TYPE_DOT_EXTN): Define.
	* swis.h (MimeMap_Translate): Define.

Mon Aug  5 10:15:40 2002  Peter Naulls  <peter@chocky.org>

	* netlib/_net_error.s (__net_error_simple_entry): Add branch
	to jump over recent NAME entry.

	* netlib/connect.c (connect): Update debugging code.
	
Mon Aug  5 10:09:40 2002  Nick Burrett  <nick@dsvr.net>

	* unix/unix.c (verify_redirection): A space is not permitted between
	a file descriptor number and a redirection operator.

Mon Aug  5 10:07:11 2002  Peter Naulls  <peter@chocky.org>

	* pwd/pwdread.c (__pwddefault): Fix logic inversion of pwd_inited
	comparison.

	* unix/fcntl.c (fcntl): Third argument to _sioctl is an address to
	an argument.
	
Wed Jul 31 15:16:14 2002  Nick Burrett  <nick@dsvr.net>

	* unix/unix.c (check_io_redir): Cope with [fd]>>.
	(get_io_redir): Likewise.
	
Fri Jul 26 13:32:38 2002  Nick Burrett  <nick@dsvr.net>

	* stdint.h: Add missing #endif
	* net/if.h: Set __NET_IF_H rather than __SYS_IF_H.

Fri Jul 26 11:00:15 2002  Nick Burrett  <nick@dsvr.net>

	* stdio/fpos.c (fseek): Set errno to EINVAL if the offset to
	SEEK_SET is negative, but don't set the stream error.
	
Fri Jul 26 10:47:36 2002  Nick Burrett  <nick@dsvr.net>

	* sys/_vfork.s (vfork): No need to save sp around __vfork call.
	I think it is legacy from the old __vfork implementation.

Fri Jul 26 10:41:47 2002  Peter Naulls  <peter@chocky.org>
			  Nick Burrett  <nick@dsvr.net>

	* common/stat.c (__stat): If ImageFS is to be treated as a
	directory, then fudge directory size and set hard links to 2.
	Otherwise don't fudge directory size and set hard links to 1.
	
Fri Jul 26 10:35:30 2002  Alex Waugh  <alex@alexwaugh.com>

	* unix/fcntl.c (fcntl): When F_SETFL is called on a socket,
	actually alter the behaviour of the socket.

Fri Jul 19 14:19:48 2002  John Tytgat  <John.Tytgat@aaug.net>

	* index.c: #include <strings.h> so that we have header file
	declaration all exported functions.

Fri Jul 19 14:18:33 2002  John Tytgat  <John.Tytgat@aaug.net>

	* objs/Makefile,fe1: Fixed typo in the Norcroft compiler settings

Fri Jul 19 14:16:30 2002  John Tytgat  <John.Tytgat@aaug.net>

	* stdlib/_rand48.c, drand48.c, erand48.c, jrand48.c, lcong48.c
          lrand48.c, mrand48.c, nrand48.c, random.c, seed48.c
          srand48.c: Added RCS style comment header
	* sys/vfork.c (__vfork): The last environment and argument
	  vector needs to be NULL.

Fri Jul 19 14:13:45 2002  John Tytgat  <John.Tytgat@aaug.net>

	* objs/Makefile,fe1: Removed o.rand
	* scl/_kernel.s: declared AREA readonly. Updated comments.
	* common/_exist.s: Embedding function names
	* gcccompat/_divdi3.s, _moddi3.s, _udivdi3.s, _umoddi3.s:
	  Likewise.
	* math-asm/_acos.s, _asin.s, _atan.s, _atan2.s, _ceil.s
	  _copysign.s, _cos.s, _cosh.s, _exp.s, _fabs.s, _fclrexcpt.s
	  _fegetenv.s, _fegetrnd.s, _feholdexc.s, _fesetenv.s, _fesetroun.s
	  _finite.s, _floor.s, _fraiseexc.s, _fsetexcpt.s, _ftstexcpt.s
	  _hypot.s, _isinf.s, _isnan.s, _ldexp.s, _log.s, _log10.s, _modf1.s
	  _pow.s, _signbit.s, _sin.s, _sincos.s, _sinh.s, _sqrt.s, _tan.s
	  _tanh.s: Likewise.
	* netlib/_accept.s, _bind.s, _connect.s, _getpeerna.s
	  _getsockna.s, _getsockop.s, _gettsize.s, _hostbyadd.s, _hostbynam.s
	  _listen.s, _net_error.s, _readv.s, _recv.s, _recvfrom.s, _recvmsg.s
	  _sclose.s, _select.s, _send.s, _sendmsg.s, _sendto.s, _sendtosm.s
	  _setsockop.s, _shutdown.s, _sioctl.s, _socket.s, _sockstat.s
	  _sread.s, _swrite.s, _writev.s, htonl.s, htons.s, ntohl.s
	  ntohs.s: Likewise.
	* scl/_kcurskch.s, _kernel.s, _kgetenv.s, _kosargs.s
	  _kosbget.s, _kosbput.s, _kosbyte.s, _koscli.s, _kosfile.s
	  _kosfind.s, _kosgbpb.s, _kosrdch.s, _kosword.s, _koswrch.s
	  _ksetenv.s, _kswi_c.s: Likewise.
	* signal/_coredump.s, _signal.s, sigexec.s, printf.s:
	  Likewise.
	* sys/_alloca.s, _divsi3.s, _divtest.s, _jmp.s, _mem.s
